/* A Bison parser, made by GNU Bison 3.7.3.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2020 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.7.3"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         parser_parse
#define yylex           parser_lex
#define yyerror         parser_error
#define yydebug         parser_debug
#define yynerrs         parser_nerrs
#define yylval          parser_lval
#define yychar          parser_char

/* First part of user prologue.  */
#line 1 "tools/widl/parser.y"

/*
 * IDL Compiler
 *
 * Copyright 2002 Ove Kaaven
 * Copyright 2006-2008 Robert Shearman
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
 */

#include "config.h"

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <assert.h>
#include <ctype.h>
#include <string.h>

#include "widl.h"
#include "utils.h"
#include "parser.h"
#include "header.h"
#include "typelib.h"
#include "typegen.h"
#include "expr.h"
#include "typetree.h"

typedef struct list typelist_t;
struct typenode {
  type_t *type;
  struct list entry;
};

struct _import_t
{
  char *name;
  int import_performed;
};

static str_list_t *append_str(str_list_t *list, char *str);
static attr_list_t *append_attr(attr_list_t *list, attr_t *attr);
static attr_list_t *append_attr_list(attr_list_t *new_list, attr_list_t *old_list);
static decl_spec_t *make_decl_spec(type_t *type, decl_spec_t *left, decl_spec_t *right,
        enum storage_class stgclass, enum type_qualifier qual, enum function_specifier func_specifier);
static attr_t *make_attr(enum attr_type type);
static attr_t *make_attrv(enum attr_type type, unsigned int val);
static attr_t *make_attrp(enum attr_type type, void *val);
static attr_t *make_custom_attr(UUID *id, expr_t *pval);
static expr_list_t *append_expr(expr_list_t *list, expr_t *expr);
static var_t *declare_var(attr_list_t *attrs, decl_spec_t *decl_spec, declarator_t *decl, int top);
static var_list_t *set_var_types(attr_list_t *attrs, decl_spec_t *decl_spec, declarator_list_t *decls);
static ifref_list_t *append_ifref(ifref_list_t *list, ifref_t *iface);
static ifref_t *make_ifref(type_t *iface);
static var_list_t *append_var_list(var_list_t *list, var_list_t *vars);
static declarator_list_t *append_declarator(declarator_list_t *list, declarator_t *p);
static declarator_t *make_declarator(var_t *var);
static type_t *make_safearray(type_t *type);
static typelib_t *make_library(const char *name, const attr_list_t *attrs);
static void append_array(declarator_t *decl, expr_t *expr);
static void append_chain_type(declarator_t *decl, type_t *type, enum type_qualifier qual);
static void append_chain_callconv(type_t *chain, char *callconv);
static warning_list_t *append_warning(warning_list_t *, int);

static type_t *reg_typedefs(decl_spec_t *decl_spec, var_list_t *names, attr_list_t *attrs);
static type_t *find_type_or_error(const char *name, int t);
static type_t *find_type_or_error2(char *name, int t);

static var_t *reg_const(var_t *var);

static void push_namespace(const char *name);
static void pop_namespace(const char *name);
static void init_lookup_namespace(const char *name);
static void push_lookup_namespace(const char *name);

static void check_arg_attrs(const var_t *arg);
static void check_statements(const statement_list_t *stmts, int is_inside_library);
static void check_all_user_types(const statement_list_t *stmts);
static attr_list_t *check_iface_attrs(const char *name, attr_list_t *attrs);
static attr_list_t *check_function_attrs(const char *name, attr_list_t *attrs);
static attr_list_t *check_typedef_attrs(attr_list_t *attrs);
static attr_list_t *check_enum_attrs(attr_list_t *attrs);
static attr_list_t *check_enum_member_attrs(attr_list_t *attrs);
static attr_list_t *check_struct_attrs(attr_list_t *attrs);
static attr_list_t *check_union_attrs(attr_list_t *attrs);
static attr_list_t *check_field_attrs(const char *name, attr_list_t *attrs);
static attr_list_t *check_library_attrs(const char *name, attr_list_t *attrs);
static attr_list_t *check_dispiface_attrs(const char *name, attr_list_t *attrs);
static attr_list_t *check_module_attrs(const char *name, attr_list_t *attrs);
static attr_list_t *check_coclass_attrs(const char *name, attr_list_t *attrs);
const char *get_attr_display_name(enum attr_type type);
static void add_explicit_handle_if_necessary(const type_t *iface, var_t *func);
static void check_def(const type_t *t);

static void check_async_uuid(type_t *iface);

static statement_t *make_statement(enum statement_type type);
static statement_t *make_statement_type_decl(type_t *type);
static statement_t *make_statement_reference(type_t *type);
static statement_t *make_statement_declaration(var_t *var);
static statement_t *make_statement_library(typelib_t *typelib);
static statement_t *make_statement_pragma(const char *str);
static statement_t *make_statement_cppquote(const char *str);
static statement_t *make_statement_importlib(const char *str);
static statement_t *make_statement_module(type_t *type);
static statement_t *make_statement_typedef(var_list_t *names, int declonly);
static statement_t *make_statement_import(const char *str);
static statement_list_t *append_statement(statement_list_t *list, statement_t *stmt);
static statement_list_t *append_statements(statement_list_t *, statement_list_t *);
static attr_list_t *append_attribs(attr_list_t *, attr_list_t *);

static struct namespace global_namespace = {
    NULL, NULL, LIST_INIT(global_namespace.entry), LIST_INIT(global_namespace.children)
};

static struct namespace *current_namespace = &global_namespace;
static struct namespace *lookup_namespace = &global_namespace;

static typelib_t *current_typelib;


#line 212 "tools/widl/parser.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif


/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int parser_debug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    aIDENTIFIER = 258,             /* aIDENTIFIER  */
    aPRAGMA = 259,                 /* aPRAGMA  */
    aKNOWNTYPE = 260,              /* aKNOWNTYPE  */
    aNAMESPACE = 261,              /* aNAMESPACE  */
    aNUM = 262,                    /* aNUM  */
    aHEXNUM = 263,                 /* aHEXNUM  */
    aDOUBLE = 264,                 /* aDOUBLE  */
    aSTRING = 265,                 /* aSTRING  */
    aWSTRING = 266,                /* aWSTRING  */
    aSQSTRING = 267,               /* aSQSTRING  */
    aUUID = 268,                   /* aUUID  */
    aEOF = 269,                    /* aEOF  */
    aACF = 270,                    /* aACF  */
    SHL = 271,                     /* SHL  */
    SHR = 272,                     /* SHR  */
    MEMBERPTR = 273,               /* MEMBERPTR  */
    EQUALITY = 274,                /* EQUALITY  */
    INEQUALITY = 275,              /* INEQUALITY  */
    GREATEREQUAL = 276,            /* GREATEREQUAL  */
    LESSEQUAL = 277,               /* LESSEQUAL  */
    LOGICALOR = 278,               /* LOGICALOR  */
    LOGICALAND = 279,              /* LOGICALAND  */
    ELLIPSIS = 280,                /* ELLIPSIS  */
    tAGGREGATABLE = 281,           /* tAGGREGATABLE  */
    tALLNODES = 282,               /* tALLNODES  */
    tALLOCATE = 283,               /* tALLOCATE  */
    tANNOTATION = 284,             /* tANNOTATION  */
    tAPPOBJECT = 285,              /* tAPPOBJECT  */
    tASYNC = 286,                  /* tASYNC  */
    tASYNCUUID = 287,              /* tASYNCUUID  */
    tAUTOHANDLE = 288,             /* tAUTOHANDLE  */
    tBINDABLE = 289,               /* tBINDABLE  */
    tBOOLEAN = 290,                /* tBOOLEAN  */
    tBROADCAST = 291,              /* tBROADCAST  */
    tBYTE = 292,                   /* tBYTE  */
    tBYTECOUNT = 293,              /* tBYTECOUNT  */
    tCALLAS = 294,                 /* tCALLAS  */
    tCALLBACK = 295,               /* tCALLBACK  */
    tCASE = 296,                   /* tCASE  */
    tCDECL = 297,                  /* tCDECL  */
    tCHAR = 298,                   /* tCHAR  */
    tCOCLASS = 299,                /* tCOCLASS  */
    tCODE = 300,                   /* tCODE  */
    tCOMMSTATUS = 301,             /* tCOMMSTATUS  */
    tCONST = 302,                  /* tCONST  */
    tCONTEXTHANDLE = 303,          /* tCONTEXTHANDLE  */
    tCONTEXTHANDLENOSERIALIZE = 304, /* tCONTEXTHANDLENOSERIALIZE  */
    tCONTEXTHANDLESERIALIZE = 305, /* tCONTEXTHANDLESERIALIZE  */
    tCONTROL = 306,                /* tCONTROL  */
    tCPPQUOTE = 307,               /* tCPPQUOTE  */
    tCUSTOM = 308,                 /* tCUSTOM  */
    tDECODE = 309,                 /* tDECODE  */
    tDEFAULT = 310,                /* tDEFAULT  */
    tDEFAULTBIND = 311,            /* tDEFAULTBIND  */
    tDEFAULTCOLLELEM = 312,        /* tDEFAULTCOLLELEM  */
    tDEFAULTVALUE = 313,           /* tDEFAULTVALUE  */
    tDEFAULTVTABLE = 314,          /* tDEFAULTVTABLE  */
    tDISABLECONSISTENCYCHECK = 315, /* tDISABLECONSISTENCYCHECK  */
    tDISPLAYBIND = 316,            /* tDISPLAYBIND  */
    tDISPINTERFACE = 317,          /* tDISPINTERFACE  */
    tDLLNAME = 318,                /* tDLLNAME  */
    tDONTFREE = 319,               /* tDONTFREE  */
    tDOUBLE = 320,                 /* tDOUBLE  */
    tDUAL = 321,                   /* tDUAL  */
    tENABLEALLOCATE = 322,         /* tENABLEALLOCATE  */
    tENCODE = 323,                 /* tENCODE  */
    tENDPOINT = 324,               /* tENDPOINT  */
    tENTRY = 325,                  /* tENTRY  */
    tENUM = 326,                   /* tENUM  */
    tERRORSTATUST = 327,           /* tERRORSTATUST  */
    tEXPLICITHANDLE = 328,         /* tEXPLICITHANDLE  */
    tEXTERN = 329,                 /* tEXTERN  */
    tFALSE = 330,                  /* tFALSE  */
    tFASTCALL = 331,               /* tFASTCALL  */
    tFAULTSTATUS = 332,            /* tFAULTSTATUS  */
    tFLOAT = 333,                  /* tFLOAT  */
    tFORCEALLOCATE = 334,          /* tFORCEALLOCATE  */
    tHANDLE = 335,                 /* tHANDLE  */
    tHANDLET = 336,                /* tHANDLET  */
    tHELPCONTEXT = 337,            /* tHELPCONTEXT  */
    tHELPFILE = 338,               /* tHELPFILE  */
    tHELPSTRING = 339,             /* tHELPSTRING  */
    tHELPSTRINGCONTEXT = 340,      /* tHELPSTRINGCONTEXT  */
    tHELPSTRINGDLL = 341,          /* tHELPSTRINGDLL  */
    tHIDDEN = 342,                 /* tHIDDEN  */
    tHYPER = 343,                  /* tHYPER  */
    tID = 344,                     /* tID  */
    tIDEMPOTENT = 345,             /* tIDEMPOTENT  */
    tIGNORE = 346,                 /* tIGNORE  */
    tIIDIS = 347,                  /* tIIDIS  */
    tIMMEDIATEBIND = 348,          /* tIMMEDIATEBIND  */
    tIMPLICITHANDLE = 349,         /* tIMPLICITHANDLE  */
    tIMPORT = 350,                 /* tIMPORT  */
    tIMPORTLIB = 351,              /* tIMPORTLIB  */
    tIN = 352,                     /* tIN  */
    tIN_LINE = 353,                /* tIN_LINE  */
    tINLINE = 354,                 /* tINLINE  */
    tINPUTSYNC = 355,              /* tINPUTSYNC  */
    tINT = 356,                    /* tINT  */
    tINT32 = 357,                  /* tINT32  */
    tINT3264 = 358,                /* tINT3264  */
    tINT64 = 359,                  /* tINT64  */
    tINTERFACE = 360,              /* tINTERFACE  */
    tLCID = 361,                   /* tLCID  */
    tLENGTHIS = 362,               /* tLENGTHIS  */
    tLIBRARY = 363,                /* tLIBRARY  */
    tLICENSED = 364,               /* tLICENSED  */
    tLOCAL = 365,                  /* tLOCAL  */
    tLONG = 366,                   /* tLONG  */
    tMAYBE = 367,                  /* tMAYBE  */
    tMESSAGE = 368,                /* tMESSAGE  */
    tMETHODS = 369,                /* tMETHODS  */
    tMODULE = 370,                 /* tMODULE  */
    tNAMESPACE = 371,              /* tNAMESPACE  */
    tNOCODE = 372,                 /* tNOCODE  */
    tNONBROWSABLE = 373,           /* tNONBROWSABLE  */
    tNONCREATABLE = 374,           /* tNONCREATABLE  */
    tNONEXTENSIBLE = 375,          /* tNONEXTENSIBLE  */
    tNOTIFY = 376,                 /* tNOTIFY  */
    tNOTIFYFLAG = 377,             /* tNOTIFYFLAG  */
    tNULL = 378,                   /* tNULL  */
    tOBJECT = 379,                 /* tOBJECT  */
    tODL = 380,                    /* tODL  */
    tOLEAUTOMATION = 381,          /* tOLEAUTOMATION  */
    tOPTIMIZE = 382,               /* tOPTIMIZE  */
    tOPTIONAL = 383,               /* tOPTIONAL  */
    tOUT = 384,                    /* tOUT  */
    tPARTIALIGNORE = 385,          /* tPARTIALIGNORE  */
    tPASCAL = 386,                 /* tPASCAL  */
    tPOINTERDEFAULT = 387,         /* tPOINTERDEFAULT  */
    tPRAGMA_WARNING = 388,         /* tPRAGMA_WARNING  */
    tPROGID = 389,                 /* tPROGID  */
    tPROPERTIES = 390,             /* tPROPERTIES  */
    tPROPGET = 391,                /* tPROPGET  */
    tPROPPUT = 392,                /* tPROPPUT  */
    tPROPPUTREF = 393,             /* tPROPPUTREF  */
    tPROXY = 394,                  /* tPROXY  */
    tPTR = 395,                    /* tPTR  */
    tPUBLIC = 396,                 /* tPUBLIC  */
    tRANGE = 397,                  /* tRANGE  */
    tREADONLY = 398,               /* tREADONLY  */
    tREF = 399,                    /* tREF  */
    tREGISTER = 400,               /* tREGISTER  */
    tREPRESENTAS = 401,            /* tREPRESENTAS  */
    tREQUESTEDIT = 402,            /* tREQUESTEDIT  */
    tRESTRICTED = 403,             /* tRESTRICTED  */
    tRETVAL = 404,                 /* tRETVAL  */
    tSAFEARRAY = 405,              /* tSAFEARRAY  */
    tSHORT = 406,                  /* tSHORT  */
    tSIGNED = 407,                 /* tSIGNED  */
    tSINGLENODE = 408,             /* tSINGLENODE  */
    tSIZEIS = 409,                 /* tSIZEIS  */
    tSIZEOF = 410,                 /* tSIZEOF  */
    tSMALL = 411,                  /* tSMALL  */
    tSOURCE = 412,                 /* tSOURCE  */
    tSTATIC = 413,                 /* tSTATIC  */
    tSTDCALL = 414,                /* tSTDCALL  */
    tSTRICTCONTEXTHANDLE = 415,    /* tSTRICTCONTEXTHANDLE  */
    tSTRING = 416,                 /* tSTRING  */
    tSTRUCT = 417,                 /* tSTRUCT  */
    tSWITCH = 418,                 /* tSWITCH  */
    tSWITCHIS = 419,               /* tSWITCHIS  */
    tSWITCHTYPE = 420,             /* tSWITCHTYPE  */
    tTHREADING = 421,              /* tTHREADING  */
    tTRANSMITAS = 422,             /* tTRANSMITAS  */
    tTRUE = 423,                   /* tTRUE  */
    tTYPEDEF = 424,                /* tTYPEDEF  */
    tUIDEFAULT = 425,              /* tUIDEFAULT  */
    tUNION = 426,                  /* tUNION  */
    tUNIQUE = 427,                 /* tUNIQUE  */
    tUNSIGNED = 428,               /* tUNSIGNED  */
    tUSESGETLASTERROR = 429,       /* tUSESGETLASTERROR  */
    tUSERMARSHAL = 430,            /* tUSERMARSHAL  */
    tUUID = 431,                   /* tUUID  */
    tV1ENUM = 432,                 /* tV1ENUM  */
    tVARARG = 433,                 /* tVARARG  */
    tVERSION = 434,                /* tVERSION  */
    tVIPROGID = 435,               /* tVIPROGID  */
    tVOID = 436,                   /* tVOID  */
    tWCHAR = 437,                  /* tWCHAR  */
    tWIREMARSHAL = 438,            /* tWIREMARSHAL  */
    tAPARTMENT = 439,              /* tAPARTMENT  */
    tNEUTRAL = 440,                /* tNEUTRAL  */
    tSINGLE = 441,                 /* tSINGLE  */
    tFREE = 442,                   /* tFREE  */
    tBOTH = 443,                   /* tBOTH  */
    CAST = 444,                    /* CAST  */
    PPTR = 445,                    /* PPTR  */
    POS = 446,                     /* POS  */
    NEG = 447,                     /* NEG  */
    ADDRESSOF = 448                /* ADDRESSOF  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 134 "tools/widl/parser.y"

	attr_t *attr;
	attr_list_t *attr_list;
	str_list_t *str_list;
	expr_t *expr;
	expr_list_t *expr_list;
	type_t *type;
	var_t *var;
	var_list_t *var_list;
	declarator_t *declarator;
	declarator_list_t *declarator_list;
	statement_t *statement;
	statement_list_t *stmt_list;
	warning_t *warning;
	warning_list_t *warning_list;
	ifref_t *ifref;
	ifref_list_t *ifref_list;
	char *str;
	UUID *uuid;
	unsigned int num;
	double dbl;
	typelib_t *typelib;
	struct _import_t *import;
	struct _decl_spec_t *declspec;
	enum storage_class stgclass;
	enum type_qualifier type_qualifier;
	enum function_specifier function_specifier;

#line 481 "tools/widl/parser.tab.c"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE parser_lval;

int parser_parse (void);


/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_aIDENTIFIER = 3,                /* aIDENTIFIER  */
  YYSYMBOL_aPRAGMA = 4,                    /* aPRAGMA  */
  YYSYMBOL_aKNOWNTYPE = 5,                 /* aKNOWNTYPE  */
  YYSYMBOL_aNAMESPACE = 6,                 /* aNAMESPACE  */
  YYSYMBOL_aNUM = 7,                       /* aNUM  */
  YYSYMBOL_aHEXNUM = 8,                    /* aHEXNUM  */
  YYSYMBOL_aDOUBLE = 9,                    /* aDOUBLE  */
  YYSYMBOL_aSTRING = 10,                   /* aSTRING  */
  YYSYMBOL_aWSTRING = 11,                  /* aWSTRING  */
  YYSYMBOL_aSQSTRING = 12,                 /* aSQSTRING  */
  YYSYMBOL_aUUID = 13,                     /* aUUID  */
  YYSYMBOL_aEOF = 14,                      /* aEOF  */
  YYSYMBOL_aACF = 15,                      /* aACF  */
  YYSYMBOL_SHL = 16,                       /* SHL  */
  YYSYMBOL_SHR = 17,                       /* SHR  */
  YYSYMBOL_MEMBERPTR = 18,                 /* MEMBERPTR  */
  YYSYMBOL_EQUALITY = 19,                  /* EQUALITY  */
  YYSYMBOL_INEQUALITY = 20,                /* INEQUALITY  */
  YYSYMBOL_GREATEREQUAL = 21,              /* GREATEREQUAL  */
  YYSYMBOL_LESSEQUAL = 22,                 /* LESSEQUAL  */
  YYSYMBOL_LOGICALOR = 23,                 /* LOGICALOR  */
  YYSYMBOL_LOGICALAND = 24,                /* LOGICALAND  */
  YYSYMBOL_ELLIPSIS = 25,                  /* ELLIPSIS  */
  YYSYMBOL_tAGGREGATABLE = 26,             /* tAGGREGATABLE  */
  YYSYMBOL_tALLNODES = 27,                 /* tALLNODES  */
  YYSYMBOL_tALLOCATE = 28,                 /* tALLOCATE  */
  YYSYMBOL_tANNOTATION = 29,               /* tANNOTATION  */
  YYSYMBOL_tAPPOBJECT = 30,                /* tAPPOBJECT  */
  YYSYMBOL_tASYNC = 31,                    /* tASYNC  */
  YYSYMBOL_tASYNCUUID = 32,                /* tASYNCUUID  */
  YYSYMBOL_tAUTOHANDLE = 33,               /* tAUTOHANDLE  */
  YYSYMBOL_tBINDABLE = 34,                 /* tBINDABLE  */
  YYSYMBOL_tBOOLEAN = 35,                  /* tBOOLEAN  */
  YYSYMBOL_tBROADCAST = 36,                /* tBROADCAST  */
  YYSYMBOL_tBYTE = 37,                     /* tBYTE  */
  YYSYMBOL_tBYTECOUNT = 38,                /* tBYTECOUNT  */
  YYSYMBOL_tCALLAS = 39,                   /* tCALLAS  */
  YYSYMBOL_tCALLBACK = 40,                 /* tCALLBACK  */
  YYSYMBOL_tCASE = 41,                     /* tCASE  */
  YYSYMBOL_tCDECL = 42,                    /* tCDECL  */
  YYSYMBOL_tCHAR = 43,                     /* tCHAR  */
  YYSYMBOL_tCOCLASS = 44,                  /* tCOCLASS  */
  YYSYMBOL_tCODE = 45,                     /* tCODE  */
  YYSYMBOL_tCOMMSTATUS = 46,               /* tCOMMSTATUS  */
  YYSYMBOL_tCONST = 47,                    /* tCONST  */
  YYSYMBOL_tCONTEXTHANDLE = 48,            /* tCONTEXTHANDLE  */
  YYSYMBOL_tCONTEXTHANDLENOSERIALIZE = 49, /* tCONTEXTHANDLENOSERIALIZE  */
  YYSYMBOL_tCONTEXTHANDLESERIALIZE = 50,   /* tCONTEXTHANDLESERIALIZE  */
  YYSYMBOL_tCONTROL = 51,                  /* tCONTROL  */
  YYSYMBOL_tCPPQUOTE = 52,                 /* tCPPQUOTE  */
  YYSYMBOL_tCUSTOM = 53,                   /* tCUSTOM  */
  YYSYMBOL_tDECODE = 54,                   /* tDECODE  */
  YYSYMBOL_tDEFAULT = 55,                  /* tDEFAULT  */
  YYSYMBOL_tDEFAULTBIND = 56,              /* tDEFAULTBIND  */
  YYSYMBOL_tDEFAULTCOLLELEM = 57,          /* tDEFAULTCOLLELEM  */
  YYSYMBOL_tDEFAULTVALUE = 58,             /* tDEFAULTVALUE  */
  YYSYMBOL_tDEFAULTVTABLE = 59,            /* tDEFAULTVTABLE  */
  YYSYMBOL_tDISABLECONSISTENCYCHECK = 60,  /* tDISABLECONSISTENCYCHECK  */
  YYSYMBOL_tDISPLAYBIND = 61,              /* tDISPLAYBIND  */
  YYSYMBOL_tDISPINTERFACE = 62,            /* tDISPINTERFACE  */
  YYSYMBOL_tDLLNAME = 63,                  /* tDLLNAME  */
  YYSYMBOL_tDONTFREE = 64,                 /* tDONTFREE  */
  YYSYMBOL_tDOUBLE = 65,                   /* tDOUBLE  */
  YYSYMBOL_tDUAL = 66,                     /* tDUAL  */
  YYSYMBOL_tENABLEALLOCATE = 67,           /* tENABLEALLOCATE  */
  YYSYMBOL_tENCODE = 68,                   /* tENCODE  */
  YYSYMBOL_tENDPOINT = 69,                 /* tENDPOINT  */
  YYSYMBOL_tENTRY = 70,                    /* tENTRY  */
  YYSYMBOL_tENUM = 71,                     /* tENUM  */
  YYSYMBOL_tERRORSTATUST = 72,             /* tERRORSTATUST  */
  YYSYMBOL_tEXPLICITHANDLE = 73,           /* tEXPLICITHANDLE  */
  YYSYMBOL_tEXTERN = 74,                   /* tEXTERN  */
  YYSYMBOL_tFALSE = 75,                    /* tFALSE  */
  YYSYMBOL_tFASTCALL = 76,                 /* tFASTCALL  */
  YYSYMBOL_tFAULTSTATUS = 77,              /* tFAULTSTATUS  */
  YYSYMBOL_tFLOAT = 78,                    /* tFLOAT  */
  YYSYMBOL_tFORCEALLOCATE = 79,            /* tFORCEALLOCATE  */
  YYSYMBOL_tHANDLE = 80,                   /* tHANDLE  */
  YYSYMBOL_tHANDLET = 81,                  /* tHANDLET  */
  YYSYMBOL_tHELPCONTEXT = 82,              /* tHELPCONTEXT  */
  YYSYMBOL_tHELPFILE = 83,                 /* tHELPFILE  */
  YYSYMBOL_tHELPSTRING = 84,               /* tHELPSTRING  */
  YYSYMBOL_tHELPSTRINGCONTEXT = 85,        /* tHELPSTRINGCONTEXT  */
  YYSYMBOL_tHELPSTRINGDLL = 86,            /* tHELPSTRINGDLL  */
  YYSYMBOL_tHIDDEN = 87,                   /* tHIDDEN  */
  YYSYMBOL_tHYPER = 88,                    /* tHYPER  */
  YYSYMBOL_tID = 89,                       /* tID  */
  YYSYMBOL_tIDEMPOTENT = 90,               /* tIDEMPOTENT  */
  YYSYMBOL_tIGNORE = 91,                   /* tIGNORE  */
  YYSYMBOL_tIIDIS = 92,                    /* tIIDIS  */
  YYSYMBOL_tIMMEDIATEBIND = 93,            /* tIMMEDIATEBIND  */
  YYSYMBOL_tIMPLICITHANDLE = 94,           /* tIMPLICITHANDLE  */
  YYSYMBOL_tIMPORT = 95,                   /* tIMPORT  */
  YYSYMBOL_tIMPORTLIB = 96,                /* tIMPORTLIB  */
  YYSYMBOL_tIN = 97,                       /* tIN  */
  YYSYMBOL_tIN_LINE = 98,                  /* tIN_LINE  */
  YYSYMBOL_tINLINE = 99,                   /* tINLINE  */
  YYSYMBOL_tINPUTSYNC = 100,               /* tINPUTSYNC  */
  YYSYMBOL_tINT = 101,                     /* tINT  */
  YYSYMBOL_tINT32 = 102,                   /* tINT32  */
  YYSYMBOL_tINT3264 = 103,                 /* tINT3264  */
  YYSYMBOL_tINT64 = 104,                   /* tINT64  */
  YYSYMBOL_tINTERFACE = 105,               /* tINTERFACE  */
  YYSYMBOL_tLCID = 106,                    /* tLCID  */
  YYSYMBOL_tLENGTHIS = 107,                /* tLENGTHIS  */
  YYSYMBOL_tLIBRARY = 108,                 /* tLIBRARY  */
  YYSYMBOL_tLICENSED = 109,                /* tLICENSED  */
  YYSYMBOL_tLOCAL = 110,                   /* tLOCAL  */
  YYSYMBOL_tLONG = 111,                    /* tLONG  */
  YYSYMBOL_tMAYBE = 112,                   /* tMAYBE  */
  YYSYMBOL_tMESSAGE = 113,                 /* tMESSAGE  */
  YYSYMBOL_tMETHODS = 114,                 /* tMETHODS  */
  YYSYMBOL_tMODULE = 115,                  /* tMODULE  */
  YYSYMBOL_tNAMESPACE = 116,               /* tNAMESPACE  */
  YYSYMBOL_tNOCODE = 117,                  /* tNOCODE  */
  YYSYMBOL_tNONBROWSABLE = 118,            /* tNONBROWSABLE  */
  YYSYMBOL_tNONCREATABLE = 119,            /* tNONCREATABLE  */
  YYSYMBOL_tNONEXTENSIBLE = 120,           /* tNONEXTENSIBLE  */
  YYSYMBOL_tNOTIFY = 121,                  /* tNOTIFY  */
  YYSYMBOL_tNOTIFYFLAG = 122,              /* tNOTIFYFLAG  */
  YYSYMBOL_tNULL = 123,                    /* tNULL  */
  YYSYMBOL_tOBJECT = 124,                  /* tOBJECT  */
  YYSYMBOL_tODL = 125,                     /* tODL  */
  YYSYMBOL_tOLEAUTOMATION = 126,           /* tOLEAUTOMATION  */
  YYSYMBOL_tOPTIMIZE = 127,                /* tOPTIMIZE  */
  YYSYMBOL_tOPTIONAL = 128,                /* tOPTIONAL  */
  YYSYMBOL_tOUT = 129,                     /* tOUT  */
  YYSYMBOL_tPARTIALIGNORE = 130,           /* tPARTIALIGNORE  */
  YYSYMBOL_tPASCAL = 131,                  /* tPASCAL  */
  YYSYMBOL_tPOINTERDEFAULT = 132,          /* tPOINTERDEFAULT  */
  YYSYMBOL_tPRAGMA_WARNING = 133,          /* tPRAGMA_WARNING  */
  YYSYMBOL_tPROGID = 134,                  /* tPROGID  */
  YYSYMBOL_tPROPERTIES = 135,              /* tPROPERTIES  */
  YYSYMBOL_tPROPGET = 136,                 /* tPROPGET  */
  YYSYMBOL_tPROPPUT = 137,                 /* tPROPPUT  */
  YYSYMBOL_tPROPPUTREF = 138,              /* tPROPPUTREF  */
  YYSYMBOL_tPROXY = 139,                   /* tPROXY  */
  YYSYMBOL_tPTR = 140,                     /* tPTR  */
  YYSYMBOL_tPUBLIC = 141,                  /* tPUBLIC  */
  YYSYMBOL_tRANGE = 142,                   /* tRANGE  */
  YYSYMBOL_tREADONLY = 143,                /* tREADONLY  */
  YYSYMBOL_tREF = 144,                     /* tREF  */
  YYSYMBOL_tREGISTER = 145,                /* tREGISTER  */
  YYSYMBOL_tREPRESENTAS = 146,             /* tREPRESENTAS  */
  YYSYMBOL_tREQUESTEDIT = 147,             /* tREQUESTEDIT  */
  YYSYMBOL_tRESTRICTED = 148,              /* tRESTRICTED  */
  YYSYMBOL_tRETVAL = 149,                  /* tRETVAL  */
  YYSYMBOL_tSAFEARRAY = 150,               /* tSAFEARRAY  */
  YYSYMBOL_tSHORT = 151,                   /* tSHORT  */
  YYSYMBOL_tSIGNED = 152,                  /* tSIGNED  */
  YYSYMBOL_tSINGLENODE = 153,              /* tSINGLENODE  */
  YYSYMBOL_tSIZEIS = 154,                  /* tSIZEIS  */
  YYSYMBOL_tSIZEOF = 155,                  /* tSIZEOF  */
  YYSYMBOL_tSMALL = 156,                   /* tSMALL  */
  YYSYMBOL_tSOURCE = 157,                  /* tSOURCE  */
  YYSYMBOL_tSTATIC = 158,                  /* tSTATIC  */
  YYSYMBOL_tSTDCALL = 159,                 /* tSTDCALL  */
  YYSYMBOL_tSTRICTCONTEXTHANDLE = 160,     /* tSTRICTCONTEXTHANDLE  */
  YYSYMBOL_tSTRING = 161,                  /* tSTRING  */
  YYSYMBOL_tSTRUCT = 162,                  /* tSTRUCT  */
  YYSYMBOL_tSWITCH = 163,                  /* tSWITCH  */
  YYSYMBOL_tSWITCHIS = 164,                /* tSWITCHIS  */
  YYSYMBOL_tSWITCHTYPE = 165,              /* tSWITCHTYPE  */
  YYSYMBOL_tTHREADING = 166,               /* tTHREADING  */
  YYSYMBOL_tTRANSMITAS = 167,              /* tTRANSMITAS  */
  YYSYMBOL_tTRUE = 168,                    /* tTRUE  */
  YYSYMBOL_tTYPEDEF = 169,                 /* tTYPEDEF  */
  YYSYMBOL_tUIDEFAULT = 170,               /* tUIDEFAULT  */
  YYSYMBOL_tUNION = 171,                   /* tUNION  */
  YYSYMBOL_tUNIQUE = 172,                  /* tUNIQUE  */
  YYSYMBOL_tUNSIGNED = 173,                /* tUNSIGNED  */
  YYSYMBOL_tUSESGETLASTERROR = 174,        /* tUSESGETLASTERROR  */
  YYSYMBOL_tUSERMARSHAL = 175,             /* tUSERMARSHAL  */
  YYSYMBOL_tUUID = 176,                    /* tUUID  */
  YYSYMBOL_tV1ENUM = 177,                  /* tV1ENUM  */
  YYSYMBOL_tVARARG = 178,                  /* tVARARG  */
  YYSYMBOL_tVERSION = 179,                 /* tVERSION  */
  YYSYMBOL_tVIPROGID = 180,                /* tVIPROGID  */
  YYSYMBOL_tVOID = 181,                    /* tVOID  */
  YYSYMBOL_tWCHAR = 182,                   /* tWCHAR  */
  YYSYMBOL_tWIREMARSHAL = 183,             /* tWIREMARSHAL  */
  YYSYMBOL_tAPARTMENT = 184,               /* tAPARTMENT  */
  YYSYMBOL_tNEUTRAL = 185,                 /* tNEUTRAL  */
  YYSYMBOL_tSINGLE = 186,                  /* tSINGLE  */
  YYSYMBOL_tFREE = 187,                    /* tFREE  */
  YYSYMBOL_tBOTH = 188,                    /* tBOTH  */
  YYSYMBOL_189_ = 189,                     /* ','  */
  YYSYMBOL_190_ = 190,                     /* '?'  */
  YYSYMBOL_191_ = 191,                     /* ':'  */
  YYSYMBOL_192_ = 192,                     /* '|'  */
  YYSYMBOL_193_ = 193,                     /* '^'  */
  YYSYMBOL_194_ = 194,                     /* '&'  */
  YYSYMBOL_195_ = 195,                     /* '<'  */
  YYSYMBOL_196_ = 196,                     /* '>'  */
  YYSYMBOL_197_ = 197,                     /* '-'  */
  YYSYMBOL_198_ = 198,                     /* '+'  */
  YYSYMBOL_199_ = 199,                     /* '*'  */
  YYSYMBOL_200_ = 200,                     /* '/'  */
  YYSYMBOL_201_ = 201,                     /* '%'  */
  YYSYMBOL_202_ = 202,                     /* '!'  */
  YYSYMBOL_203_ = 203,                     /* '~'  */
  YYSYMBOL_CAST = 204,                     /* CAST  */
  YYSYMBOL_PPTR = 205,                     /* PPTR  */
  YYSYMBOL_POS = 206,                      /* POS  */
  YYSYMBOL_NEG = 207,                      /* NEG  */
  YYSYMBOL_ADDRESSOF = 208,                /* ADDRESSOF  */
  YYSYMBOL_209_ = 209,                     /* '.'  */
  YYSYMBOL_210_ = 210,                     /* '['  */
  YYSYMBOL_211_ = 211,                     /* ']'  */
  YYSYMBOL_212_ = 212,                     /* '{'  */
  YYSYMBOL_213_ = 213,                     /* '}'  */
  YYSYMBOL_214_ = 214,                     /* ';'  */
  YYSYMBOL_215_ = 215,                     /* '('  */
  YYSYMBOL_216_ = 216,                     /* ')'  */
  YYSYMBOL_217_ = 217,                     /* '='  */
  YYSYMBOL_YYACCEPT = 218,                 /* $accept  */
  YYSYMBOL_input = 219,                    /* input  */
  YYSYMBOL_m_acf = 220,                    /* m_acf  */
  YYSYMBOL_gbl_statements = 221,           /* gbl_statements  */
  YYSYMBOL_222_1 = 222,                    /* $@1  */
  YYSYMBOL_imp_statements = 223,           /* imp_statements  */
  YYSYMBOL_224_2 = 224,                    /* $@2  */
  YYSYMBOL_int_statements = 225,           /* int_statements  */
  YYSYMBOL_semicolon_opt = 226,            /* semicolon_opt  */
  YYSYMBOL_statement = 227,                /* statement  */
  YYSYMBOL_pragma_warning = 228,           /* pragma_warning  */
  YYSYMBOL_warnings = 229,                 /* warnings  */
  YYSYMBOL_typedecl = 230,                 /* typedecl  */
  YYSYMBOL_cppquote = 231,                 /* cppquote  */
  YYSYMBOL_import_start = 232,             /* import_start  */
  YYSYMBOL_import = 233,                   /* import  */
  YYSYMBOL_importlib = 234,                /* importlib  */
  YYSYMBOL_libraryhdr = 235,               /* libraryhdr  */
  YYSYMBOL_library_start = 236,            /* library_start  */
  YYSYMBOL_librarydef = 237,               /* librarydef  */
  YYSYMBOL_m_args = 238,                   /* m_args  */
  YYSYMBOL_arg_list = 239,                 /* arg_list  */
  YYSYMBOL_args = 240,                     /* args  */
  YYSYMBOL_arg = 241,                      /* arg  */
  YYSYMBOL_array = 242,                    /* array  */
  YYSYMBOL_m_attributes = 243,             /* m_attributes  */
  YYSYMBOL_attributes = 244,               /* attributes  */
  YYSYMBOL_attrib_list = 245,              /* attrib_list  */
  YYSYMBOL_str_list = 246,                 /* str_list  */
  YYSYMBOL_attribute = 247,                /* attribute  */
  YYSYMBOL_uuid_string = 248,              /* uuid_string  */
  YYSYMBOL_callconv = 249,                 /* callconv  */
  YYSYMBOL_cases = 250,                    /* cases  */
  YYSYMBOL_case = 251,                     /* case  */
  YYSYMBOL_enums = 252,                    /* enums  */
  YYSYMBOL_enum_list = 253,                /* enum_list  */
  YYSYMBOL_enum_member = 254,              /* enum_member  */
  YYSYMBOL_enum = 255,                     /* enum  */
  YYSYMBOL_enumdef = 256,                  /* enumdef  */
  YYSYMBOL_m_exprs = 257,                  /* m_exprs  */
  YYSYMBOL_m_expr = 258,                   /* m_expr  */
  YYSYMBOL_expr = 259,                     /* expr  */
  YYSYMBOL_expr_list_int_const = 260,      /* expr_list_int_const  */
  YYSYMBOL_expr_int_const = 261,           /* expr_int_const  */
  YYSYMBOL_expr_const = 262,               /* expr_const  */
  YYSYMBOL_fields = 263,                   /* fields  */
  YYSYMBOL_field = 264,                    /* field  */
  YYSYMBOL_ne_union_field = 265,           /* ne_union_field  */
  YYSYMBOL_ne_union_fields = 266,          /* ne_union_fields  */
  YYSYMBOL_union_field = 267,              /* union_field  */
  YYSYMBOL_s_field = 268,                  /* s_field  */
  YYSYMBOL_funcdef = 269,                  /* funcdef  */
  YYSYMBOL_declaration = 270,              /* declaration  */
  YYSYMBOL_m_ident = 271,                  /* m_ident  */
  YYSYMBOL_t_ident = 272,                  /* t_ident  */
  YYSYMBOL_ident = 273,                    /* ident  */
  YYSYMBOL_base_type = 274,                /* base_type  */
  YYSYMBOL_m_int = 275,                    /* m_int  */
  YYSYMBOL_int_std = 276,                  /* int_std  */
  YYSYMBOL_qualified_seq = 277,            /* qualified_seq  */
  YYSYMBOL_278_3 = 278,                    /* $@3  */
  YYSYMBOL_qualified_type = 279,           /* qualified_type  */
  YYSYMBOL_280_4 = 280,                    /* $@4  */
  YYSYMBOL_coclass = 281,                  /* coclass  */
  YYSYMBOL_coclasshdr = 282,               /* coclasshdr  */
  YYSYMBOL_coclassdef = 283,               /* coclassdef  */
  YYSYMBOL_namespacedef = 284,             /* namespacedef  */
  YYSYMBOL_coclass_ints = 285,             /* coclass_ints  */
  YYSYMBOL_coclass_int = 286,              /* coclass_int  */
  YYSYMBOL_dispinterface = 287,            /* dispinterface  */
  YYSYMBOL_dispinterfacehdr = 288,         /* dispinterfacehdr  */
  YYSYMBOL_dispint_props = 289,            /* dispint_props  */
  YYSYMBOL_dispint_meths = 290,            /* dispint_meths  */
  YYSYMBOL_dispinterfacedef = 291,         /* dispinterfacedef  */
  YYSYMBOL_inherit = 292,                  /* inherit  */
  YYSYMBOL_interface = 293,                /* interface  */
  YYSYMBOL_interfacehdr = 294,             /* interfacehdr  */
  YYSYMBOL_interfacedef = 295,             /* interfacedef  */
  YYSYMBOL_interfacedec = 296,             /* interfacedec  */
  YYSYMBOL_module = 297,                   /* module  */
  YYSYMBOL_modulehdr = 298,                /* modulehdr  */
  YYSYMBOL_moduledef = 299,                /* moduledef  */
  YYSYMBOL_storage_cls_spec = 300,         /* storage_cls_spec  */
  YYSYMBOL_function_specifier = 301,       /* function_specifier  */
  YYSYMBOL_type_qualifier = 302,           /* type_qualifier  */
  YYSYMBOL_m_type_qual_list = 303,         /* m_type_qual_list  */
  YYSYMBOL_decl_spec = 304,                /* decl_spec  */
  YYSYMBOL_m_decl_spec_no_type = 305,      /* m_decl_spec_no_type  */
  YYSYMBOL_decl_spec_no_type = 306,        /* decl_spec_no_type  */
  YYSYMBOL_declarator = 307,               /* declarator  */
  YYSYMBOL_direct_declarator = 308,        /* direct_declarator  */
  YYSYMBOL_abstract_declarator = 309,      /* abstract_declarator  */
  YYSYMBOL_abstract_declarator_no_direct = 310, /* abstract_declarator_no_direct  */
  YYSYMBOL_m_abstract_declarator = 311,    /* m_abstract_declarator  */
  YYSYMBOL_abstract_direct_declarator = 312, /* abstract_direct_declarator  */
  YYSYMBOL_any_declarator = 313,           /* any_declarator  */
  YYSYMBOL_any_declarator_no_direct = 314, /* any_declarator_no_direct  */
  YYSYMBOL_m_any_declarator = 315,         /* m_any_declarator  */
  YYSYMBOL_any_direct_declarator = 316,    /* any_direct_declarator  */
  YYSYMBOL_declarator_list = 317,          /* declarator_list  */
  YYSYMBOL_m_bitfield = 318,               /* m_bitfield  */
  YYSYMBOL_struct_declarator = 319,        /* struct_declarator  */
  YYSYMBOL_struct_declarator_list = 320,   /* struct_declarator_list  */
  YYSYMBOL_init_declarator = 321,          /* init_declarator  */
  YYSYMBOL_threading_type = 322,           /* threading_type  */
  YYSYMBOL_pointer_type = 323,             /* pointer_type  */
  YYSYMBOL_structdef = 324,                /* structdef  */
  YYSYMBOL_type = 325,                     /* type  */
  YYSYMBOL_typedef = 326,                  /* typedef  */
  YYSYMBOL_uniondef = 327,                 /* uniondef  */
  YYSYMBOL_version = 328,                  /* version  */
  YYSYMBOL_acf_statements = 329,           /* acf_statements  */
  YYSYMBOL_acf_int_statements = 330,       /* acf_int_statements  */
  YYSYMBOL_acf_int_statement = 331,        /* acf_int_statement  */
  YYSYMBOL_acf_interface = 332,            /* acf_interface  */
  YYSYMBOL_acf_attributes = 333,           /* acf_attributes  */
  YYSYMBOL_acf_attribute_list = 334,       /* acf_attribute_list  */
  YYSYMBOL_acf_attribute = 335,            /* acf_attribute  */
  YYSYMBOL_allocate_option_list = 336,     /* allocate_option_list  */
  YYSYMBOL_allocate_option = 337           /* allocate_option  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   3146

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  218
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  120
/* YYNRULES -- Number of rules.  */
#define YYNRULES  426
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  748

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   448


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   202,     2,     2,     2,   201,   194,     2,
     215,   216,   199,   198,   189,   197,   209,   200,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   191,   214,
     195,   217,   196,   190,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   210,     2,   211,   193,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   212,   192,   213,   203,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   204,   205,   206,   207,   208
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   322,   322,   336,   336,   338,   339,   339,   341,   342,
     343,   346,   349,   350,   351,   354,   355,   356,   356,   358,
     359,   360,   363,   364,   365,   366,   369,   370,   373,   374,
     378,   379,   380,   381,   382,   383,   384,   387,   398,   399,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   414,
     416,   424,   430,   434,   435,   437,   441,   445,   446,   449,
     450,   453,   454,   458,   463,   470,   474,   475,   478,   479,
     483,   486,   487,   488,   491,   492,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   602,   603,   608,
     609,   610,   611,   614,   615,   618,   622,   628,   629,   630,
     633,   637,   649,   654,   658,   663,   666,   667,   670,   671,
     674,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   713,   715,
     716,   719,   720,   723,   729,   735,   736,   739,   744,   751,
     752,   755,   756,   760,   761,   764,   768,   774,   782,   786,
     791,   792,   795,   796,   797,   800,   802,   805,   806,   807,
     808,   809,   810,   811,   812,   813,   814,   815,   818,   819,
     822,   823,   824,   825,   826,   827,   828,   829,   830,   834,
     835,   835,   839,   840,   840,   843,   844,   852,   858,   862,
     863,   866,   867,   871,   874,   875,   878,   887,   888,   891,
     892,   895,   901,   907,   908,   911,   912,   915,   922,   931,
     936,   940,   941,   944,   945,   948,   953,   960,   961,   962,
     966,   970,   973,   974,   977,   978,   982,   983,   987,   988,
     989,   993,   995,   996,  1000,  1001,  1002,  1003,  1008,  1010,
    1011,  1016,  1018,  1022,  1023,  1028,  1029,  1030,  1031,  1035,
    1043,  1045,  1046,  1051,  1053,  1057,  1058,  1065,  1066,  1067,
    1068,  1069,  1073,  1080,  1081,  1084,  1085,  1088,  1095,  1096,
    1101,  1102,  1106,  1107,  1108,  1109,  1110,  1114,  1115,  1116,
    1119,  1122,  1123,  1124,  1125,  1126,  1127,  1128,  1129,  1130,
    1131,  1134,  1141,  1143,  1149,  1150,  1151,  1155,  1156,  1160,
    1161,  1165,  1172,  1181,  1182,  1186,  1187,  1191,  1193,  1194,
    1195,  1199,  1200,  1205,  1206,  1207,  1208
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "aIDENTIFIER",
  "aPRAGMA", "aKNOWNTYPE", "aNAMESPACE", "aNUM", "aHEXNUM", "aDOUBLE",
  "aSTRING", "aWSTRING", "aSQSTRING", "aUUID", "aEOF", "aACF", "SHL",
  "SHR", "MEMBERPTR", "EQUALITY", "INEQUALITY", "GREATEREQUAL",
  "LESSEQUAL", "LOGICALOR", "LOGICALAND", "ELLIPSIS", "tAGGREGATABLE",
  "tALLNODES", "tALLOCATE", "tANNOTATION", "tAPPOBJECT", "tASYNC",
  "tASYNCUUID", "tAUTOHANDLE", "tBINDABLE", "tBOOLEAN", "tBROADCAST",
  "tBYTE", "tBYTECOUNT", "tCALLAS", "tCALLBACK", "tCASE", "tCDECL",
  "tCHAR", "tCOCLASS", "tCODE", "tCOMMSTATUS", "tCONST", "tCONTEXTHANDLE",
  "tCONTEXTHANDLENOSERIALIZE", "tCONTEXTHANDLESERIALIZE", "tCONTROL",
  "tCPPQUOTE", "tCUSTOM", "tDECODE", "tDEFAULT", "tDEFAULTBIND",
  "tDEFAULTCOLLELEM", "tDEFAULTVALUE", "tDEFAULTVTABLE",
  "tDISABLECONSISTENCYCHECK", "tDISPLAYBIND", "tDISPINTERFACE", "tDLLNAME",
  "tDONTFREE", "tDOUBLE", "tDUAL", "tENABLEALLOCATE", "tENCODE",
  "tENDPOINT", "tENTRY", "tENUM", "tERRORSTATUST", "tEXPLICITHANDLE",
  "tEXTERN", "tFALSE", "tFASTCALL", "tFAULTSTATUS", "tFLOAT",
  "tFORCEALLOCATE", "tHANDLE", "tHANDLET", "tHELPCONTEXT", "tHELPFILE",
  "tHELPSTRING", "tHELPSTRINGCONTEXT", "tHELPSTRINGDLL", "tHIDDEN",
  "tHYPER", "tID", "tIDEMPOTENT", "tIGNORE", "tIIDIS", "tIMMEDIATEBIND",
  "tIMPLICITHANDLE", "tIMPORT", "tIMPORTLIB", "tIN", "tIN_LINE", "tINLINE",
  "tINPUTSYNC", "tINT", "tINT32", "tINT3264", "tINT64", "tINTERFACE",
  "tLCID", "tLENGTHIS", "tLIBRARY", "tLICENSED", "tLOCAL", "tLONG",
  "tMAYBE", "tMESSAGE", "tMETHODS", "tMODULE", "tNAMESPACE", "tNOCODE",
  "tNONBROWSABLE", "tNONCREATABLE", "tNONEXTENSIBLE", "tNOTIFY",
  "tNOTIFYFLAG", "tNULL", "tOBJECT", "tODL", "tOLEAUTOMATION", "tOPTIMIZE",
  "tOPTIONAL", "tOUT", "tPARTIALIGNORE", "tPASCAL", "tPOINTERDEFAULT",
  "tPRAGMA_WARNING", "tPROGID", "tPROPERTIES", "tPROPGET", "tPROPPUT",
  "tPROPPUTREF", "tPROXY", "tPTR", "tPUBLIC", "tRANGE", "tREADONLY",
  "tREF", "tREGISTER", "tREPRESENTAS", "tREQUESTEDIT", "tRESTRICTED",
  "tRETVAL", "tSAFEARRAY", "tSHORT", "tSIGNED", "tSINGLENODE", "tSIZEIS",
  "tSIZEOF", "tSMALL", "tSOURCE", "tSTATIC", "tSTDCALL",
  "tSTRICTCONTEXTHANDLE", "tSTRING", "tSTRUCT", "tSWITCH", "tSWITCHIS",
  "tSWITCHTYPE", "tTHREADING", "tTRANSMITAS", "tTRUE", "tTYPEDEF",
  "tUIDEFAULT", "tUNION", "tUNIQUE", "tUNSIGNED", "tUSESGETLASTERROR",
  "tUSERMARSHAL", "tUUID", "tV1ENUM", "tVARARG", "tVERSION", "tVIPROGID",
  "tVOID", "tWCHAR", "tWIREMARSHAL", "tAPARTMENT", "tNEUTRAL", "tSINGLE",
  "tFREE", "tBOTH", "','", "'?'", "':'", "'|'", "'^'", "'&'", "'<'", "'>'",
  "'-'", "'+'", "'*'", "'/'", "'%'", "'!'", "'~'", "CAST", "PPTR", "POS",
  "NEG", "ADDRESSOF", "'.'", "'['", "']'", "'{'", "'}'", "';'", "'('",
  "')'", "'='", "$accept", "input", "m_acf", "gbl_statements", "$@1",
  "imp_statements", "$@2", "int_statements", "semicolon_opt", "statement",
  "pragma_warning", "warnings", "typedecl", "cppquote", "import_start",
  "import", "importlib", "libraryhdr", "library_start", "librarydef",
  "m_args", "arg_list", "args", "arg", "array", "m_attributes",
  "attributes", "attrib_list", "str_list", "attribute", "uuid_string",
  "callconv", "cases", "case", "enums", "enum_list", "enum_member", "enum",
  "enumdef", "m_exprs", "m_expr", "expr", "expr_list_int_const",
  "expr_int_const", "expr_const", "fields", "field", "ne_union_field",
  "ne_union_fields", "union_field", "s_field", "funcdef", "declaration",
  "m_ident", "t_ident", "ident", "base_type", "m_int", "int_std",
  "qualified_seq", "$@3", "qualified_type", "$@4", "coclass", "coclasshdr",
  "coclassdef", "namespacedef", "coclass_ints", "coclass_int",
  "dispinterface", "dispinterfacehdr", "dispint_props", "dispint_meths",
  "dispinterfacedef", "inherit", "interface", "interfacehdr",
  "interfacedef", "interfacedec", "module", "modulehdr", "moduledef",
  "storage_cls_spec", "function_specifier", "type_qualifier",
  "m_type_qual_list", "decl_spec", "m_decl_spec_no_type",
  "decl_spec_no_type", "declarator", "direct_declarator",
  "abstract_declarator", "abstract_declarator_no_direct",
  "m_abstract_declarator", "abstract_direct_declarator", "any_declarator",
  "any_declarator_no_direct", "m_any_declarator", "any_direct_declarator",
  "declarator_list", "m_bitfield", "struct_declarator",
  "struct_declarator_list", "init_declarator", "threading_type",
  "pointer_type", "structdef", "type", "typedef", "uniondef", "version",
  "acf_statements", "acf_int_statements", "acf_int_statement",
  "acf_interface", "acf_attributes", "acf_attribute_list", "acf_attribute",
  "allocate_option_list", "allocate_option", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,    44,
      63,    58,   124,    94,    38,    60,    62,    45,    43,    42,
      47,    37,    33,   126,   444,   445,   446,   447,   448,    46,
      91,    93,   123,   125,    59,    40,    41,    61
};
#endif

#define YYPACT_NINF (-586)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-414)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -586,    39,  1740,  -586,  -586,  -586,   -30,   -79,  -586,  -586,
    -586,   154,  -586,   -77,   164,  -586,   339,  -586,  -586,  -586,
    -586,    77,   181,  -586,  -586,  -586,  -586,  -586,   343,    77,
      54,   -16,  -586,     8,    77,   194,  -586,  -586,   364,   377,
     194,  -586,  -586,  2963,  -586,  -586,  -586,   -12,  -586,  -586,
    -586,  -586,  -586,    38,  2631,     6,    15,  -586,  -586,  -586,
      21,    14,  -586,    24,    60,    63,    89,    90,    59,  -586,
    -586,   129,  -586,     4,     4,     4,    79,  2809,   133,     4,
     141,   145,  -586,    51,  -586,   -79,   150,  -586,  -586,   346,
    -586,  -586,   169,  -586,   158,  -586,  -586,   160,  -586,  -586,
    -586,  -586,  -586,   372,  2809,  -586,  -586,   174,   182,  -113,
     -94,  -586,  -586,   192,  -586,  -586,   200,  -586,  -586,  -586,
     213,   218,  -586,  -586,  -586,  -586,  -586,  -586,   231,  -586,
    -586,  -586,  -586,   232,  -586,  -586,  -586,   234,  -586,  -586,
    -586,   235,   239,  -586,  -586,  -586,  -586,   241,   267,   269,
     271,   273,  -586,   277,  -586,  -586,   280,  -586,   281,  -586,
    -586,   288,   291,  -586,  -586,  -586,  -586,  -586,  -586,  -586,
    -586,  -586,  -586,  -586,  -586,  -586,   292,  -586,  -586,  -586,
     293,   295,  -586,  -586,  -586,  -586,  -586,  -586,   296,  -586,
    -586,   297,  -586,  -586,  -586,   298,  -586,  -586,  -586,   299,
     300,   302,   303,  -586,  -586,  -586,   304,   305,  -586,  -586,
     308,   310,   311,  -118,  -586,  -586,  -586,  1873,   869,   248,
     387,   388,   403,   407,   408,   315,   316,  -586,  -586,  -586,
    -586,    79,   317,   319,  -586,  -586,  -586,  -586,  -586,    -1,
    -586,  -586,  -586,   333,   322,  -586,  -586,  -586,  -586,  -586,
    -586,  -586,  -586,  -586,  -586,  -586,  -586,    79,    79,  -586,
     318,  -134,  -586,  -586,  -586,     4,  -586,  -586,  -586,   411,
     321,  -586,  -586,  -586,  -117,  -586,  -586,   532,   323,  -133,
    -586,   350,   326,  -586,   330,  -586,   536,   135,   426,   730,
     135,   730,   537,   539,   730,   730,   541,   542,   730,   548,
     730,   730,  2296,   730,   730,   550,     2,   551,   730,  2809,
     730,   730,  2809,   123,  2809,  2809,   135,   120,   552,  2809,
    2963,   353,  -586,   341,  -586,  -586,  -586,   352,  -586,   355,
    -586,  -586,  -586,    89,  2720,  -586,   357,  -586,  -586,  -586,
    -586,   357,   -90,  -586,  -586,  -121,  -586,   379,   -87,   369,
     373,  -586,  -586,  1251,    49,   370,  -586,   730,   490,  2296,
    -586,  -586,   378,  -586,  -586,    22,    51,  -586,   376,  -586,
     426,   380,   400,   375,  -586,   587,  -586,    56,   248,    66,
     382,  -586,  -586,   389,   390,  -586,  -586,  -586,  -586,  -586,
    -586,  -586,  -586,  -586,   386,  -586,   730,   730,   730,   730,
     730,   730,   625,  2463,   -46,  -586,   414,  2463,   391,   393,
    -586,   -33,   395,   396,   398,   399,   401,   402,   404,   381,
     406,  2720,    53,   410,   -31,  -586,  2463,   413,   422,   423,
     427,   424,   -28,  1910,   425,  -586,  -586,  -586,  -586,  -586,
     428,   430,   432,   433,   416,  -586,   434,   441,   443,  -586,
    2963,   586,  -586,  -586,  -586,    79,    89,    36,  -586,  1131,
    -586,   436,  2720,   449,  1609,   429,   569,  1371,    89,  -586,
    2720,  -586,  -586,  -586,  -586,   644,  -586,  2392,   450,   476,
    -586,  -586,  -586,  -586,  -586,  -586,  -586,   -13,  -586,  -586,
     500,  -586,  -586,   130,   730,  -586,    18,  -586,  2720,  -586,
     459,  -586,   463,  -586,   464,  -586,  -586,  -586,  2720,    23,
      23,    23,    23,    23,    23,  2303,   409,   730,   730,   676,
     730,   730,   730,   730,   730,   730,   730,   730,   730,   730,
     730,   730,   730,   730,   730,   730,   730,   678,   730,   730,
    -586,   730,  -586,  -586,   673,  -586,  -586,  -586,  -586,  -586,
    -586,  -586,  -586,  -586,  -586,    53,  -586,  1985,  -586,    53,
    -586,  -586,  -586,    -4,  -586,   730,  -586,  -586,  -586,  -586,
     730,  -586,  -586,  -586,  -586,  -586,  -586,  -586,  -586,   684,
    -586,  -586,  -586,  -586,   469,  -586,  -586,   506,  -586,  -586,
    -586,  -586,    79,   223,  -586,  -586,  2720,   484,  -586,  -586,
    -586,    89,  -586,  -586,  -586,  -586,  2207,   411,    22,  -586,
     492,   491,   500,  -586,  -586,  -586,  -586,    53,   493,   426,
    -586,  -586,   409,  -586,  -586,  2118,  -586,   409,  -586,   496,
      12,   546,   546,  -586,   693,   693,   243,   243,  2329,  1529,
    1978,   225,   860,    92,   243,   243,   163,   163,    23,    23,
      23,  -586,  2414,  -586,   501,  -586,  -586,    41,  -586,   502,
      53,   504,  -586,  2296,  -586,  -586,   505,  -586,    89,  1000,
      79,  -586,  -586,  1491,  -586,  -586,  -586,  -586,  -586,   703,
    -586,  -586,   525,  -586,   -63,  -586,   510,  -586,   507,   385,
    -586,   509,    53,   514,  -586,   730,  2296,  -586,   730,  -586,
    -586,  -586,    41,  -586,  -586,  -586,   515,  -586,  -586,  -586,
    -586,    89,   518,   730,  -586,    53,  -586,  -586,  -586,  -586,
      41,  -586,  -586,  -586,    23,   519,  2463,  -586,  -586,  -586,
    -586,  -586,  -586,    -8,  -586,  -586,   730,   543,  -586,  -586,
     558,    43,    43,  -586,  -586,   538,  -586,  -586
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       5,     0,     3,     1,    35,   292,     0,   407,   275,   267,
     286,     0,   331,     0,     0,   274,   262,   276,   327,   273,
     277,   278,     0,   330,   280,   287,   288,   285,     0,   278,
       0,     0,   329,     0,   278,     0,   282,   328,   262,   262,
     272,   391,   268,    76,     2,    14,    36,     0,    30,    15,
      33,    15,    13,     0,    69,   394,     0,   393,   269,   392,
       0,     0,    11,     0,     0,     0,    28,     0,   313,     9,
       8,     0,    12,   336,   336,   336,     0,     0,   396,   336,
       0,   398,   293,     0,     4,   407,     0,   295,   296,     0,
     304,   305,   395,   264,     0,   279,   284,     0,   315,   316,
     283,   299,   300,     0,     0,   281,   270,   397,     0,   399,
       0,   271,    77,     0,    79,    80,     0,    81,    82,    83,
       0,     0,    86,    87,    88,    89,    90,    91,     0,    93,
      94,    95,    96,     0,    98,    99,   100,     0,   102,   103,
     104,     0,     0,   107,   108,   109,   110,     0,     0,     0,
       0,     0,   116,     0,   118,   119,     0,   121,     0,   123,
     124,   127,     0,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,     0,   142,   143,   144,
       0,     0,   147,   148,   149,   150,   389,   151,     0,   153,
     387,     0,   155,   156,   157,     0,   159,   160,   161,     0,
       0,     0,     0,   166,   388,   167,     0,     0,   171,   172,
       0,     0,     0,     0,    71,   176,    31,    68,    68,    68,
     262,     0,     0,   262,   262,     0,   394,   297,   306,   317,
     325,     0,   396,   398,    32,    10,   301,     6,   322,     0,
      29,   320,   321,     0,     0,    26,   340,   337,   339,   338,
     265,   266,   179,   180,   181,   182,   332,     0,     0,   344,
     380,   343,   259,   394,   396,   336,   398,   334,    34,     0,
       0,   419,   418,   420,     0,   415,   408,     0,     0,    68,
      50,     0,     0,   245,     0,   251,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   198,     0,     0,     0,     0,     0,
     198,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      76,    70,    51,     0,    23,    24,    25,     0,    21,     0,
      19,    16,    22,    28,     0,    69,   395,    53,    54,   323,
     324,   397,   399,    55,   258,    68,     5,     0,    68,     0,
       0,   314,    26,    68,     0,     0,   342,     0,     0,    57,
     346,   335,     0,   289,   294,     0,     0,   414,     0,    49,
       0,     0,   189,   194,   190,     0,   400,    68,    68,    68,
       0,   178,   177,     0,     0,   209,   200,   201,   202,   206,
     207,   208,   203,   204,     0,   205,     0,     0,     0,     0,
       0,     0,     0,   243,     0,   241,     0,   244,     0,     0,
      74,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   365,     0,     0,   196,   199,     0,     0,     0,
       0,     0,     0,     0,     0,   382,   383,   384,   385,   386,
       0,     0,     0,     0,   404,   406,     0,     0,     0,    72,
      76,     0,    20,    17,    56,     0,    28,     0,   302,    68,
     307,     0,     0,     0,     0,     0,     0,    68,    28,    27,
      69,   333,   341,   345,   381,     0,    67,     0,     0,    61,
      58,    59,   290,   425,   423,   426,   424,     0,   421,   416,
     409,   192,   195,    68,     0,    38,     0,   390,     0,   246,
       0,   402,    69,   252,     0,    78,   170,    84,     0,   233,
     232,   231,   234,   229,   230,     0,   353,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      85,     0,    97,   101,     0,   105,   106,   111,   112,   113,
     114,   115,   117,   120,   122,   365,   332,    57,   370,   365,
     367,   366,    64,   362,   126,   198,   125,   141,   145,   146,
       0,   154,   158,   162,   163,   165,   164,   168,   169,     0,
     173,   174,   175,    73,     0,    15,   373,   401,   298,   303,
       7,   309,     0,   396,   308,   311,     0,     0,   257,   312,
      26,    28,   326,    66,    65,   347,     0,     0,     0,   417,
     413,     0,   409,   191,   193,    39,    37,     0,   398,   260,
     250,   249,   353,   240,   332,    57,   357,   353,   354,     0,
     350,   222,   223,   235,   216,   217,   220,   221,   211,   212,
       0,   213,   214,   215,   219,   218,   225,   224,   227,   228,
     226,   236,     0,   242,     0,    75,    63,   365,   332,     0,
     365,     0,   361,    57,   369,   197,     0,   405,    28,    68,
       0,   255,   310,    68,   318,    62,    60,   291,   422,     0,
     412,   410,   375,   378,     0,   248,     0,   261,     0,   353,
     332,     0,   365,     0,   349,     0,    57,   356,     0,   239,
      92,   360,   365,   371,   364,   368,     0,   152,    52,    18,
     374,    28,     0,     0,   377,     0,   247,   183,   238,   348,
     365,   358,   352,   355,   237,     0,   210,   363,   372,   319,
     411,   376,   379,     0,   351,   359,     0,     0,   403,   184,
       0,    68,    68,   254,   186,     0,   185,   253
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -586,  -586,  -586,   405,  -586,   -47,  -586,  -338,  -316,     0,
    -586,  -586,  -586,  -586,  -586,   284,  -586,  -586,  -586,    10,
    -492,  -586,  -586,  -271,  -251,  -213,    -2,  -586,  -586,  -300,
    -143,   -68,  -586,  -586,  -586,  -586,  -586,   260,    13,   444,
     193,  -204,  -586,  -255,  -283,  -586,  -586,  -586,  -586,    26,
    -263,  -586,   301,  -586,   -10,   -71,  -586,   110,   142,   152,
    -586,   517,  -586,     5,  -586,    11,    17,  -586,  -586,   707,
    -586,  -586,  -586,  -586,  -586,   -38,  -586,    19,    16,  -586,
    -586,    20,  -586,  -586,  -324,  -522,   -53,   -11,   -37,  -234,
    -586,  -586,  -586,  -552,  -586,  -585,  -586,  -170,  -586,  -586,
    -586,    42,  -586,   531,  -586,   457,     1,   -42,  -586,     7,
    -586,   679,   157,  -586,  -586,   156,  -586,   412,  -586,   165
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,    44,     2,   346,   217,   585,   353,   241,   324,
      46,   496,    47,    48,    49,    50,   325,   225,    51,   326,
     478,   479,   480,   481,   558,    53,   335,   213,   411,   214,
     383,   559,   733,   739,   371,   372,   373,   374,   263,   424,
     425,   403,   404,   405,   408,   377,   499,   503,   379,   744,
     745,   597,    56,   686,    94,   560,    57,    96,    58,   364,
     607,    59,   269,   327,    61,   328,   329,   345,   458,    64,
      65,   348,   464,    66,   244,    67,    68,   330,   331,   230,
      71,   332,    73,    74,    75,   354,    76,   246,    77,   260,
     261,   628,   693,   629,   630,   561,   661,   562,   563,   587,
     714,   683,   684,   262,   440,   215,   264,    79,    80,   266,
     446,    84,   611,   612,    85,    86,   274,   275,   487,   488
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      54,   231,    45,    78,   218,   259,   334,    60,   258,    81,
     360,   412,    52,    62,   467,    55,   229,   454,    70,    63,
     449,    69,    72,   355,   356,   615,  -413,   461,   108,   110,
     471,   420,   682,   736,   657,   265,   247,   247,   247,     3,
     413,   519,   247,   416,   250,   418,   251,   737,   423,   483,
    -263,    12,   250,   430,   251,   232,   250,   101,   251,   227,
     102,   233,   282,   248,   249,   659,   370,   226,   267,   284,
     688,   320,   366,  -263,   474,   694,   358,    43,    18,   270,
    -187,   359,   250,   252,   251,   463,   484,   407,    12,    43,
     407,   252,   456,   321,   367,   252,    12,   419,    14,  -263,
     426,   -45,   689,    23,    28,   271,   426,   433,   517,   518,
     519,   520,   521,   522,   523,   500,   504,   253,   285,   272,
     472,   252,  -263,    43,   273,   253,   715,   444,   445,   253,
     682,    83,   457,   691,   347,   462,   702,   719,    89,   100,
     588,    28,   186,   539,   105,   381,   190,   406,   382,    32,
     583,   716,   602,   407,   477,   253,   544,    87,   565,    88,
     259,   565,    37,   258,   498,   462,   462,    90,   720,    91,
     540,   706,   254,   443,   204,   485,   608,   106,    95,    82,
     254,   519,   111,   545,   254,   566,   259,   259,   572,   258,
     258,    97,   509,   510,   511,   512,   513,   514,   515,   103,
     255,   349,   216,   609,   725,   738,   358,   219,   255,   486,
     254,   663,   255,   108,   110,    54,    54,   384,    78,    78,
     -40,   586,   358,   104,    81,    81,   236,   696,   247,   234,
      55,    55,   537,   538,   616,   235,   237,    10,   255,   614,
     556,   517,   518,   519,   520,   521,   522,   523,   256,   422,
     243,   358,   556,    43,   361,   277,   557,   743,   654,   517,
     518,   519,   673,   358,   257,   626,    43,   431,   557,   497,
     434,   512,   441,   442,   238,   239,    43,   448,   256,   501,
     370,   455,    21,   259,   653,   674,   258,   530,   531,   532,
     533,   534,   535,   536,   257,    24,    25,    26,    27,   491,
     421,   537,   538,   240,   242,    29,   422,   435,   436,   437,
     438,   439,   664,   631,   632,   666,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   471,   652,   676,   350,   407,     5,     6,
      43,   245,    92,  -188,    93,    34,    98,   -42,    99,   516,
      36,   470,   708,   469,    78,   268,   278,   421,   671,   -44,
      81,   426,   534,   535,   536,   471,    55,   107,   555,    93,
     279,   626,   537,   538,   280,   281,   626,   502,   471,   697,
     109,  -263,    93,   -41,   259,   656,  -263,   258,   -43,   662,
     336,   337,    93,   338,   283,   729,   471,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   339,   286,   340,   592,
     341,   342,    93,    93,   362,   287,   363,   231,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   252,   288,   250,
     731,   251,    12,   289,   537,   538,   710,  -256,   626,  -256,
     532,   533,   534,   535,   536,   617,   290,   291,   627,   292,
     293,   252,   537,   538,   294,   622,   295,    54,    43,    45,
      78,   253,   596,   593,    60,   470,    81,   469,    78,    52,
      62,   232,    55,   589,    81,    70,    63,   233,    69,    72,
      55,   740,   296,   226,   297,   253,   298,   701,   299,   660,
     704,   724,   300,   385,   726,   301,   302,   386,   387,   388,
     389,   390,   391,   303,   422,   618,   304,   305,   306,   407,
     307,   308,   309,   310,   311,   312,   254,   313,   314,   315,
     316,   259,   722,   317,   258,   318,   319,   343,   462,   462,
     -46,   -47,   727,   -48,   352,   357,   365,   368,   669,   369,
     254,   375,   376,   231,   255,   378,   380,   409,   687,   410,
     734,   414,   415,   422,   627,   421,   451,   692,   417,   627,
     427,   429,   447,   450,   519,   392,   452,   453,   255,  -263,
     460,   526,   422,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   465,   624,   466,   473,   482,   490,   493,
     537,   538,   494,   492,   495,   358,   584,   553,   505,   259,
     625,   508,   258,   541,   421,   506,   507,   542,   624,   543,
     422,   546,   547,   393,   548,   549,   570,   550,   551,   358,
     552,   627,   554,   421,   625,   579,   564,   591,   385,   567,
       5,     6,   386,   387,   388,   389,   390,   391,   568,   569,
     571,   574,   599,   422,   575,   394,   576,   385,   577,   578,
     580,   386,   387,   388,   389,   390,   391,   581,   395,   582,
       8,   421,     9,   594,    22,   606,   605,    54,    10,   610,
      78,   470,    12,   469,    78,   619,    81,   620,   621,   633,
      81,   651,    55,   655,   396,   668,    55,   397,   398,   475,
      15,   667,   400,   401,   421,   670,   220,    17,   672,    18,
     392,   476,    83,    19,   680,   402,    20,   685,   712,   517,
     518,   519,   695,    21,   522,   523,   713,   700,   703,   392,
     705,   707,   717,   718,    23,   721,    24,    25,    26,    27,
     723,   728,   730,   385,   741,   735,    29,   386,   387,   388,
     389,   390,   391,   532,   533,   534,   535,   536,   393,   742,
     600,   459,   747,   613,   432,   537,   538,   732,   665,   677,
     351,   228,   344,   428,   276,   598,   679,   393,   746,   681,
      32,     0,     0,   678,     0,    33,    34,    35,   489,     0,
     394,    36,     0,    37,     0,     0,     0,   223,     0,     0,
       0,     0,     0,   395,     0,     0,   224,     0,    40,   394,
       0,     0,     0,     0,     0,   392,    41,    42,     0,     0,
       0,     0,   395,     0,     0,     0,     0,     0,     0,   396,
       0,     0,   397,   398,   399,     0,     0,   400,   401,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   396,     0,
     402,   397,   398,   399,     0,     0,   400,   401,     0,     0,
       0,     0,     0,   393,     0,   603,     0,     0,     0,   402,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     4,     5,     6,   517,   518,   519,   520,
     521,   522,   523,     0,     0,   394,     0,     0,   530,   531,
     532,   533,   534,   535,   536,     0,     0,     0,   395,     0,
       0,     0,   537,   538,     8,     0,     9,     0,     0,     0,
       0,     0,    10,    11,     0,     0,    12,     0,     0,     0,
       0,    13,     0,     0,   396,     0,     0,   397,   398,   399,
       0,    14,   400,   401,    15,     0,     0,     0,     0,     0,
      16,    17,     0,    18,     0,   402,     0,    19,     0,     0,
      20,     0,     0,     0,     0,     0,     0,    21,     0,     0,
       0,     0,     0,     0,    22,   323,     0,     0,    23,     0,
      24,    25,    26,    27,    28,     0,     0,     0,     0,     0,
      29,     0,     0,     0,     0,    30,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    31,     0,     4,     5,     6,     0,     0,     0,
       0,     0,     0,     0,    32,     0,     0,     0,     0,    33,
      34,    35,     0,     0,     0,    36,     0,    37,     0,     0,
       0,    38,     0,     0,     0,     8,     0,     9,     0,     0,
      39,     0,    40,    10,    11,     0,     0,    12,     0,     0,
      41,    42,    13,     0,   529,   530,   531,   532,   533,   534,
     535,   536,    14,     0,     0,    15,     0,     0,     0,   537,
     538,    16,    17,     0,    18,     0,     0,     0,    19,    43,
       0,    20,   333,     0,     0,     0,     0,     0,    21,     0,
       0,     0,     0,     0,     0,    22,   323,     0,     0,    23,
       0,    24,    25,    26,    27,    28,     0,     0,     0,     0,
       0,    29,     0,     0,     0,     0,    30,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    31,     0,     4,     5,     6,     0,     0,
       0,     0,     0,     0,     0,    32,     0,     0,     0,     0,
      33,    34,    35,     0,     0,     0,    36,     0,    37,     0,
       0,     0,    38,     0,     0,     0,     8,     0,     9,     0,
       0,    39,     0,    40,    10,    11,     0,     0,    12,     0,
       0,    41,    42,    13,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    14,     0,     0,    15,     0,     0,     0,
       0,     0,    16,    17,     0,    18,     0,     0,     0,    19,
      43,     0,    20,   709,     0,     0,     0,     0,     0,    21,
       0,     0,     0,     0,     0,     0,    22,     0,     0,     0,
      23,     0,    24,    25,    26,    27,    28,     0,     0,     0,
       0,     0,    29,     0,     0,     0,     0,    30,     0,     0,
       0,     0,     0,     0,     0,     4,     5,     6,     0,     0,
       0,     0,     0,     0,    31,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    32,     0,     0,     0,
       0,    33,    34,    35,     0,     0,     8,    36,     9,    37,
       0,     0,     0,    38,    10,     0,     0,     0,    12,     0,
       0,     0,    39,    13,    40,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,    15,     0,     0,     0,
       0,     0,    16,    17,     0,    18,     0,     0,     0,    19,
       0,     0,    20,     0,     0,     0,     0,     0,     0,    21,
       0,    43,     0,     0,   590,     0,    22,     0,     0,     0,
      23,     0,    24,    25,    26,    27,     0,     0,     0,     0,
       0,     0,    29,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     4,     5,     6,     0,     0,
       0,     0,     0,     0,    31,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    32,     0,     0,     0,
       0,    33,    34,    35,     0,     0,     8,    36,     9,    37,
       0,     0,     0,    38,    10,     0,     0,     0,    12,     0,
       0,     0,    39,    13,    40,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,    15,     0,     0,     0,
       0,     0,    16,    17,     0,    18,     0,     0,     0,    19,
       0,     0,    20,     0,     0,     0,     0,     0,     0,    21,
       0,    43,     0,     0,   468,     0,    22,     0,     0,     0,
      23,     0,    24,    25,    26,    27,     0,     0,     0,     0,
       0,     0,    29,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     4,     5,     6,     0,     0,
       0,     0,     0,     0,    31,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    32,     0,     0,     0,
       0,    33,    34,    35,     0,     0,     8,    36,     9,    37,
       0,     0,     0,    38,    10,     0,     0,     0,    12,     0,
       0,     0,    39,    13,    40,   517,   518,   519,   520,   521,
     522,   523,    41,    42,     0,     0,    15,     0,     0,     0,
       0,     0,    16,    17,     0,    18,     0,     0,     0,    19,
       0,     0,    20,     0,     0,     0,     0,     0,     0,    21,
       0,    43,     0,     0,   601,     0,    22,     0,     0,     0,
      23,     0,    24,    25,    26,    27,     0,     0,     0,     0,
       0,     0,    29,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     5,     6,     0,     0,     0,     0,
       0,     0,     0,     0,    31,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    32,     0,     0,     0,
       0,    33,    34,    35,     8,     0,     9,    36,     0,    37,
       0,     0,    10,    38,     0,     0,    12,     0,     0,     0,
       0,     0,    39,     0,    40,     0,     0,     0,     0,     0,
       0,     0,    41,    42,    15,     0,     0,     0,     0,     0,
     220,    17,     0,    18,     0,     0,     0,    19,     0,     0,
      20,     0,     0,     0,     0,     0,     0,    21,     0,     0,
       0,    43,     0,     0,   711,     0,     0,     0,    23,     0,
      24,    25,    26,    27,     0,     0,     0,     0,     0,     0,
      29,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,     0,     0,     0,     0,     0,     0,     0,   537,   538,
       0,     0,     0,     0,     4,     5,     6,     0,     0,     0,
       0,     0,     0,     0,    32,     7,     0,     0,     0,    33,
      34,    35,     0,     0,     0,    36,     0,    37,     0,     0,
       0,   223,     0,     0,     0,     8,     0,     9,     0,     0,
     224,     0,    40,    10,    11,     0,     0,    12,     0,     0,
      41,    42,    13,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    14,     0,     0,    15,     0,     0,     0,     0,
       0,    16,    17,     0,    18,     0,     0,     0,    19,    43,
       0,    20,   595,     0,     0,     0,     0,     0,    21,     0,
       0,     0,     0,     0,     0,    22,     0,     0,     0,    23,
       0,    24,    25,    26,    27,    28,     0,     0,     0,     0,
       0,    29,     0,     0,     0,     0,    30,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    31,     0,     0,     0,     4,     5,     6,
       0,     0,     0,     0,     0,    32,     0,   322,     0,     0,
      33,    34,    35,     0,     0,     0,    36,     0,    37,     0,
       0,     0,    38,     0,     0,     0,     0,     0,     8,   -68,
       9,    39,     0,    40,     0,     0,    10,    11,     0,     0,
      12,    41,    42,     0,     0,    13,   517,   518,   519,   520,
     521,   522,   523,   524,   525,    14,     0,     0,    15,     0,
       0,     0,     0,     0,    16,    17,     0,    18,     0,     0,
      43,    19,     0,     0,    20,     0,     0,     0,     0,     0,
       0,    21,     0,     0,     0,     0,     0,     0,    22,   323,
       0,     0,    23,     0,    24,    25,    26,    27,    28,     0,
       0,     0,     0,     0,    29,     0,     0,     0,     0,    30,
       5,     6,     0,     0,   517,   518,   519,   520,   521,   522,
     523,   524,   525,     0,     0,     0,    31,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    32,     0,
       8,     0,     9,    33,    34,    35,     0,   252,    10,    36,
       0,    37,    12,     0,     0,    38,     0,     0,     0,     0,
       0,     0,     0,     0,    39,     0,    40,     0,     0,     0,
      15,     0,     0,     0,    41,    42,   220,    17,     0,    18,
       0,   253,     0,    19,     0,     0,    20,     0,     0,     0,
       0,     0,     0,    21,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    43,    23,     0,    24,    25,    26,    27,
       0,     0,     0,     0,     0,     0,    29,     0,     0,     0,
     526,     0,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,     0,     0,     0,     0,   254,     0,     0,   537,
     538,     0,     0,     5,     6,     0,   573,     0,     0,     0,
      32,     0,     0,     0,     0,    33,    34,    35,     0,     0,
       0,    36,     0,    37,   255,     0,     0,   223,     0,     0,
       0,     0,     0,     8,     0,     9,   224,     0,    40,     0,
     252,    10,     0,     0,     0,    12,    41,    42,   526,   698,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
       0,     0,     0,    15,   658,     0,     0,   537,   538,   220,
      17,     0,    18,     0,   253,    43,    19,     0,     0,    20,
       0,     0,     0,     0,     0,     0,    21,     0,     0,     0,
       0,     0,     5,     6,     0,     0,     0,    23,     0,    24,
      25,    26,    27,     0,     0,     0,     0,     0,     0,    29,
       0,     0,   675,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     8,     0,     9,     0,     0,     0,     0,   254,
      10,     0,     0,     0,    12,     0,     0,     0,     0,     0,
       0,     0,     0,    32,     0,     0,     0,     0,    33,    34,
      35,     0,    15,     0,    36,     0,    37,   255,   220,    17,
     223,    18,     0,     0,     0,    19,     0,     0,    20,   224,
       0,    40,     0,     0,     0,    21,     0,     0,     0,    41,
      42,     5,     6,     0,     0,     0,    23,     0,    24,    25,
      26,    27,     0,     0,     0,     0,     0,   690,    29,   517,
     518,   519,   520,   521,   522,   523,   524,   525,    43,     0,
       0,     8,     0,     9,     0,     0,     0,     0,     0,    10,
       0,     0,     0,    12,     0,   517,   518,   519,   520,   521,
     522,   523,    32,   525,     0,     0,     0,    33,    34,    35,
       0,    15,     0,    36,     0,    37,     0,   220,    17,   223,
      18,     0,     0,     0,    19,     0,     0,    20,   224,     0,
      40,     0,     0,     0,    21,     0,     0,     0,    41,    42,
       0,     0,     0,     0,     0,    23,     0,    24,    25,    26,
      27,     0,     0,     0,     0,     0,     0,    29,   517,   518,
     519,   520,   521,   522,   523,   524,   525,    43,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     517,   518,   519,   520,   521,   522,   523,   524,   525,     0,
       0,    32,     0,     0,     0,     0,    33,    34,    35,     0,
       0,     0,    36,     0,    37,     0,     0,     0,   223,     0,
       0,     0,     0,     0,     0,     0,     0,   224,     0,    40,
       0,     0,     0,     0,     0,     0,     0,    41,    42,   517,
     518,   519,   520,   521,   522,   523,   524,   525,     0,     0,
       0,     0,     0,   526,     0,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,     0,    43,     0,     0,     0,
       0,     0,   537,   538,     0,     0,     0,     0,     0,   623,
       0,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,     0,     0,     0,     0,     0,     0,     0,   537,   538,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   526,     0,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,     0,     0,     0,     0,     0,     0,
       0,   537,   538,   604,   526,     0,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,     0,     0,     0,     0,
       0,     0,     0,   537,   538,   699,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     5,     6,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   526,     0,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,     0,     8,     0,     9,     0,
       0,     0,   537,   538,    10,    11,     0,     0,    12,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    14,     0,     0,    15,     0,     0,     0,
       0,     0,   220,    17,     0,    18,     0,     0,     0,    19,
       0,     0,    20,     0,     0,     0,     0,     0,     0,    21,
       0,     0,     0,     0,     0,     5,     6,     0,     0,     0,
      23,     0,    24,    25,    26,    27,    28,     0,     0,   221,
       0,     0,    29,     0,     0,     0,   222,     0,     0,     0,
       0,     0,     0,     0,     0,     8,     0,     9,     0,     0,
       0,     0,     0,    10,     0,     0,     0,    12,     0,     0,
       0,     0,     0,     0,     0,     0,    32,     0,     0,     0,
       0,    33,    34,    35,     0,    15,     0,    36,     0,    37,
       0,   220,    17,   223,    18,     0,     0,     0,    19,     0,
       0,    20,   224,     0,    40,     0,     0,     0,    21,     0,
       0,     0,    41,    42,     5,     6,     0,     0,     0,    23,
       0,    24,    25,    26,    27,     0,     0,     0,     0,     0,
       0,    29,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     8,     0,     9,     0,     0,     0,
       0,     0,    10,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    32,     0,     0,     0,     0,
      33,    34,    35,     0,    15,     0,    36,     0,    37,     0,
     220,    17,   223,     0,     0,     0,     0,    19,     0,     0,
      20,   224,     0,    40,     0,     0,     0,    21,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
      24,    25,    26,    27,     0,     0,     0,     0,     0,     0,
      29,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    33,
      34,    35,     0,     0,     0,    36,     0,     0,     0,     0,
       0,   223,     0,     0,     0,     0,     0,     0,     0,     0,
     224,     0,    40,     0,     0,     0,     0,     0,     0,   112,
      41,    42,   113,   114,   115,   116,   117,   118,     0,   119,
       0,     0,   120,     0,   121,     0,     0,     0,   122,   123,
       0,   124,   125,   126,   127,     0,   128,   129,   130,   131,
     132,   133,   134,   135,   136,     0,   137,     0,     0,   138,
     139,   140,   141,   142,     0,     0,   143,     0,     0,     0,
     144,     0,   145,   146,     0,   147,   148,   149,   150,   151,
     152,     0,   153,   154,   155,   156,   157,   158,     0,     0,
     159,     0,     0,   160,     0,     0,     0,     0,     0,   161,
     162,     0,   163,   164,     0,   165,   166,     0,     0,     0,
     167,   168,   169,   170,   171,   172,     0,   173,   174,   175,
     176,   177,   178,   179,     0,   180,     0,   181,     0,   182,
     183,   184,   185,   186,   187,   188,   189,   190,     0,   191,
     192,   193,   194,     0,     0,     0,     0,   195,     0,     0,
     196,     0,     0,   197,   198,     0,     0,   199,   200,   201,
     202,     0,     0,   203,     0,   204,     0,   205,   206,   207,
     208,   209,   210,   211,     0,     0,   212
};

static const yytype_int16 yycheck[] =
{
       2,    54,     2,     2,    51,    76,   219,     2,    76,     2,
     261,   294,     2,     2,   352,     2,    54,   333,     2,     2,
     320,     2,     2,   257,   258,     7,   105,   114,    38,    39,
     354,   302,   617,    41,   556,    77,    73,    74,    75,     0,
     295,    18,    79,   298,     3,   300,     5,    55,   303,    27,
     163,    47,     3,   308,     5,    54,     3,     3,     5,    54,
       6,    54,   104,    74,    75,   557,   279,    54,    79,   163,
     622,   189,   189,   163,   357,   627,   210,   210,    74,    28,
     213,   215,     3,    42,     5,   348,    64,   291,    47,   210,
     294,    42,   213,   211,   211,    42,    47,   301,    62,   212,
     304,   214,   624,    99,   105,    54,   310,   311,    16,    17,
      18,    19,    20,    21,    22,   378,   379,    76,   212,    68,
     354,    42,   212,   210,    73,    76,   189,     7,     8,    76,
     715,   210,   345,   625,   135,   348,   658,   689,   215,    29,
     456,   105,   140,   189,    34,    10,   144,   290,    13,   145,
     450,   214,   468,   357,   358,    76,   189,     3,   189,     5,
     231,   189,   158,   231,   377,   378,   379,     3,   690,     5,
     216,   663,   131,   316,   172,   153,   189,    35,   101,   209,
     131,    18,    40,   216,   131,   216,   257,   258,   216,   257,
     258,    10,   396,   397,   398,   399,   400,   401,   402,   215,
     159,   239,   214,   216,   696,   213,   210,   169,   159,   187,
     131,   215,   159,   223,   224,   217,   218,   288,   217,   218,
     214,   455,   210,   215,   217,   218,   212,   215,   265,   214,
     217,   218,   209,   210,   216,   214,   212,    43,   159,   494,
     199,    16,    17,    18,    19,    20,    21,    22,   199,   302,
     191,   210,   199,   210,   265,   105,   215,   214,   541,    16,
      17,    18,   600,   210,   215,   516,   210,   309,   215,   213,
     312,   475,   314,   315,   214,   212,   210,   319,   199,   213,
     493,   334,    88,   354,   539,   601,   354,   195,   196,   197,
     198,   199,   200,   201,   215,   101,   102,   103,   104,   370,
     302,   209,   210,   214,   214,   111,   359,   184,   185,   186,
     187,   188,   563,   517,   518,   570,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   657,   538,   606,     3,   541,     5,     6,
     210,   212,     3,   213,     5,   151,     3,   214,     5,   402,
     156,   353,   668,   353,   353,   214,    10,   359,   592,   214,
     353,   565,   199,   200,   201,   689,   353,     3,   421,     5,
     212,   622,   209,   210,   214,     3,   627,   379,   702,   630,
       3,   212,     5,   214,   455,   555,   212,   455,   214,   559,
       3,     3,     5,     5,   212,   711,   720,    16,    17,    18,
      19,    20,    21,    22,    23,    24,     3,   215,     5,   462,
       3,     3,     5,     5,     3,   215,     5,   470,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    42,   215,     3,
     713,     5,    47,   215,   209,   210,   670,   214,   689,   216,
     197,   198,   199,   200,   201,   498,   215,   215,   516,   215,
     215,    42,   209,   210,   215,   508,   215,   459,   210,   459,
     459,    76,   464,   462,   459,   467,   459,   467,   467,   459,
     459,   470,   459,   457,   467,   459,   459,   470,   459,   459,
     467,   736,   215,   470,   215,    76,   215,   657,   215,   557,
     660,   695,   215,     3,   698,   215,   215,     7,     8,     9,
      10,    11,    12,   215,   557,   498,   215,   215,   215,   713,
     215,   215,   215,   215,   215,   215,   131,   215,   215,   215,
     215,   592,   692,   215,   592,   215,   215,   212,   741,   742,
     214,   214,   702,   214,   212,   217,   215,     5,   585,   216,
     131,   191,   216,   596,   159,   215,    10,    10,   619,    10,
     720,    10,    10,   606,   622,   557,   215,   625,    10,   627,
      10,    10,    10,   210,    18,    75,   214,   212,   159,   212,
     191,   190,   625,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   214,   199,   212,   216,   209,   212,   189,
     209,   210,   217,   213,     7,   210,    10,   216,   216,   670,
     215,   215,   670,   189,   606,   216,   216,   216,   199,   216,
     663,   216,   216,   123,   216,   216,   189,   216,   216,   210,
     216,   689,   216,   625,   215,   209,   216,   191,     3,   216,
       5,     6,     7,     8,     9,    10,    11,    12,   216,   216,
     216,   216,   213,   696,   216,   155,   216,     3,   216,   216,
     216,     7,     8,     9,    10,    11,    12,   216,   168,   216,
      35,   663,    37,   214,    95,   189,   216,   669,    43,   169,
     669,   673,    47,   673,   673,   216,   669,   214,   214,     3,
     673,     3,   669,    10,   194,   216,   673,   197,   198,   199,
      65,     7,   202,   203,   696,   189,    71,    72,   214,    74,
      75,   211,   210,    78,   213,   215,    81,   214,     5,    16,
      17,    18,   216,    88,    21,    22,   191,   216,   216,    75,
     216,   216,   212,   216,    99,   216,   101,   102,   103,   104,
     216,   216,   214,     3,   191,   216,   111,     7,     8,     9,
      10,    11,    12,   197,   198,   199,   200,   201,   123,   191,
     466,   346,   214,   493,   310,   209,   210,   715,   565,   607,
     243,    54,   231,   306,    85,   464,   610,   123,   742,   612,
     145,    -1,    -1,   608,    -1,   150,   151,   152,   366,    -1,
     155,   156,    -1,   158,    -1,    -1,    -1,   162,    -1,    -1,
      -1,    -1,    -1,   168,    -1,    -1,   171,    -1,   173,   155,
      -1,    -1,    -1,    -1,    -1,    75,   181,   182,    -1,    -1,
      -1,    -1,   168,    -1,    -1,    -1,    -1,    -1,    -1,   194,
      -1,    -1,   197,   198,   199,    -1,    -1,   202,   203,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   194,    -1,
     215,   197,   198,   199,    -1,    -1,   202,   203,    -1,    -1,
      -1,    -1,    -1,   123,    -1,   211,    -1,    -1,    -1,   215,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     4,     5,     6,    16,    17,    18,    19,
      20,    21,    22,    -1,    -1,   155,    -1,    -1,   195,   196,
     197,   198,   199,   200,   201,    -1,    -1,    -1,   168,    -1,
      -1,    -1,   209,   210,    35,    -1,    37,    -1,    -1,    -1,
      -1,    -1,    43,    44,    -1,    -1,    47,    -1,    -1,    -1,
      -1,    52,    -1,    -1,   194,    -1,    -1,   197,   198,   199,
      -1,    62,   202,   203,    65,    -1,    -1,    -1,    -1,    -1,
      71,    72,    -1,    74,    -1,   215,    -1,    78,    -1,    -1,
      81,    -1,    -1,    -1,    -1,    -1,    -1,    88,    -1,    -1,
      -1,    -1,    -1,    -1,    95,    96,    -1,    -1,    99,    -1,
     101,   102,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,
     111,    -1,    -1,    -1,    -1,   116,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   133,    -1,     4,     5,     6,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   145,    -1,    -1,    -1,    -1,   150,
     151,   152,    -1,    -1,    -1,   156,    -1,   158,    -1,    -1,
      -1,   162,    -1,    -1,    -1,    35,    -1,    37,    -1,    -1,
     171,    -1,   173,    43,    44,    -1,    -1,    47,    -1,    -1,
     181,   182,    52,    -1,   194,   195,   196,   197,   198,   199,
     200,   201,    62,    -1,    -1,    65,    -1,    -1,    -1,   209,
     210,    71,    72,    -1,    74,    -1,    -1,    -1,    78,   210,
      -1,    81,   213,    -1,    -1,    -1,    -1,    -1,    88,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    -1,    -1,    99,
      -1,   101,   102,   103,   104,   105,    -1,    -1,    -1,    -1,
      -1,   111,    -1,    -1,    -1,    -1,   116,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   133,    -1,     4,     5,     6,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   145,    -1,    -1,    -1,    -1,
     150,   151,   152,    -1,    -1,    -1,   156,    -1,   158,    -1,
      -1,    -1,   162,    -1,    -1,    -1,    35,    -1,    37,    -1,
      -1,   171,    -1,   173,    43,    44,    -1,    -1,    47,    -1,
      -1,   181,   182,    52,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    62,    -1,    -1,    65,    -1,    -1,    -1,
      -1,    -1,    71,    72,    -1,    74,    -1,    -1,    -1,    78,
     210,    -1,    81,   213,    -1,    -1,    -1,    -1,    -1,    88,
      -1,    -1,    -1,    -1,    -1,    -1,    95,    -1,    -1,    -1,
      99,    -1,   101,   102,   103,   104,   105,    -1,    -1,    -1,
      -1,    -1,   111,    -1,    -1,    -1,    -1,   116,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     4,     5,     6,    -1,    -1,
      -1,    -1,    -1,    -1,   133,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   145,    -1,    -1,    -1,
      -1,   150,   151,   152,    -1,    -1,    35,   156,    37,   158,
      -1,    -1,    -1,   162,    43,    -1,    -1,    -1,    47,    -1,
      -1,    -1,   171,    52,   173,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   181,   182,    -1,    -1,    65,    -1,    -1,    -1,
      -1,    -1,    71,    72,    -1,    74,    -1,    -1,    -1,    78,
      -1,    -1,    81,    -1,    -1,    -1,    -1,    -1,    -1,    88,
      -1,   210,    -1,    -1,   213,    -1,    95,    -1,    -1,    -1,
      99,    -1,   101,   102,   103,   104,    -1,    -1,    -1,    -1,
      -1,    -1,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     4,     5,     6,    -1,    -1,
      -1,    -1,    -1,    -1,   133,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   145,    -1,    -1,    -1,
      -1,   150,   151,   152,    -1,    -1,    35,   156,    37,   158,
      -1,    -1,    -1,   162,    43,    -1,    -1,    -1,    47,    -1,
      -1,    -1,   171,    52,   173,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   181,   182,    -1,    -1,    65,    -1,    -1,    -1,
      -1,    -1,    71,    72,    -1,    74,    -1,    -1,    -1,    78,
      -1,    -1,    81,    -1,    -1,    -1,    -1,    -1,    -1,    88,
      -1,   210,    -1,    -1,   213,    -1,    95,    -1,    -1,    -1,
      99,    -1,   101,   102,   103,   104,    -1,    -1,    -1,    -1,
      -1,    -1,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     4,     5,     6,    -1,    -1,
      -1,    -1,    -1,    -1,   133,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   145,    -1,    -1,    -1,
      -1,   150,   151,   152,    -1,    -1,    35,   156,    37,   158,
      -1,    -1,    -1,   162,    43,    -1,    -1,    -1,    47,    -1,
      -1,    -1,   171,    52,   173,    16,    17,    18,    19,    20,
      21,    22,   181,   182,    -1,    -1,    65,    -1,    -1,    -1,
      -1,    -1,    71,    72,    -1,    74,    -1,    -1,    -1,    78,
      -1,    -1,    81,    -1,    -1,    -1,    -1,    -1,    -1,    88,
      -1,   210,    -1,    -1,   213,    -1,    95,    -1,    -1,    -1,
      99,    -1,   101,   102,   103,   104,    -1,    -1,    -1,    -1,
      -1,    -1,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     5,     6,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   133,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   145,    -1,    -1,    -1,
      -1,   150,   151,   152,    35,    -1,    37,   156,    -1,   158,
      -1,    -1,    43,   162,    -1,    -1,    47,    -1,    -1,    -1,
      -1,    -1,   171,    -1,   173,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   181,   182,    65,    -1,    -1,    -1,    -1,    -1,
      71,    72,    -1,    74,    -1,    -1,    -1,    78,    -1,    -1,
      81,    -1,    -1,    -1,    -1,    -1,    -1,    88,    -1,    -1,
      -1,   210,    -1,    -1,   213,    -1,    -1,    -1,    99,    -1,
     101,   102,   103,   104,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   209,   210,
      -1,    -1,    -1,    -1,     4,     5,     6,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   145,    15,    -1,    -1,    -1,   150,
     151,   152,    -1,    -1,    -1,   156,    -1,   158,    -1,    -1,
      -1,   162,    -1,    -1,    -1,    35,    -1,    37,    -1,    -1,
     171,    -1,   173,    43,    44,    -1,    -1,    47,    -1,    -1,
     181,   182,    52,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    62,    -1,    -1,    65,    -1,    -1,    -1,    -1,
      -1,    71,    72,    -1,    74,    -1,    -1,    -1,    78,   210,
      -1,    81,   213,    -1,    -1,    -1,    -1,    -1,    88,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    -1,    -1,    -1,    99,
      -1,   101,   102,   103,   104,   105,    -1,    -1,    -1,    -1,
      -1,   111,    -1,    -1,    -1,    -1,   116,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   133,    -1,    -1,    -1,     4,     5,     6,
      -1,    -1,    -1,    -1,    -1,   145,    -1,    14,    -1,    -1,
     150,   151,   152,    -1,    -1,    -1,   156,    -1,   158,    -1,
      -1,    -1,   162,    -1,    -1,    -1,    -1,    -1,    35,   169,
      37,   171,    -1,   173,    -1,    -1,    43,    44,    -1,    -1,
      47,   181,   182,    -1,    -1,    52,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    62,    -1,    -1,    65,    -1,
      -1,    -1,    -1,    -1,    71,    72,    -1,    74,    -1,    -1,
     210,    78,    -1,    -1,    81,    -1,    -1,    -1,    -1,    -1,
      -1,    88,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,
      -1,    -1,    99,    -1,   101,   102,   103,   104,   105,    -1,
      -1,    -1,    -1,    -1,   111,    -1,    -1,    -1,    -1,   116,
       5,     6,    -1,    -1,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    -1,    -1,    -1,   133,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   145,    -1,
      35,    -1,    37,   150,   151,   152,    -1,    42,    43,   156,
      -1,   158,    47,    -1,    -1,   162,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   171,    -1,   173,    -1,    -1,    -1,
      65,    -1,    -1,    -1,   181,   182,    71,    72,    -1,    74,
      -1,    76,    -1,    78,    -1,    -1,    81,    -1,    -1,    -1,
      -1,    -1,    -1,    88,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   210,    99,    -1,   101,   102,   103,   104,
      -1,    -1,    -1,    -1,    -1,    -1,   111,    -1,    -1,    -1,
     190,    -1,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,    -1,    -1,    -1,    -1,   131,    -1,    -1,   209,
     210,    -1,    -1,     5,     6,    -1,   216,    -1,    -1,    -1,
     145,    -1,    -1,    -1,    -1,   150,   151,   152,    -1,    -1,
      -1,   156,    -1,   158,   159,    -1,    -1,   162,    -1,    -1,
      -1,    -1,    -1,    35,    -1,    37,   171,    -1,   173,    -1,
      42,    43,    -1,    -1,    -1,    47,   181,   182,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
      -1,    -1,    -1,    65,   199,    -1,    -1,   209,   210,    71,
      72,    -1,    74,    -1,    76,   210,    78,    -1,    -1,    81,
      -1,    -1,    -1,    -1,    -1,    -1,    88,    -1,    -1,    -1,
      -1,    -1,     5,     6,    -1,    -1,    -1,    99,    -1,   101,
     102,   103,   104,    -1,    -1,    -1,    -1,    -1,    -1,   111,
      -1,    -1,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    35,    -1,    37,    -1,    -1,    -1,    -1,   131,
      43,    -1,    -1,    -1,    47,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   145,    -1,    -1,    -1,    -1,   150,   151,
     152,    -1,    65,    -1,   156,    -1,   158,   159,    71,    72,
     162,    74,    -1,    -1,    -1,    78,    -1,    -1,    81,   171,
      -1,   173,    -1,    -1,    -1,    88,    -1,    -1,    -1,   181,
     182,     5,     6,    -1,    -1,    -1,    99,    -1,   101,   102,
     103,   104,    -1,    -1,    -1,    -1,    -1,   199,   111,    16,
      17,    18,    19,    20,    21,    22,    23,    24,   210,    -1,
      -1,    35,    -1,    37,    -1,    -1,    -1,    -1,    -1,    43,
      -1,    -1,    -1,    47,    -1,    16,    17,    18,    19,    20,
      21,    22,   145,    24,    -1,    -1,    -1,   150,   151,   152,
      -1,    65,    -1,   156,    -1,   158,    -1,    71,    72,   162,
      74,    -1,    -1,    -1,    78,    -1,    -1,    81,   171,    -1,
     173,    -1,    -1,    -1,    88,    -1,    -1,    -1,   181,   182,
      -1,    -1,    -1,    -1,    -1,    99,    -1,   101,   102,   103,
     104,    -1,    -1,    -1,    -1,    -1,    -1,   111,    16,    17,
      18,    19,    20,    21,    22,    23,    24,   210,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    -1,
      -1,   145,    -1,    -1,    -1,    -1,   150,   151,   152,    -1,
      -1,    -1,   156,    -1,   158,    -1,    -1,    -1,   162,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   171,    -1,   173,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   181,   182,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    -1,    -1,
      -1,    -1,    -1,   190,    -1,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   210,    -1,    -1,    -1,
      -1,    -1,   209,   210,    -1,    -1,    -1,    -1,    -1,   216,
      -1,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   209,   210,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   190,    -1,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   209,   210,   211,   190,    -1,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   209,   210,   211,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     5,     6,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   190,    -1,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,    35,    -1,    37,    -1,
      -1,    -1,   209,   210,    43,    44,    -1,    -1,    47,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    62,    -1,    -1,    65,    -1,    -1,    -1,
      -1,    -1,    71,    72,    -1,    74,    -1,    -1,    -1,    78,
      -1,    -1,    81,    -1,    -1,    -1,    -1,    -1,    -1,    88,
      -1,    -1,    -1,    -1,    -1,     5,     6,    -1,    -1,    -1,
      99,    -1,   101,   102,   103,   104,   105,    -1,    -1,   108,
      -1,    -1,   111,    -1,    -1,    -1,   115,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    35,    -1,    37,    -1,    -1,
      -1,    -1,    -1,    43,    -1,    -1,    -1,    47,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   145,    -1,    -1,    -1,
      -1,   150,   151,   152,    -1,    65,    -1,   156,    -1,   158,
      -1,    71,    72,   162,    74,    -1,    -1,    -1,    78,    -1,
      -1,    81,   171,    -1,   173,    -1,    -1,    -1,    88,    -1,
      -1,    -1,   181,   182,     5,     6,    -1,    -1,    -1,    99,
      -1,   101,   102,   103,   104,    -1,    -1,    -1,    -1,    -1,
      -1,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    35,    -1,    37,    -1,    -1,    -1,
      -1,    -1,    43,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   145,    -1,    -1,    -1,    -1,
     150,   151,   152,    -1,    65,    -1,   156,    -1,   158,    -1,
      71,    72,   162,    -1,    -1,    -1,    -1,    78,    -1,    -1,
      81,   171,    -1,   173,    -1,    -1,    -1,    88,    -1,    -1,
      -1,   181,   182,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     101,   102,   103,   104,    -1,    -1,    -1,    -1,    -1,    -1,
     111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   150,
     151,   152,    -1,    -1,    -1,   156,    -1,    -1,    -1,    -1,
      -1,   162,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     171,    -1,   173,    -1,    -1,    -1,    -1,    -1,    -1,    26,
     181,   182,    29,    30,    31,    32,    33,    34,    -1,    36,
      -1,    -1,    39,    -1,    41,    -1,    -1,    -1,    45,    46,
      -1,    48,    49,    50,    51,    -1,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    -1,    63,    -1,    -1,    66,
      67,    68,    69,    70,    -1,    -1,    73,    -1,    -1,    -1,
      77,    -1,    79,    80,    -1,    82,    83,    84,    85,    86,
      87,    -1,    89,    90,    91,    92,    93,    94,    -1,    -1,
      97,    -1,    -1,   100,    -1,    -1,    -1,    -1,    -1,   106,
     107,    -1,   109,   110,    -1,   112,   113,    -1,    -1,    -1,
     117,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
     127,   128,   129,   130,    -1,   132,    -1,   134,    -1,   136,
     137,   138,   139,   140,   141,   142,   143,   144,    -1,   146,
     147,   148,   149,    -1,    -1,    -1,    -1,   154,    -1,    -1,
     157,    -1,    -1,   160,   161,    -1,    -1,   164,   165,   166,
     167,    -1,    -1,   170,    -1,   172,    -1,   174,   175,   176,
     177,   178,   179,   180,    -1,    -1,   183
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,   219,   221,     0,     4,     5,     6,    15,    35,    37,
      43,    44,    47,    52,    62,    65,    71,    72,    74,    78,
      81,    88,    95,    99,   101,   102,   103,   104,   105,   111,
     116,   133,   145,   150,   151,   152,   156,   158,   162,   171,
     173,   181,   182,   210,   220,   227,   228,   230,   231,   232,
     233,   236,   237,   243,   244,   256,   270,   274,   276,   279,
     281,   282,   283,   284,   287,   288,   291,   293,   294,   295,
     296,   298,   299,   300,   301,   302,   304,   306,   324,   325,
     326,   327,   209,   210,   329,   332,   333,     3,     5,   215,
       3,     5,     3,     5,   272,   101,   275,    10,     3,     5,
     275,     3,     6,   215,   215,   275,   276,     3,   272,     3,
     272,   276,    26,    29,    30,    31,    32,    33,    34,    36,
      39,    41,    45,    46,    48,    49,    50,    51,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    63,    66,    67,
      68,    69,    70,    73,    77,    79,    80,    82,    83,    84,
      85,    86,    87,    89,    90,    91,    92,    93,    94,    97,
     100,   106,   107,   109,   110,   112,   113,   117,   118,   119,
     120,   121,   122,   124,   125,   126,   127,   128,   129,   130,
     132,   134,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   146,   147,   148,   149,   154,   157,   160,   161,   164,
     165,   166,   167,   170,   172,   174,   175,   176,   177,   178,
     179,   180,   183,   245,   247,   323,   214,   223,   223,   169,
      71,   108,   115,   162,   171,   235,   256,   281,   287,   293,
     297,   304,   324,   327,   214,   214,   212,   212,   214,   212,
     214,   226,   214,   191,   292,   212,   305,   306,   305,   305,
       3,     5,    42,    76,   131,   159,   199,   215,   249,   273,
     307,   308,   321,   256,   324,   325,   327,   305,   214,   280,
      28,    54,    68,    73,   334,   335,   329,   105,    10,   212,
     214,     3,   325,   212,   163,   212,   215,   215,   215,   215,
     215,   215,   215,   215,   215,   215,   215,   215,   215,   215,
     215,   215,   215,   215,   215,   215,   215,   215,   215,   215,
     215,   215,   215,   215,   215,   215,   215,   215,   215,   215,
     189,   211,    14,    96,   227,   234,   237,   281,   283,   284,
     295,   296,   299,   213,   243,   244,     3,     3,     5,     3,
       5,     3,     3,   212,   321,   285,   222,   135,   289,   293,
       3,   279,   212,   225,   303,   307,   307,   217,   210,   215,
     242,   305,     3,     5,   277,   215,   189,   211,     5,   216,
     243,   252,   253,   254,   255,   191,   216,   263,   215,   266,
      10,    10,    13,   248,   273,     3,     7,     8,     9,    10,
      11,    12,    75,   123,   155,   168,   194,   197,   198,   199,
     202,   203,   215,   259,   260,   261,   248,   259,   262,    10,
      10,   246,   262,   261,    10,    10,   261,    10,   261,   259,
     241,   244,   304,   261,   257,   258,   259,    10,   323,    10,
     261,   325,   257,   259,   325,   184,   185,   186,   187,   188,
     322,   325,   325,   248,     7,     8,   328,    10,   325,   247,
     210,   215,   214,   212,   226,   304,   213,   243,   286,   221,
     191,   114,   243,   268,   290,   214,   212,   225,   213,   227,
     244,   302,   307,   216,   262,   199,   211,   259,   238,   239,
     240,   241,   209,    27,    64,   153,   187,   336,   337,   335,
     212,   273,   213,   189,   217,     7,   229,   213,   243,   264,
     268,   213,   244,   265,   268,   216,   216,   216,   215,   259,
     259,   259,   259,   259,   259,   259,   304,    16,    17,    18,
      19,    20,    21,    22,    23,    24,   190,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   209,   210,   189,
     216,   189,   216,   216,   189,   216,   216,   216,   216,   216,
     216,   216,   216,   216,   216,   304,   199,   215,   242,   249,
     273,   313,   315,   316,   216,   189,   216,   216,   216,   216,
     189,   216,   216,   216,   216,   216,   216,   216,   216,   209,
     216,   216,   216,   247,    10,   224,   307,   317,   226,   296,
     213,   191,   304,   324,   214,   213,   244,   269,   270,   213,
     233,   213,   226,   211,   211,   216,   189,   278,   189,   216,
     169,   330,   331,   255,   261,     7,   216,   304,   327,   216,
     214,   214,   304,   216,   199,   215,   242,   249,   309,   311,
     312,   259,   259,     3,   259,   259,   259,   259,   259,   259,
     259,   259,   259,   259,   259,   259,   259,   259,   259,   259,
     259,     3,   259,   261,   262,    10,   315,   303,   199,   238,
     249,   314,   315,   215,   242,   258,   261,     7,   216,   223,
     189,   307,   214,   225,   226,    25,   241,   277,   337,   333,
     213,   330,   313,   319,   320,   214,   271,   273,   311,   303,
     199,   238,   249,   310,   311,   216,   215,   242,   191,   211,
     216,   315,   303,   216,   315,   216,   238,   216,   226,   213,
     307,   213,     5,   191,   318,   189,   214,   212,   216,   311,
     303,   216,   315,   216,   259,   238,   259,   315,   216,   226,
     214,   262,   319,   250,   315,   216,    41,    55,   213,   251,
     261,   191,   191,   214,   267,   268,   267,   214
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_int16 yyr1[] =
{
       0,   218,   219,   220,   220,   221,   222,   221,   221,   221,
     221,   221,   221,   221,   221,   223,   223,   224,   223,   223,
     223,   223,   223,   223,   223,   223,   225,   225,   226,   226,
     227,   227,   227,   227,   227,   227,   227,   228,   229,   229,
     230,   230,   230,   230,   230,   230,   230,   230,   230,   231,
     232,   233,   234,   235,   235,   236,   237,   238,   238,   239,
     239,   240,   240,   241,   241,   242,   242,   242,   243,   243,
     244,   245,   245,   245,   246,   246,   247,   247,   247,   247,
     247,   247,   247,   247,   247,   247,   247,   247,   247,   247,
     247,   247,   247,   247,   247,   247,   247,   247,   247,   247,
     247,   247,   247,   247,   247,   247,   247,   247,   247,   247,
     247,   247,   247,   247,   247,   247,   247,   247,   247,   247,
     247,   247,   247,   247,   247,   247,   247,   247,   247,   247,
     247,   247,   247,   247,   247,   247,   247,   247,   247,   247,
     247,   247,   247,   247,   247,   247,   247,   247,   247,   247,
     247,   247,   247,   247,   247,   247,   247,   247,   247,   247,
     247,   247,   247,   247,   247,   247,   247,   247,   247,   247,
     247,   247,   247,   247,   247,   247,   247,   248,   248,   249,
     249,   249,   249,   250,   250,   251,   251,   252,   252,   252,
     253,   253,   254,   255,   255,   256,   257,   257,   258,   258,
     259,   259,   259,   259,   259,   259,   259,   259,   259,   259,
     259,   259,   259,   259,   259,   259,   259,   259,   259,   259,
     259,   259,   259,   259,   259,   259,   259,   259,   259,   259,
     259,   259,   259,   259,   259,   259,   259,   259,   259,   259,
     259,   260,   260,   261,   262,   263,   263,   264,   264,   265,
     265,   266,   266,   267,   267,   268,   268,   269,   270,   270,
     271,   271,   272,   272,   272,   273,   273,   274,   274,   274,
     274,   274,   274,   274,   274,   274,   274,   274,   275,   275,
     276,   276,   276,   276,   276,   276,   276,   276,   276,   277,
     278,   277,   279,   280,   279,   281,   281,   282,   283,   284,
     284,   285,   285,   286,   287,   287,   288,   289,   289,   290,
     290,   291,   291,   292,   292,   293,   293,   294,   295,   295,
     295,   296,   296,   297,   297,   298,   299,   300,   300,   300,
     301,   302,   303,   303,   304,   304,   305,   305,   306,   306,
     306,   307,   307,   307,   308,   308,   308,   308,   309,   309,
     309,   310,   310,   311,   311,   312,   312,   312,   312,   312,
     313,   313,   313,   314,   314,   315,   315,   316,   316,   316,
     316,   316,   316,   317,   317,   318,   318,   319,   320,   320,
     321,   321,   322,   322,   322,   322,   322,   323,   323,   323,
     324,   325,   325,   325,   325,   325,   325,   325,   325,   325,
     325,   326,   327,   327,   328,   328,   328,   329,   329,   330,
     330,   331,   332,   333,   333,   334,   334,   335,   335,   335,
     335,   336,   336,   337,   337,   337,   337
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     2,     0,     2,     0,     0,     6,     2,     2,
       3,     2,     2,     2,     2,     0,     2,     0,     6,     2,
       3,     2,     2,     2,     2,     2,     0,     2,     0,     1,
       1,     2,     2,     1,     2,     1,     1,     6,     1,     2,
       1,     2,     1,     2,     1,     2,     2,     2,     2,     4,
       3,     3,     5,     2,     2,     3,     4,     0,     1,     1,
       3,     1,     3,     3,     2,     3,     3,     2,     0,     1,
       3,     1,     3,     4,     1,     3,     0,     1,     4,     1,
       1,     1,     1,     1,     4,     4,     1,     1,     1,     1,
       1,     1,     6,     1,     1,     1,     1,     4,     1,     1,
       1,     4,     1,     1,     1,     4,     4,     1,     1,     1,
       1,     4,     4,     4,     4,     4,     1,     4,     1,     1,
       4,     1,     4,     1,     1,     4,     4,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     4,     1,     1,     1,     4,     4,     1,     1,     1,
       1,     1,     6,     1,     4,     1,     1,     1,     4,     1,
       1,     1,     4,     4,     4,     4,     1,     1,     4,     4,
       4,     1,     1,     4,     4,     4,     1,     1,     1,     1,
       1,     1,     1,     0,     2,     4,     3,     0,     2,     1,
       1,     3,     2,     3,     1,     5,     1,     3,     0,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       5,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     2,
       2,     2,     2,     2,     2,     3,     3,     5,     5,     4,
       3,     1,     3,     1,     1,     0,     2,     4,     3,     2,
       2,     0,     2,     2,     1,     3,     2,     1,     3,     2,
       0,     1,     0,     1,     1,     1,     1,     1,     1,     1,
       2,     2,     1,     1,     1,     1,     1,     1,     0,     1,
       1,     2,     1,     2,     2,     1,     1,     1,     1,     1,
       0,     4,     1,     0,     4,     2,     2,     2,     5,     2,
       2,     0,     2,     2,     2,     2,     2,     2,     3,     2,
       3,     5,     5,     0,     2,     2,     2,     2,     6,     8,
       2,     2,     2,     2,     2,     2,     5,     1,     1,     1,
       1,     1,     0,     2,     2,     3,     0,     1,     2,     2,
       2,     3,     2,     1,     1,     3,     2,     4,     3,     2,
       1,     3,     2,     0,     1,     3,     2,     1,     3,     4,
       3,     2,     1,     3,     2,     0,     1,     1,     3,     2,
       1,     3,     4,     1,     3,     0,     2,     2,     1,     3,
       1,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       5,     1,     1,     1,     1,     2,     1,     2,     1,     2,
       4,     5,     5,    10,     1,     3,     1,     0,     2,     0,
       2,     4,     6,     0,     3,     1,     3,     4,     1,     1,
       1,     1,     3,     1,     1,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
# ifndef YY_LOCATION_PRINT
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yysymbol_kind_t yytoken;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  int yyn = yypact[+*yyctx->yyssp];
  if (!yypact_value_is_default (yyn))
    {
      /* Start YYX at -YYN if negative to avoid negative indexes in
         YYCHECK.  In other words, skip the first -YYN actions for
         this state because they are default actions.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;
      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yyx;
      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
        if (yycheck[yyx + yyn] == yyx && yyx != YYSYMBOL_YYerror
            && !yytable_value_is_error (yytable[yyx + yyn]))
          {
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = YY_CAST (yysymbol_kind_t, yyx);
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif

#ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;
      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
#endif


static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yytnamerr (YY_NULLPTR, yytname[yyarg[yyi]]);
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yytname[yyarg[yyi++]]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* input: gbl_statements m_acf  */
#line 322 "tools/widl/parser.y"
                                                { check_statements((yyvsp[-1].stmt_list), FALSE);
						  check_all_user_types((yyvsp[-1].stmt_list));
						  write_header((yyvsp[-1].stmt_list));
						  write_id_data((yyvsp[-1].stmt_list));
						  write_proxies((yyvsp[-1].stmt_list));
						  write_client((yyvsp[-1].stmt_list));
						  write_server((yyvsp[-1].stmt_list));
						  write_regscript((yyvsp[-1].stmt_list));
						  write_typelib_regscript((yyvsp[-1].stmt_list));
						  write_dlldata((yyvsp[-1].stmt_list));
						  write_local_stubs((yyvsp[-1].stmt_list));
						}
#line 3160 "tools/widl/parser.tab.c"
    break;

  case 5: /* gbl_statements: %empty  */
#line 338 "tools/widl/parser.y"
                                                { (yyval.stmt_list) = NULL; }
#line 3166 "tools/widl/parser.tab.c"
    break;

  case 6: /* $@1: %empty  */
#line 339 "tools/widl/parser.y"
                                          { push_namespace((yyvsp[-1].str)); }
#line 3172 "tools/widl/parser.tab.c"
    break;

  case 7: /* gbl_statements: gbl_statements namespacedef '{' $@1 gbl_statements '}'  */
#line 340 "tools/widl/parser.y"
                                                { pop_namespace((yyvsp[-4].str)); (yyval.stmt_list) = append_statements((yyvsp[-5].stmt_list), (yyvsp[-1].stmt_list)); }
#line 3178 "tools/widl/parser.tab.c"
    break;

  case 8: /* gbl_statements: gbl_statements interfacedec  */
#line 341 "tools/widl/parser.y"
                                                { (yyval.stmt_list) = append_statement((yyvsp[-1].stmt_list), make_statement_reference((yyvsp[0].type))); }
#line 3184 "tools/widl/parser.tab.c"
    break;

  case 9: /* gbl_statements: gbl_statements interfacedef  */
#line 342 "tools/widl/parser.y"
                                                { (yyval.stmt_list) = append_statement((yyvsp[-1].stmt_list), make_statement_type_decl((yyvsp[0].type))); }
#line 3190 "tools/widl/parser.tab.c"
    break;

  case 10: /* gbl_statements: gbl_statements coclass ';'  */
#line 343 "tools/widl/parser.y"
                                                { (yyval.stmt_list) = (yyvsp[-2].stmt_list);
						  reg_type((yyvsp[-1].type), (yyvsp[-1].type)->name, current_namespace, 0);
						}
#line 3198 "tools/widl/parser.tab.c"
    break;

  case 11: /* gbl_statements: gbl_statements coclassdef  */
#line 346 "tools/widl/parser.y"
                                                { (yyval.stmt_list) = append_statement((yyvsp[-1].stmt_list), make_statement_type_decl((yyvsp[0].type)));
						  reg_type((yyvsp[0].type), (yyvsp[0].type)->name, current_namespace, 0);
						}
#line 3206 "tools/widl/parser.tab.c"
    break;

  case 12: /* gbl_statements: gbl_statements moduledef  */
#line 349 "tools/widl/parser.y"
                                                { (yyval.stmt_list) = append_statement((yyvsp[-1].stmt_list), make_statement_module((yyvsp[0].type))); }
#line 3212 "tools/widl/parser.tab.c"
    break;

  case 13: /* gbl_statements: gbl_statements librarydef  */
#line 350 "tools/widl/parser.y"
                                                { (yyval.stmt_list) = append_statement((yyvsp[-1].stmt_list), make_statement_library((yyvsp[0].typelib))); }
#line 3218 "tools/widl/parser.tab.c"
    break;

  case 14: /* gbl_statements: gbl_statements statement  */
#line 351 "tools/widl/parser.y"
                                                { (yyval.stmt_list) = append_statement((yyvsp[-1].stmt_list), (yyvsp[0].statement)); }
#line 3224 "tools/widl/parser.tab.c"
    break;

  case 15: /* imp_statements: %empty  */
#line 354 "tools/widl/parser.y"
                                                { (yyval.stmt_list) = NULL; }
#line 3230 "tools/widl/parser.tab.c"
    break;

  case 16: /* imp_statements: imp_statements interfacedec  */
#line 355 "tools/widl/parser.y"
                                                { (yyval.stmt_list) = append_statement((yyvsp[-1].stmt_list), make_statement_reference((yyvsp[0].type))); }
#line 3236 "tools/widl/parser.tab.c"
    break;

  case 17: /* $@2: %empty  */
#line 356 "tools/widl/parser.y"
                                          { push_namespace((yyvsp[-1].str)); }
#line 3242 "tools/widl/parser.tab.c"
    break;

  case 18: /* imp_statements: imp_statements namespacedef '{' $@2 imp_statements '}'  */
#line 357 "tools/widl/parser.y"
                                                { pop_namespace((yyvsp[-4].str)); (yyval.stmt_list) = append_statements((yyvsp[-5].stmt_list), (yyvsp[-1].stmt_list)); }
#line 3248 "tools/widl/parser.tab.c"
    break;

  case 19: /* imp_statements: imp_statements interfacedef  */
#line 358 "tools/widl/parser.y"
                                                { (yyval.stmt_list) = append_statement((yyvsp[-1].stmt_list), make_statement_type_decl((yyvsp[0].type))); }
#line 3254 "tools/widl/parser.tab.c"
    break;

  case 20: /* imp_statements: imp_statements coclass ';'  */
#line 359 "tools/widl/parser.y"
                                                { (yyval.stmt_list) = (yyvsp[-2].stmt_list); reg_type((yyvsp[-1].type), (yyvsp[-1].type)->name, current_namespace, 0); }
#line 3260 "tools/widl/parser.tab.c"
    break;

  case 21: /* imp_statements: imp_statements coclassdef  */
#line 360 "tools/widl/parser.y"
                                                { (yyval.stmt_list) = append_statement((yyvsp[-1].stmt_list), make_statement_type_decl((yyvsp[0].type)));
						  reg_type((yyvsp[0].type), (yyvsp[0].type)->name, current_namespace, 0);
						}
#line 3268 "tools/widl/parser.tab.c"
    break;

  case 22: /* imp_statements: imp_statements moduledef  */
#line 363 "tools/widl/parser.y"
                                                { (yyval.stmt_list) = append_statement((yyvsp[-1].stmt_list), make_statement_module((yyvsp[0].type))); }
#line 3274 "tools/widl/parser.tab.c"
    break;

  case 23: /* imp_statements: imp_statements statement  */
#line 364 "tools/widl/parser.y"
                                                { (yyval.stmt_list) = append_statement((yyvsp[-1].stmt_list), (yyvsp[0].statement)); }
#line 3280 "tools/widl/parser.tab.c"
    break;

  case 24: /* imp_statements: imp_statements importlib  */
#line 365 "tools/widl/parser.y"
                                                { (yyval.stmt_list) = append_statement((yyvsp[-1].stmt_list), make_statement_importlib((yyvsp[0].str))); }
#line 3286 "tools/widl/parser.tab.c"
    break;

  case 25: /* imp_statements: imp_statements librarydef  */
#line 366 "tools/widl/parser.y"
                                                { (yyval.stmt_list) = append_statement((yyvsp[-1].stmt_list), make_statement_library((yyvsp[0].typelib))); }
#line 3292 "tools/widl/parser.tab.c"
    break;

  case 26: /* int_statements: %empty  */
#line 369 "tools/widl/parser.y"
                                                { (yyval.stmt_list) = NULL; }
#line 3298 "tools/widl/parser.tab.c"
    break;

  case 27: /* int_statements: int_statements statement  */
#line 370 "tools/widl/parser.y"
                                                { (yyval.stmt_list) = append_statement((yyvsp[-1].stmt_list), (yyvsp[0].statement)); }
#line 3304 "tools/widl/parser.tab.c"
    break;

  case 30: /* statement: cppquote  */
#line 378 "tools/widl/parser.y"
                                                { (yyval.statement) = make_statement_cppquote((yyvsp[0].str)); }
#line 3310 "tools/widl/parser.tab.c"
    break;

  case 31: /* statement: typedecl ';'  */
#line 379 "tools/widl/parser.y"
                                                { (yyval.statement) = make_statement_type_decl((yyvsp[-1].type)); }
#line 3316 "tools/widl/parser.tab.c"
    break;

  case 32: /* statement: declaration ';'  */
#line 380 "tools/widl/parser.y"
                                                { (yyval.statement) = make_statement_declaration((yyvsp[-1].var)); }
#line 3322 "tools/widl/parser.tab.c"
    break;

  case 33: /* statement: import  */
#line 381 "tools/widl/parser.y"
                                                { (yyval.statement) = make_statement_import((yyvsp[0].str)); }
#line 3328 "tools/widl/parser.tab.c"
    break;

  case 34: /* statement: typedef ';'  */
#line 382 "tools/widl/parser.y"
                                                { (yyval.statement) = (yyvsp[-1].statement); }
#line 3334 "tools/widl/parser.tab.c"
    break;

  case 35: /* statement: aPRAGMA  */
#line 383 "tools/widl/parser.y"
                                                { (yyval.statement) = make_statement_pragma((yyvsp[0].str)); }
#line 3340 "tools/widl/parser.tab.c"
    break;

  case 36: /* statement: pragma_warning  */
#line 384 "tools/widl/parser.y"
                         { (yyval.statement) = NULL; }
#line 3346 "tools/widl/parser.tab.c"
    break;

  case 37: /* pragma_warning: tPRAGMA_WARNING '(' aIDENTIFIER ':' warnings ')'  */
#line 388 "tools/widl/parser.y"
                  {
                      int result;
                      (yyval.statement) = NULL;
                      result = do_warning((yyvsp[-3].str), (yyvsp[-1].warning_list));
                      if(!result)
                          error_loc("expected \"disable\" or \"enable\"\n");
                  }
#line 3358 "tools/widl/parser.tab.c"
    break;

  case 38: /* warnings: aNUM  */
#line 398 "tools/widl/parser.y"
               { (yyval.warning_list) = append_warning(NULL, (yyvsp[0].num)); }
#line 3364 "tools/widl/parser.tab.c"
    break;

  case 39: /* warnings: warnings aNUM  */
#line 399 "tools/widl/parser.y"
                        { (yyval.warning_list) = append_warning((yyvsp[-1].warning_list), (yyvsp[0].num)); }
#line 3370 "tools/widl/parser.tab.c"
    break;

  case 41: /* typedecl: tENUM aIDENTIFIER  */
#line 404 "tools/widl/parser.y"
                                                { (yyval.type) = type_new_enum((yyvsp[0].str), current_namespace, FALSE, NULL); }
#line 3376 "tools/widl/parser.tab.c"
    break;

  case 43: /* typedecl: tSTRUCT aIDENTIFIER  */
#line 406 "tools/widl/parser.y"
                                                { (yyval.type) = type_new_struct((yyvsp[0].str), current_namespace, FALSE, NULL); }
#line 3382 "tools/widl/parser.tab.c"
    break;

  case 45: /* typedecl: tUNION aIDENTIFIER  */
#line 408 "tools/widl/parser.y"
                                                { (yyval.type) = type_new_nonencapsulated_union((yyvsp[0].str), FALSE, NULL); }
#line 3388 "tools/widl/parser.tab.c"
    break;

  case 46: /* typedecl: attributes enumdef  */
#line 409 "tools/widl/parser.y"
                                                { (yyval.type) = (yyvsp[0].type); (yyval.type)->attrs = check_enum_attrs((yyvsp[-1].attr_list)); }
#line 3394 "tools/widl/parser.tab.c"
    break;

  case 47: /* typedecl: attributes structdef  */
#line 410 "tools/widl/parser.y"
                                                { (yyval.type) = (yyvsp[0].type); (yyval.type)->attrs = check_struct_attrs((yyvsp[-1].attr_list)); }
#line 3400 "tools/widl/parser.tab.c"
    break;

  case 48: /* typedecl: attributes uniondef  */
#line 411 "tools/widl/parser.y"
                                                { (yyval.type) = (yyvsp[0].type); (yyval.type)->attrs = check_union_attrs((yyvsp[-1].attr_list)); }
#line 3406 "tools/widl/parser.tab.c"
    break;

  case 49: /* cppquote: tCPPQUOTE '(' aSTRING ')'  */
#line 414 "tools/widl/parser.y"
                                                { (yyval.str) = (yyvsp[-1].str); }
#line 3412 "tools/widl/parser.tab.c"
    break;

  case 50: /* import_start: tIMPORT aSTRING ';'  */
#line 416 "tools/widl/parser.y"
                                                { assert(yychar == YYEMPTY);
						  (yyval.import) = xmalloc(sizeof(struct _import_t));
						  (yyval.import)->name = (yyvsp[-1].str);
						  (yyval.import)->import_performed = do_import((yyvsp[-1].str));
						  if (!(yyval.import)->import_performed) yychar = aEOF;
						}
#line 3423 "tools/widl/parser.tab.c"
    break;

  case 51: /* import: import_start imp_statements aEOF  */
#line 424 "tools/widl/parser.y"
                                                { (yyval.str) = (yyvsp[-2].import)->name;
						  if ((yyvsp[-2].import)->import_performed) pop_import();
						  free((yyvsp[-2].import));
						}
#line 3432 "tools/widl/parser.tab.c"
    break;

  case 52: /* importlib: tIMPORTLIB '(' aSTRING ')' semicolon_opt  */
#line 431 "tools/widl/parser.y"
                                                { (yyval.str) = (yyvsp[-2].str); if(!parse_only) add_importlib((yyvsp[-2].str), current_typelib); }
#line 3438 "tools/widl/parser.tab.c"
    break;

  case 53: /* libraryhdr: tLIBRARY aIDENTIFIER  */
#line 434 "tools/widl/parser.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 3444 "tools/widl/parser.tab.c"
    break;

  case 54: /* libraryhdr: tLIBRARY aKNOWNTYPE  */
#line 435 "tools/widl/parser.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 3450 "tools/widl/parser.tab.c"
    break;

  case 55: /* library_start: attributes libraryhdr '{'  */
#line 437 "tools/widl/parser.y"
                                                { (yyval.typelib) = make_library((yyvsp[-1].str), check_library_attrs((yyvsp[-1].str), (yyvsp[-2].attr_list)));
						  if (!parse_only && do_typelib) current_typelib = (yyval.typelib);
						}
#line 3458 "tools/widl/parser.tab.c"
    break;

  case 56: /* librarydef: library_start imp_statements '}' semicolon_opt  */
#line 442 "tools/widl/parser.y"
                                                { (yyval.typelib) = (yyvsp[-3].typelib); (yyval.typelib)->stmts = (yyvsp[-2].stmt_list); }
#line 3464 "tools/widl/parser.tab.c"
    break;

  case 57: /* m_args: %empty  */
#line 445 "tools/widl/parser.y"
                                                { (yyval.var_list) = NULL; }
#line 3470 "tools/widl/parser.tab.c"
    break;

  case 59: /* arg_list: arg  */
#line 449 "tools/widl/parser.y"
                                                { check_arg_attrs((yyvsp[0].var)); (yyval.var_list) = append_var( NULL, (yyvsp[0].var) ); }
#line 3476 "tools/widl/parser.tab.c"
    break;

  case 60: /* arg_list: arg_list ',' arg  */
#line 450 "tools/widl/parser.y"
                                                { check_arg_attrs((yyvsp[0].var)); (yyval.var_list) = append_var( (yyvsp[-2].var_list), (yyvsp[0].var) ); }
#line 3482 "tools/widl/parser.tab.c"
    break;

  case 62: /* args: arg_list ',' ELLIPSIS  */
#line 454 "tools/widl/parser.y"
                                                { (yyval.var_list) = append_var( (yyvsp[-2].var_list), make_var(strdup("...")) ); }
#line 3488 "tools/widl/parser.tab.c"
    break;

  case 63: /* arg: attributes decl_spec m_any_declarator  */
#line 458 "tools/widl/parser.y"
                                                { if ((yyvsp[-1].declspec)->stgclass != STG_NONE && (yyvsp[-1].declspec)->stgclass != STG_REGISTER)
						    error_loc("invalid storage class for function parameter\n");
						  (yyval.var) = declare_var((yyvsp[-2].attr_list), (yyvsp[-1].declspec), (yyvsp[0].declarator), TRUE);
						  free((yyvsp[-1].declspec)); free((yyvsp[0].declarator));
						}
#line 3498 "tools/widl/parser.tab.c"
    break;

  case 64: /* arg: decl_spec m_any_declarator  */
#line 463 "tools/widl/parser.y"
                                                { if ((yyvsp[-1].declspec)->stgclass != STG_NONE && (yyvsp[-1].declspec)->stgclass != STG_REGISTER)
						    error_loc("invalid storage class for function parameter\n");
						  (yyval.var) = declare_var(NULL, (yyvsp[-1].declspec), (yyvsp[0].declarator), TRUE);
						  free((yyvsp[-1].declspec)); free((yyvsp[0].declarator));
						}
#line 3508 "tools/widl/parser.tab.c"
    break;

  case 65: /* array: '[' expr ']'  */
#line 470 "tools/widl/parser.y"
                                                { (yyval.expr) = (yyvsp[-1].expr);
						  if (!(yyval.expr)->is_const || (yyval.expr)->cval <= 0)
						      error_loc("array dimension is not a positive integer constant\n");
						}
#line 3517 "tools/widl/parser.tab.c"
    break;

  case 66: /* array: '[' '*' ']'  */
#line 474 "tools/widl/parser.y"
                                                { (yyval.expr) = make_expr(EXPR_VOID); }
#line 3523 "tools/widl/parser.tab.c"
    break;

  case 67: /* array: '[' ']'  */
#line 475 "tools/widl/parser.y"
                                                { (yyval.expr) = make_expr(EXPR_VOID); }
#line 3529 "tools/widl/parser.tab.c"
    break;

  case 68: /* m_attributes: %empty  */
#line 478 "tools/widl/parser.y"
                                                { (yyval.attr_list) = NULL; }
#line 3535 "tools/widl/parser.tab.c"
    break;

  case 70: /* attributes: '[' attrib_list ']'  */
#line 483 "tools/widl/parser.y"
                                                { (yyval.attr_list) = (yyvsp[-1].attr_list); }
#line 3541 "tools/widl/parser.tab.c"
    break;

  case 71: /* attrib_list: attribute  */
#line 486 "tools/widl/parser.y"
                                                { (yyval.attr_list) = append_attr( NULL, (yyvsp[0].attr) ); }
#line 3547 "tools/widl/parser.tab.c"
    break;

  case 72: /* attrib_list: attrib_list ',' attribute  */
#line 487 "tools/widl/parser.y"
                                                { (yyval.attr_list) = append_attr( (yyvsp[-2].attr_list), (yyvsp[0].attr) ); }
#line 3553 "tools/widl/parser.tab.c"
    break;

  case 73: /* attrib_list: attrib_list ']' '[' attribute  */
#line 488 "tools/widl/parser.y"
                                                { (yyval.attr_list) = append_attr( (yyvsp[-3].attr_list), (yyvsp[0].attr) ); }
#line 3559 "tools/widl/parser.tab.c"
    break;

  case 74: /* str_list: aSTRING  */
#line 491 "tools/widl/parser.y"
                                                { (yyval.str_list) = append_str( NULL, (yyvsp[0].str) ); }
#line 3565 "tools/widl/parser.tab.c"
    break;

  case 75: /* str_list: str_list ',' aSTRING  */
#line 492 "tools/widl/parser.y"
                                                { (yyval.str_list) = append_str( (yyvsp[-2].str_list), (yyvsp[0].str) ); }
#line 3571 "tools/widl/parser.tab.c"
    break;

  case 76: /* attribute: %empty  */
#line 495 "tools/widl/parser.y"
                                                { (yyval.attr) = NULL; }
#line 3577 "tools/widl/parser.tab.c"
    break;

  case 77: /* attribute: tAGGREGATABLE  */
#line 496 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_AGGREGATABLE); }
#line 3583 "tools/widl/parser.tab.c"
    break;

  case 78: /* attribute: tANNOTATION '(' aSTRING ')'  */
#line 497 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attrp(ATTR_ANNOTATION, (yyvsp[-1].str)); }
#line 3589 "tools/widl/parser.tab.c"
    break;

  case 79: /* attribute: tAPPOBJECT  */
#line 498 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_APPOBJECT); }
#line 3595 "tools/widl/parser.tab.c"
    break;

  case 80: /* attribute: tASYNC  */
#line 499 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_ASYNC); }
#line 3601 "tools/widl/parser.tab.c"
    break;

  case 81: /* attribute: tAUTOHANDLE  */
#line 500 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_AUTO_HANDLE); }
#line 3607 "tools/widl/parser.tab.c"
    break;

  case 82: /* attribute: tBINDABLE  */
#line 501 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_BINDABLE); }
#line 3613 "tools/widl/parser.tab.c"
    break;

  case 83: /* attribute: tBROADCAST  */
#line 502 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_BROADCAST); }
#line 3619 "tools/widl/parser.tab.c"
    break;

  case 84: /* attribute: tCALLAS '(' ident ')'  */
#line 503 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attrp(ATTR_CALLAS, (yyvsp[-1].var)); }
#line 3625 "tools/widl/parser.tab.c"
    break;

  case 85: /* attribute: tCASE '(' expr_list_int_const ')'  */
#line 504 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attrp(ATTR_CASE, (yyvsp[-1].expr_list)); }
#line 3631 "tools/widl/parser.tab.c"
    break;

  case 86: /* attribute: tCODE  */
#line 505 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_CODE); }
#line 3637 "tools/widl/parser.tab.c"
    break;

  case 87: /* attribute: tCOMMSTATUS  */
#line 506 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_COMMSTATUS); }
#line 3643 "tools/widl/parser.tab.c"
    break;

  case 88: /* attribute: tCONTEXTHANDLE  */
#line 507 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attrv(ATTR_CONTEXTHANDLE, 0); }
#line 3649 "tools/widl/parser.tab.c"
    break;

  case 89: /* attribute: tCONTEXTHANDLENOSERIALIZE  */
#line 508 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attrv(ATTR_CONTEXTHANDLE, 0); /* RPC_CONTEXT_HANDLE_DONT_SERIALIZE */ }
#line 3655 "tools/widl/parser.tab.c"
    break;

  case 90: /* attribute: tCONTEXTHANDLESERIALIZE  */
#line 509 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attrv(ATTR_CONTEXTHANDLE, 0); /* RPC_CONTEXT_HANDLE_SERIALIZE */ }
#line 3661 "tools/widl/parser.tab.c"
    break;

  case 91: /* attribute: tCONTROL  */
#line 510 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_CONTROL); }
#line 3667 "tools/widl/parser.tab.c"
    break;

  case 92: /* attribute: tCUSTOM '(' uuid_string ',' expr_const ')'  */
#line 511 "tools/widl/parser.y"
                                                     { (yyval.attr) = make_custom_attr((yyvsp[-3].uuid), (yyvsp[-1].expr)); }
#line 3673 "tools/widl/parser.tab.c"
    break;

  case 93: /* attribute: tDECODE  */
#line 512 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_DECODE); }
#line 3679 "tools/widl/parser.tab.c"
    break;

  case 94: /* attribute: tDEFAULT  */
#line 513 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_DEFAULT); }
#line 3685 "tools/widl/parser.tab.c"
    break;

  case 95: /* attribute: tDEFAULTBIND  */
#line 514 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_DEFAULTBIND); }
#line 3691 "tools/widl/parser.tab.c"
    break;

  case 96: /* attribute: tDEFAULTCOLLELEM  */
#line 515 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_DEFAULTCOLLELEM); }
#line 3697 "tools/widl/parser.tab.c"
    break;

  case 97: /* attribute: tDEFAULTVALUE '(' expr_const ')'  */
#line 516 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attrp(ATTR_DEFAULTVALUE, (yyvsp[-1].expr)); }
#line 3703 "tools/widl/parser.tab.c"
    break;

  case 98: /* attribute: tDEFAULTVTABLE  */
#line 517 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_DEFAULTVTABLE); }
#line 3709 "tools/widl/parser.tab.c"
    break;

  case 99: /* attribute: tDISABLECONSISTENCYCHECK  */
#line 518 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_DISABLECONSISTENCYCHECK); }
#line 3715 "tools/widl/parser.tab.c"
    break;

  case 100: /* attribute: tDISPLAYBIND  */
#line 519 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_DISPLAYBIND); }
#line 3721 "tools/widl/parser.tab.c"
    break;

  case 101: /* attribute: tDLLNAME '(' aSTRING ')'  */
#line 520 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attrp(ATTR_DLLNAME, (yyvsp[-1].str)); }
#line 3727 "tools/widl/parser.tab.c"
    break;

  case 102: /* attribute: tDUAL  */
#line 521 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_DUAL); }
#line 3733 "tools/widl/parser.tab.c"
    break;

  case 103: /* attribute: tENABLEALLOCATE  */
#line 522 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_ENABLEALLOCATE); }
#line 3739 "tools/widl/parser.tab.c"
    break;

  case 104: /* attribute: tENCODE  */
#line 523 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_ENCODE); }
#line 3745 "tools/widl/parser.tab.c"
    break;

  case 105: /* attribute: tENDPOINT '(' str_list ')'  */
#line 524 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attrp(ATTR_ENDPOINT, (yyvsp[-1].str_list)); }
#line 3751 "tools/widl/parser.tab.c"
    break;

  case 106: /* attribute: tENTRY '(' expr_const ')'  */
#line 525 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attrp(ATTR_ENTRY, (yyvsp[-1].expr)); }
#line 3757 "tools/widl/parser.tab.c"
    break;

  case 107: /* attribute: tEXPLICITHANDLE  */
#line 526 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_EXPLICIT_HANDLE); }
#line 3763 "tools/widl/parser.tab.c"
    break;

  case 108: /* attribute: tFAULTSTATUS  */
#line 527 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_FAULTSTATUS); }
#line 3769 "tools/widl/parser.tab.c"
    break;

  case 109: /* attribute: tFORCEALLOCATE  */
#line 528 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_FORCEALLOCATE); }
#line 3775 "tools/widl/parser.tab.c"
    break;

  case 110: /* attribute: tHANDLE  */
#line 529 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_HANDLE); }
#line 3781 "tools/widl/parser.tab.c"
    break;

  case 111: /* attribute: tHELPCONTEXT '(' expr_int_const ')'  */
#line 530 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attrp(ATTR_HELPCONTEXT, (yyvsp[-1].expr)); }
#line 3787 "tools/widl/parser.tab.c"
    break;

  case 112: /* attribute: tHELPFILE '(' aSTRING ')'  */
#line 531 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attrp(ATTR_HELPFILE, (yyvsp[-1].str)); }
#line 3793 "tools/widl/parser.tab.c"
    break;

  case 113: /* attribute: tHELPSTRING '(' aSTRING ')'  */
#line 532 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attrp(ATTR_HELPSTRING, (yyvsp[-1].str)); }
#line 3799 "tools/widl/parser.tab.c"
    break;

  case 114: /* attribute: tHELPSTRINGCONTEXT '(' expr_int_const ')'  */
#line 533 "tools/widl/parser.y"
                                                        { (yyval.attr) = make_attrp(ATTR_HELPSTRINGCONTEXT, (yyvsp[-1].expr)); }
#line 3805 "tools/widl/parser.tab.c"
    break;

  case 115: /* attribute: tHELPSTRINGDLL '(' aSTRING ')'  */
#line 534 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attrp(ATTR_HELPSTRINGDLL, (yyvsp[-1].str)); }
#line 3811 "tools/widl/parser.tab.c"
    break;

  case 116: /* attribute: tHIDDEN  */
#line 535 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_HIDDEN); }
#line 3817 "tools/widl/parser.tab.c"
    break;

  case 117: /* attribute: tID '(' expr_int_const ')'  */
#line 536 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attrp(ATTR_ID, (yyvsp[-1].expr)); }
#line 3823 "tools/widl/parser.tab.c"
    break;

  case 118: /* attribute: tIDEMPOTENT  */
#line 537 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_IDEMPOTENT); }
#line 3829 "tools/widl/parser.tab.c"
    break;

  case 119: /* attribute: tIGNORE  */
#line 538 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_IGNORE); }
#line 3835 "tools/widl/parser.tab.c"
    break;

  case 120: /* attribute: tIIDIS '(' expr ')'  */
#line 539 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attrp(ATTR_IIDIS, (yyvsp[-1].expr)); }
#line 3841 "tools/widl/parser.tab.c"
    break;

  case 121: /* attribute: tIMMEDIATEBIND  */
#line 540 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_IMMEDIATEBIND); }
#line 3847 "tools/widl/parser.tab.c"
    break;

  case 122: /* attribute: tIMPLICITHANDLE '(' arg ')'  */
#line 541 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attrp(ATTR_IMPLICIT_HANDLE, (yyvsp[-1].var)); }
#line 3853 "tools/widl/parser.tab.c"
    break;

  case 123: /* attribute: tIN  */
#line 542 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_IN); }
#line 3859 "tools/widl/parser.tab.c"
    break;

  case 124: /* attribute: tINPUTSYNC  */
#line 543 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_INPUTSYNC); }
#line 3865 "tools/widl/parser.tab.c"
    break;

  case 125: /* attribute: tLENGTHIS '(' m_exprs ')'  */
#line 544 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attrp(ATTR_LENGTHIS, (yyvsp[-1].expr_list)); }
#line 3871 "tools/widl/parser.tab.c"
    break;

  case 126: /* attribute: tLCID '(' expr_int_const ')'  */
#line 545 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attrp(ATTR_LIBLCID, (yyvsp[-1].expr)); }
#line 3877 "tools/widl/parser.tab.c"
    break;

  case 127: /* attribute: tLCID  */
#line 546 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_PARAMLCID); }
#line 3883 "tools/widl/parser.tab.c"
    break;

  case 128: /* attribute: tLICENSED  */
#line 547 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_LICENSED); }
#line 3889 "tools/widl/parser.tab.c"
    break;

  case 129: /* attribute: tLOCAL  */
#line 548 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_LOCAL); }
#line 3895 "tools/widl/parser.tab.c"
    break;

  case 130: /* attribute: tMAYBE  */
#line 549 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_MAYBE); }
#line 3901 "tools/widl/parser.tab.c"
    break;

  case 131: /* attribute: tMESSAGE  */
#line 550 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_MESSAGE); }
#line 3907 "tools/widl/parser.tab.c"
    break;

  case 132: /* attribute: tNOCODE  */
#line 551 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_NOCODE); }
#line 3913 "tools/widl/parser.tab.c"
    break;

  case 133: /* attribute: tNONBROWSABLE  */
#line 552 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_NONBROWSABLE); }
#line 3919 "tools/widl/parser.tab.c"
    break;

  case 134: /* attribute: tNONCREATABLE  */
#line 553 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_NONCREATABLE); }
#line 3925 "tools/widl/parser.tab.c"
    break;

  case 135: /* attribute: tNONEXTENSIBLE  */
#line 554 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_NONEXTENSIBLE); }
#line 3931 "tools/widl/parser.tab.c"
    break;

  case 136: /* attribute: tNOTIFY  */
#line 555 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_NOTIFY); }
#line 3937 "tools/widl/parser.tab.c"
    break;

  case 137: /* attribute: tNOTIFYFLAG  */
#line 556 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_NOTIFYFLAG); }
#line 3943 "tools/widl/parser.tab.c"
    break;

  case 138: /* attribute: tOBJECT  */
#line 557 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_OBJECT); }
#line 3949 "tools/widl/parser.tab.c"
    break;

  case 139: /* attribute: tODL  */
#line 558 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_ODL); }
#line 3955 "tools/widl/parser.tab.c"
    break;

  case 140: /* attribute: tOLEAUTOMATION  */
#line 559 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_OLEAUTOMATION); }
#line 3961 "tools/widl/parser.tab.c"
    break;

  case 141: /* attribute: tOPTIMIZE '(' aSTRING ')'  */
#line 560 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attrp(ATTR_OPTIMIZE, (yyvsp[-1].str)); }
#line 3967 "tools/widl/parser.tab.c"
    break;

  case 142: /* attribute: tOPTIONAL  */
#line 561 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_OPTIONAL); }
#line 3973 "tools/widl/parser.tab.c"
    break;

  case 143: /* attribute: tOUT  */
#line 562 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_OUT); }
#line 3979 "tools/widl/parser.tab.c"
    break;

  case 144: /* attribute: tPARTIALIGNORE  */
#line 563 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_PARTIALIGNORE); }
#line 3985 "tools/widl/parser.tab.c"
    break;

  case 145: /* attribute: tPOINTERDEFAULT '(' pointer_type ')'  */
#line 564 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attrv(ATTR_POINTERDEFAULT, (yyvsp[-1].num)); }
#line 3991 "tools/widl/parser.tab.c"
    break;

  case 146: /* attribute: tPROGID '(' aSTRING ')'  */
#line 565 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attrp(ATTR_PROGID, (yyvsp[-1].str)); }
#line 3997 "tools/widl/parser.tab.c"
    break;

  case 147: /* attribute: tPROPGET  */
#line 566 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_PROPGET); }
#line 4003 "tools/widl/parser.tab.c"
    break;

  case 148: /* attribute: tPROPPUT  */
#line 567 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_PROPPUT); }
#line 4009 "tools/widl/parser.tab.c"
    break;

  case 149: /* attribute: tPROPPUTREF  */
#line 568 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_PROPPUTREF); }
#line 4015 "tools/widl/parser.tab.c"
    break;

  case 150: /* attribute: tPROXY  */
#line 569 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_PROXY); }
#line 4021 "tools/widl/parser.tab.c"
    break;

  case 151: /* attribute: tPUBLIC  */
#line 570 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_PUBLIC); }
#line 4027 "tools/widl/parser.tab.c"
    break;

  case 152: /* attribute: tRANGE '(' expr_int_const ',' expr_int_const ')'  */
#line 572 "tools/widl/parser.y"
                                                { expr_list_t *list = append_expr( NULL, (yyvsp[-3].expr) );
						  list = append_expr( list, (yyvsp[-1].expr) );
						  (yyval.attr) = make_attrp(ATTR_RANGE, list); }
#line 4035 "tools/widl/parser.tab.c"
    break;

  case 153: /* attribute: tREADONLY  */
#line 575 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_READONLY); }
#line 4041 "tools/widl/parser.tab.c"
    break;

  case 154: /* attribute: tREPRESENTAS '(' type ')'  */
#line 576 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attrp(ATTR_REPRESENTAS, (yyvsp[-1].type)); }
#line 4047 "tools/widl/parser.tab.c"
    break;

  case 155: /* attribute: tREQUESTEDIT  */
#line 577 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_REQUESTEDIT); }
#line 4053 "tools/widl/parser.tab.c"
    break;

  case 156: /* attribute: tRESTRICTED  */
#line 578 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_RESTRICTED); }
#line 4059 "tools/widl/parser.tab.c"
    break;

  case 157: /* attribute: tRETVAL  */
#line 579 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_RETVAL); }
#line 4065 "tools/widl/parser.tab.c"
    break;

  case 158: /* attribute: tSIZEIS '(' m_exprs ')'  */
#line 580 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attrp(ATTR_SIZEIS, (yyvsp[-1].expr_list)); }
#line 4071 "tools/widl/parser.tab.c"
    break;

  case 159: /* attribute: tSOURCE  */
#line 581 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_SOURCE); }
#line 4077 "tools/widl/parser.tab.c"
    break;

  case 160: /* attribute: tSTRICTCONTEXTHANDLE  */
#line 582 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_STRICTCONTEXTHANDLE); }
#line 4083 "tools/widl/parser.tab.c"
    break;

  case 161: /* attribute: tSTRING  */
#line 583 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_STRING); }
#line 4089 "tools/widl/parser.tab.c"
    break;

  case 162: /* attribute: tSWITCHIS '(' expr ')'  */
#line 584 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attrp(ATTR_SWITCHIS, (yyvsp[-1].expr)); }
#line 4095 "tools/widl/parser.tab.c"
    break;

  case 163: /* attribute: tSWITCHTYPE '(' type ')'  */
#line 585 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attrp(ATTR_SWITCHTYPE, (yyvsp[-1].type)); }
#line 4101 "tools/widl/parser.tab.c"
    break;

  case 164: /* attribute: tTRANSMITAS '(' type ')'  */
#line 586 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attrp(ATTR_TRANSMITAS, (yyvsp[-1].type)); }
#line 4107 "tools/widl/parser.tab.c"
    break;

  case 165: /* attribute: tTHREADING '(' threading_type ')'  */
#line 587 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attrv(ATTR_THREADING, (yyvsp[-1].num)); }
#line 4113 "tools/widl/parser.tab.c"
    break;

  case 166: /* attribute: tUIDEFAULT  */
#line 588 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_UIDEFAULT); }
#line 4119 "tools/widl/parser.tab.c"
    break;

  case 167: /* attribute: tUSESGETLASTERROR  */
#line 589 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_USESGETLASTERROR); }
#line 4125 "tools/widl/parser.tab.c"
    break;

  case 168: /* attribute: tUSERMARSHAL '(' type ')'  */
#line 590 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attrp(ATTR_USERMARSHAL, (yyvsp[-1].type)); }
#line 4131 "tools/widl/parser.tab.c"
    break;

  case 169: /* attribute: tUUID '(' uuid_string ')'  */
#line 591 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attrp(ATTR_UUID, (yyvsp[-1].uuid)); }
#line 4137 "tools/widl/parser.tab.c"
    break;

  case 170: /* attribute: tASYNCUUID '(' uuid_string ')'  */
#line 592 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attrp(ATTR_ASYNCUUID, (yyvsp[-1].uuid)); }
#line 4143 "tools/widl/parser.tab.c"
    break;

  case 171: /* attribute: tV1ENUM  */
#line 593 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_V1ENUM); }
#line 4149 "tools/widl/parser.tab.c"
    break;

  case 172: /* attribute: tVARARG  */
#line 594 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_VARARG); }
#line 4155 "tools/widl/parser.tab.c"
    break;

  case 173: /* attribute: tVERSION '(' version ')'  */
#line 595 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attrv(ATTR_VERSION, (yyvsp[-1].num)); }
#line 4161 "tools/widl/parser.tab.c"
    break;

  case 174: /* attribute: tVIPROGID '(' aSTRING ')'  */
#line 596 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attrp(ATTR_VIPROGID, (yyvsp[-1].str)); }
#line 4167 "tools/widl/parser.tab.c"
    break;

  case 175: /* attribute: tWIREMARSHAL '(' type ')'  */
#line 597 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attrp(ATTR_WIREMARSHAL, (yyvsp[-1].type)); }
#line 4173 "tools/widl/parser.tab.c"
    break;

  case 176: /* attribute: pointer_type  */
#line 598 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attrv(ATTR_POINTERTYPE, (yyvsp[0].num)); }
#line 4179 "tools/widl/parser.tab.c"
    break;

  case 178: /* uuid_string: aSTRING  */
#line 603 "tools/widl/parser.y"
                                                { if (!is_valid_uuid((yyvsp[0].str)))
						    error_loc("invalid UUID: %s\n", (yyvsp[0].str));
						  (yyval.uuid) = parse_uuid((yyvsp[0].str)); }
#line 4187 "tools/widl/parser.tab.c"
    break;

  case 179: /* callconv: tCDECL  */
#line 608 "tools/widl/parser.y"
                                                { (yyval.str) = xstrdup("__cdecl"); }
#line 4193 "tools/widl/parser.tab.c"
    break;

  case 180: /* callconv: tFASTCALL  */
#line 609 "tools/widl/parser.y"
                                                { (yyval.str) = xstrdup("__fastcall"); }
#line 4199 "tools/widl/parser.tab.c"
    break;

  case 181: /* callconv: tPASCAL  */
#line 610 "tools/widl/parser.y"
                                                { (yyval.str) = xstrdup("__pascal"); }
#line 4205 "tools/widl/parser.tab.c"
    break;

  case 182: /* callconv: tSTDCALL  */
#line 611 "tools/widl/parser.y"
                                                { (yyval.str) = xstrdup("__stdcall"); }
#line 4211 "tools/widl/parser.tab.c"
    break;

  case 183: /* cases: %empty  */
#line 614 "tools/widl/parser.y"
                                                { (yyval.var_list) = NULL; }
#line 4217 "tools/widl/parser.tab.c"
    break;

  case 184: /* cases: cases case  */
#line 615 "tools/widl/parser.y"
                                                { (yyval.var_list) = append_var( (yyvsp[-1].var_list), (yyvsp[0].var) ); }
#line 4223 "tools/widl/parser.tab.c"
    break;

  case 185: /* case: tCASE expr_int_const ':' union_field  */
#line 618 "tools/widl/parser.y"
                                                { attr_t *a = make_attrp(ATTR_CASE, append_expr( NULL, (yyvsp[-2].expr) ));
						  (yyval.var) = (yyvsp[0].var); if (!(yyval.var)) (yyval.var) = make_var(NULL);
						  (yyval.var)->attrs = append_attr( (yyval.var)->attrs, a );
						}
#line 4232 "tools/widl/parser.tab.c"
    break;

  case 186: /* case: tDEFAULT ':' union_field  */
#line 622 "tools/widl/parser.y"
                                                { attr_t *a = make_attr(ATTR_DEFAULT);
						  (yyval.var) = (yyvsp[0].var); if (!(yyval.var)) (yyval.var) = make_var(NULL);
						  (yyval.var)->attrs = append_attr( (yyval.var)->attrs, a );
						}
#line 4241 "tools/widl/parser.tab.c"
    break;

  case 187: /* enums: %empty  */
#line 628 "tools/widl/parser.y"
                                                { (yyval.var_list) = NULL; }
#line 4247 "tools/widl/parser.tab.c"
    break;

  case 188: /* enums: enum_list ','  */
#line 629 "tools/widl/parser.y"
                                                { (yyval.var_list) = (yyvsp[-1].var_list); }
#line 4253 "tools/widl/parser.tab.c"
    break;

  case 190: /* enum_list: enum  */
#line 633 "tools/widl/parser.y"
                                                { if (!(yyvsp[0].var)->eval)
						    (yyvsp[0].var)->eval = make_exprl(EXPR_NUM, 0 /* default for first enum entry */);
                                                  (yyval.var_list) = append_var( NULL, (yyvsp[0].var) );
						}
#line 4262 "tools/widl/parser.tab.c"
    break;

  case 191: /* enum_list: enum_list ',' enum  */
#line 637 "tools/widl/parser.y"
                                                { if (!(yyvsp[0].var)->eval)
                                                  {
                                                    var_t *last = LIST_ENTRY( list_tail((yyval.var_list)), var_t, entry );
                                                    enum expr_type type = EXPR_NUM;
                                                    if (last->eval->type == EXPR_HEXNUM) type = EXPR_HEXNUM;
                                                    if (last->eval->cval + 1 < 0) type = EXPR_HEXNUM;
                                                    (yyvsp[0].var)->eval = make_exprl(type, last->eval->cval + 1);
                                                  }
                                                  (yyval.var_list) = append_var( (yyvsp[-2].var_list), (yyvsp[0].var) );
						}
#line 4277 "tools/widl/parser.tab.c"
    break;

  case 192: /* enum_member: m_attributes ident  */
#line 649 "tools/widl/parser.y"
                                                { (yyval.var) = (yyvsp[0].var);
						  (yyval.var)->attrs = check_enum_member_attrs((yyvsp[-1].attr_list));
						}
#line 4285 "tools/widl/parser.tab.c"
    break;

  case 193: /* enum: enum_member '=' expr_int_const  */
#line 654 "tools/widl/parser.y"
                                                { (yyval.var) = reg_const((yyvsp[-2].var));
						  (yyval.var)->eval = (yyvsp[0].expr);
                                                  (yyval.var)->declspec.type = type_new_int(TYPE_BASIC_INT, 0);
						}
#line 4294 "tools/widl/parser.tab.c"
    break;

  case 194: /* enum: enum_member  */
#line 658 "tools/widl/parser.y"
                                                { (yyval.var) = reg_const((yyvsp[0].var));
                                                  (yyval.var)->declspec.type = type_new_int(TYPE_BASIC_INT, 0);
						}
#line 4302 "tools/widl/parser.tab.c"
    break;

  case 195: /* enumdef: tENUM t_ident '{' enums '}'  */
#line 663 "tools/widl/parser.y"
                                                { (yyval.type) = type_new_enum((yyvsp[-3].str), current_namespace, TRUE, (yyvsp[-1].var_list)); }
#line 4308 "tools/widl/parser.tab.c"
    break;

  case 196: /* m_exprs: m_expr  */
#line 666 "tools/widl/parser.y"
                                                { (yyval.expr_list) = append_expr( NULL, (yyvsp[0].expr) ); }
#line 4314 "tools/widl/parser.tab.c"
    break;

  case 197: /* m_exprs: m_exprs ',' m_expr  */
#line 667 "tools/widl/parser.y"
                                                { (yyval.expr_list) = append_expr( (yyvsp[-2].expr_list), (yyvsp[0].expr) ); }
#line 4320 "tools/widl/parser.tab.c"
    break;

  case 198: /* m_expr: %empty  */
#line 670 "tools/widl/parser.y"
                                                { (yyval.expr) = make_expr(EXPR_VOID); }
#line 4326 "tools/widl/parser.tab.c"
    break;

  case 200: /* expr: aNUM  */
#line 674 "tools/widl/parser.y"
                                                { (yyval.expr) = make_exprl(EXPR_NUM, (yyvsp[0].num)); }
#line 4332 "tools/widl/parser.tab.c"
    break;

  case 201: /* expr: aHEXNUM  */
#line 675 "tools/widl/parser.y"
                                                { (yyval.expr) = make_exprl(EXPR_HEXNUM, (yyvsp[0].num)); }
#line 4338 "tools/widl/parser.tab.c"
    break;

  case 202: /* expr: aDOUBLE  */
#line 676 "tools/widl/parser.y"
                                                { (yyval.expr) = make_exprd(EXPR_DOUBLE, (yyvsp[0].dbl)); }
#line 4344 "tools/widl/parser.tab.c"
    break;

  case 203: /* expr: tFALSE  */
#line 677 "tools/widl/parser.y"
                                                { (yyval.expr) = make_exprl(EXPR_TRUEFALSE, 0); }
#line 4350 "tools/widl/parser.tab.c"
    break;

  case 204: /* expr: tNULL  */
#line 678 "tools/widl/parser.y"
                                                { (yyval.expr) = make_exprl(EXPR_NUM, 0); }
#line 4356 "tools/widl/parser.tab.c"
    break;

  case 205: /* expr: tTRUE  */
#line 679 "tools/widl/parser.y"
                                                { (yyval.expr) = make_exprl(EXPR_TRUEFALSE, 1); }
#line 4362 "tools/widl/parser.tab.c"
    break;

  case 206: /* expr: aSTRING  */
#line 680 "tools/widl/parser.y"
                                                { (yyval.expr) = make_exprs(EXPR_STRLIT, (yyvsp[0].str)); }
#line 4368 "tools/widl/parser.tab.c"
    break;

  case 207: /* expr: aWSTRING  */
#line 681 "tools/widl/parser.y"
                                                { (yyval.expr) = make_exprs(EXPR_WSTRLIT, (yyvsp[0].str)); }
#line 4374 "tools/widl/parser.tab.c"
    break;

  case 208: /* expr: aSQSTRING  */
#line 682 "tools/widl/parser.y"
                                                { (yyval.expr) = make_exprs(EXPR_CHARCONST, (yyvsp[0].str)); }
#line 4380 "tools/widl/parser.tab.c"
    break;

  case 209: /* expr: aIDENTIFIER  */
#line 683 "tools/widl/parser.y"
                                                { (yyval.expr) = make_exprs(EXPR_IDENTIFIER, (yyvsp[0].str)); }
#line 4386 "tools/widl/parser.tab.c"
    break;

  case 210: /* expr: expr '?' expr ':' expr  */
#line 684 "tools/widl/parser.y"
                                                { (yyval.expr) = make_expr3(EXPR_COND, (yyvsp[-4].expr), (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4392 "tools/widl/parser.tab.c"
    break;

  case 211: /* expr: expr LOGICALOR expr  */
#line 685 "tools/widl/parser.y"
                                                { (yyval.expr) = make_expr2(EXPR_LOGOR, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4398 "tools/widl/parser.tab.c"
    break;

  case 212: /* expr: expr LOGICALAND expr  */
#line 686 "tools/widl/parser.y"
                                                { (yyval.expr) = make_expr2(EXPR_LOGAND, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4404 "tools/widl/parser.tab.c"
    break;

  case 213: /* expr: expr '|' expr  */
#line 687 "tools/widl/parser.y"
                                                { (yyval.expr) = make_expr2(EXPR_OR , (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4410 "tools/widl/parser.tab.c"
    break;

  case 214: /* expr: expr '^' expr  */
#line 688 "tools/widl/parser.y"
                                                { (yyval.expr) = make_expr2(EXPR_XOR, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4416 "tools/widl/parser.tab.c"
    break;

  case 215: /* expr: expr '&' expr  */
#line 689 "tools/widl/parser.y"
                                                { (yyval.expr) = make_expr2(EXPR_AND, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4422 "tools/widl/parser.tab.c"
    break;

  case 216: /* expr: expr EQUALITY expr  */
#line 690 "tools/widl/parser.y"
                                                { (yyval.expr) = make_expr2(EXPR_EQUALITY, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4428 "tools/widl/parser.tab.c"
    break;

  case 217: /* expr: expr INEQUALITY expr  */
#line 691 "tools/widl/parser.y"
                                                { (yyval.expr) = make_expr2(EXPR_INEQUALITY, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4434 "tools/widl/parser.tab.c"
    break;

  case 218: /* expr: expr '>' expr  */
#line 692 "tools/widl/parser.y"
                                                { (yyval.expr) = make_expr2(EXPR_GTR, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4440 "tools/widl/parser.tab.c"
    break;

  case 219: /* expr: expr '<' expr  */
#line 693 "tools/widl/parser.y"
                                                { (yyval.expr) = make_expr2(EXPR_LESS, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4446 "tools/widl/parser.tab.c"
    break;

  case 220: /* expr: expr GREATEREQUAL expr  */
#line 694 "tools/widl/parser.y"
                                                { (yyval.expr) = make_expr2(EXPR_GTREQL, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4452 "tools/widl/parser.tab.c"
    break;

  case 221: /* expr: expr LESSEQUAL expr  */
#line 695 "tools/widl/parser.y"
                                                { (yyval.expr) = make_expr2(EXPR_LESSEQL, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4458 "tools/widl/parser.tab.c"
    break;

  case 222: /* expr: expr SHL expr  */
#line 696 "tools/widl/parser.y"
                                                { (yyval.expr) = make_expr2(EXPR_SHL, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4464 "tools/widl/parser.tab.c"
    break;

  case 223: /* expr: expr SHR expr  */
#line 697 "tools/widl/parser.y"
                                                { (yyval.expr) = make_expr2(EXPR_SHR, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4470 "tools/widl/parser.tab.c"
    break;

  case 224: /* expr: expr '+' expr  */
#line 698 "tools/widl/parser.y"
                                                { (yyval.expr) = make_expr2(EXPR_ADD, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4476 "tools/widl/parser.tab.c"
    break;

  case 225: /* expr: expr '-' expr  */
#line 699 "tools/widl/parser.y"
                                                { (yyval.expr) = make_expr2(EXPR_SUB, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4482 "tools/widl/parser.tab.c"
    break;

  case 226: /* expr: expr '%' expr  */
#line 700 "tools/widl/parser.y"
                                                { (yyval.expr) = make_expr2(EXPR_MOD, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4488 "tools/widl/parser.tab.c"
    break;

  case 227: /* expr: expr '*' expr  */
#line 701 "tools/widl/parser.y"
                                                { (yyval.expr) = make_expr2(EXPR_MUL, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4494 "tools/widl/parser.tab.c"
    break;

  case 228: /* expr: expr '/' expr  */
#line 702 "tools/widl/parser.y"
                                                { (yyval.expr) = make_expr2(EXPR_DIV, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4500 "tools/widl/parser.tab.c"
    break;

  case 229: /* expr: '!' expr  */
#line 703 "tools/widl/parser.y"
                                                { (yyval.expr) = make_expr1(EXPR_LOGNOT, (yyvsp[0].expr)); }
#line 4506 "tools/widl/parser.tab.c"
    break;

  case 230: /* expr: '~' expr  */
#line 704 "tools/widl/parser.y"
                                                { (yyval.expr) = make_expr1(EXPR_NOT, (yyvsp[0].expr)); }
#line 4512 "tools/widl/parser.tab.c"
    break;

  case 231: /* expr: '+' expr  */
#line 705 "tools/widl/parser.y"
                                                { (yyval.expr) = make_expr1(EXPR_POS, (yyvsp[0].expr)); }
#line 4518 "tools/widl/parser.tab.c"
    break;

  case 232: /* expr: '-' expr  */
#line 706 "tools/widl/parser.y"
                                                { (yyval.expr) = make_expr1(EXPR_NEG, (yyvsp[0].expr)); }
#line 4524 "tools/widl/parser.tab.c"
    break;

  case 233: /* expr: '&' expr  */
#line 707 "tools/widl/parser.y"
                                                { (yyval.expr) = make_expr1(EXPR_ADDRESSOF, (yyvsp[0].expr)); }
#line 4530 "tools/widl/parser.tab.c"
    break;

  case 234: /* expr: '*' expr  */
#line 708 "tools/widl/parser.y"
                                                { (yyval.expr) = make_expr1(EXPR_PPTR, (yyvsp[0].expr)); }
#line 4536 "tools/widl/parser.tab.c"
    break;

  case 235: /* expr: expr MEMBERPTR aIDENTIFIER  */
#line 709 "tools/widl/parser.y"
                                                { (yyval.expr) = make_expr2(EXPR_MEMBER, make_expr1(EXPR_PPTR, (yyvsp[-2].expr)), make_exprs(EXPR_IDENTIFIER, (yyvsp[0].str))); }
#line 4542 "tools/widl/parser.tab.c"
    break;

  case 236: /* expr: expr '.' aIDENTIFIER  */
#line 710 "tools/widl/parser.y"
                                                { (yyval.expr) = make_expr2(EXPR_MEMBER, (yyvsp[-2].expr), make_exprs(EXPR_IDENTIFIER, (yyvsp[0].str))); }
#line 4548 "tools/widl/parser.tab.c"
    break;

  case 237: /* expr: '(' decl_spec m_abstract_declarator ')' expr  */
#line 712 "tools/widl/parser.y"
                                                { (yyval.expr) = make_exprt(EXPR_CAST, declare_var(NULL, (yyvsp[-3].declspec), (yyvsp[-2].declarator), 0), (yyvsp[0].expr)); free((yyvsp[-3].declspec)); free((yyvsp[-2].declarator)); }
#line 4554 "tools/widl/parser.tab.c"
    break;

  case 238: /* expr: tSIZEOF '(' decl_spec m_abstract_declarator ')'  */
#line 714 "tools/widl/parser.y"
                                                { (yyval.expr) = make_exprt(EXPR_SIZEOF, declare_var(NULL, (yyvsp[-2].declspec), (yyvsp[-1].declarator), 0), NULL); free((yyvsp[-2].declspec)); free((yyvsp[-1].declarator)); }
#line 4560 "tools/widl/parser.tab.c"
    break;

  case 239: /* expr: expr '[' expr ']'  */
#line 715 "tools/widl/parser.y"
                                                { (yyval.expr) = make_expr2(EXPR_ARRAY, (yyvsp[-3].expr), (yyvsp[-1].expr)); }
#line 4566 "tools/widl/parser.tab.c"
    break;

  case 240: /* expr: '(' expr ')'  */
#line 716 "tools/widl/parser.y"
                                                { (yyval.expr) = (yyvsp[-1].expr); }
#line 4572 "tools/widl/parser.tab.c"
    break;

  case 241: /* expr_list_int_const: expr_int_const  */
#line 719 "tools/widl/parser.y"
                                                { (yyval.expr_list) = append_expr( NULL, (yyvsp[0].expr) ); }
#line 4578 "tools/widl/parser.tab.c"
    break;

  case 242: /* expr_list_int_const: expr_list_int_const ',' expr_int_const  */
#line 720 "tools/widl/parser.y"
                                                        { (yyval.expr_list) = append_expr( (yyvsp[-2].expr_list), (yyvsp[0].expr) ); }
#line 4584 "tools/widl/parser.tab.c"
    break;

  case 243: /* expr_int_const: expr  */
#line 723 "tools/widl/parser.y"
                                                { (yyval.expr) = (yyvsp[0].expr);
						  if (!(yyval.expr)->is_const)
						      error_loc("expression is not an integer constant\n");
						}
#line 4593 "tools/widl/parser.tab.c"
    break;

  case 244: /* expr_const: expr  */
#line 729 "tools/widl/parser.y"
                                                { (yyval.expr) = (yyvsp[0].expr);
						  if (!(yyval.expr)->is_const && (yyval.expr)->type != EXPR_STRLIT && (yyval.expr)->type != EXPR_WSTRLIT)
						      error_loc("expression is not constant\n");
						}
#line 4602 "tools/widl/parser.tab.c"
    break;

  case 245: /* fields: %empty  */
#line 735 "tools/widl/parser.y"
                                                { (yyval.var_list) = NULL; }
#line 4608 "tools/widl/parser.tab.c"
    break;

  case 246: /* fields: fields field  */
#line 736 "tools/widl/parser.y"
                                                { (yyval.var_list) = append_var_list((yyvsp[-1].var_list), (yyvsp[0].var_list)); }
#line 4614 "tools/widl/parser.tab.c"
    break;

  case 247: /* field: m_attributes decl_spec struct_declarator_list ';'  */
#line 740 "tools/widl/parser.y"
                                                { const char *first = LIST_ENTRY(list_head((yyvsp[-1].declarator_list)), declarator_t, entry)->var->name;
						  check_field_attrs(first, (yyvsp[-3].attr_list));
						  (yyval.var_list) = set_var_types((yyvsp[-3].attr_list), (yyvsp[-2].declspec), (yyvsp[-1].declarator_list));
						}
#line 4623 "tools/widl/parser.tab.c"
    break;

  case 248: /* field: m_attributes uniondef ';'  */
#line 744 "tools/widl/parser.y"
                                                { var_t *v = make_var(NULL);
						  v->declspec.type = (yyvsp[-1].type); v->attrs = (yyvsp[-2].attr_list);
						  (yyval.var_list) = append_var(NULL, v);
						}
#line 4632 "tools/widl/parser.tab.c"
    break;

  case 249: /* ne_union_field: s_field ';'  */
#line 751 "tools/widl/parser.y"
                                                { (yyval.var) = (yyvsp[-1].var); }
#line 4638 "tools/widl/parser.tab.c"
    break;

  case 250: /* ne_union_field: attributes ';'  */
#line 752 "tools/widl/parser.y"
                                                { (yyval.var) = make_var(NULL); (yyval.var)->attrs = (yyvsp[-1].attr_list); }
#line 4644 "tools/widl/parser.tab.c"
    break;

  case 251: /* ne_union_fields: %empty  */
#line 755 "tools/widl/parser.y"
                                                { (yyval.var_list) = NULL; }
#line 4650 "tools/widl/parser.tab.c"
    break;

  case 252: /* ne_union_fields: ne_union_fields ne_union_field  */
#line 756 "tools/widl/parser.y"
                                                { (yyval.var_list) = append_var( (yyvsp[-1].var_list), (yyvsp[0].var) ); }
#line 4656 "tools/widl/parser.tab.c"
    break;

  case 253: /* union_field: s_field ';'  */
#line 760 "tools/widl/parser.y"
                                                { (yyval.var) = (yyvsp[-1].var); }
#line 4662 "tools/widl/parser.tab.c"
    break;

  case 254: /* union_field: ';'  */
#line 761 "tools/widl/parser.y"
                                                { (yyval.var) = NULL; }
#line 4668 "tools/widl/parser.tab.c"
    break;

  case 255: /* s_field: m_attributes decl_spec declarator  */
#line 764 "tools/widl/parser.y"
                                                { (yyval.var) = declare_var(check_field_attrs((yyvsp[0].declarator)->var->name, (yyvsp[-2].attr_list)),
						                (yyvsp[-1].declspec), (yyvsp[0].declarator), FALSE);
						  free((yyvsp[0].declarator));
						}
#line 4677 "tools/widl/parser.tab.c"
    break;

  case 256: /* s_field: m_attributes structdef  */
#line 768 "tools/widl/parser.y"
                                                { var_t *v = make_var(NULL);
						  v->declspec.type = (yyvsp[0].type); v->attrs = (yyvsp[-1].attr_list);
						  (yyval.var) = v;
						}
#line 4686 "tools/widl/parser.tab.c"
    break;

  case 257: /* funcdef: declaration  */
#line 774 "tools/widl/parser.y"
                                                { (yyval.var) = (yyvsp[0].var);
						  if (type_get_type((yyval.var)->declspec.type) != TYPE_FUNCTION)
						    error_loc("only methods may be declared inside the methods section of a dispinterface\n");
						  check_function_attrs((yyval.var)->name, (yyval.var)->attrs);
						}
#line 4696 "tools/widl/parser.tab.c"
    break;

  case 258: /* declaration: attributes decl_spec init_declarator  */
#line 783 "tools/widl/parser.y"
                                                { (yyval.var) = declare_var((yyvsp[-2].attr_list), (yyvsp[-1].declspec), (yyvsp[0].declarator), FALSE);
						  free((yyvsp[0].declarator));
						}
#line 4704 "tools/widl/parser.tab.c"
    break;

  case 259: /* declaration: decl_spec init_declarator  */
#line 786 "tools/widl/parser.y"
                                                { (yyval.var) = declare_var(NULL, (yyvsp[-1].declspec), (yyvsp[0].declarator), FALSE);
						  free((yyvsp[0].declarator));
						}
#line 4712 "tools/widl/parser.tab.c"
    break;

  case 260: /* m_ident: %empty  */
#line 791 "tools/widl/parser.y"
                                                { (yyval.var) = NULL; }
#line 4718 "tools/widl/parser.tab.c"
    break;

  case 262: /* t_ident: %empty  */
#line 795 "tools/widl/parser.y"
                                                { (yyval.str) = NULL; }
#line 4724 "tools/widl/parser.tab.c"
    break;

  case 263: /* t_ident: aIDENTIFIER  */
#line 796 "tools/widl/parser.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 4730 "tools/widl/parser.tab.c"
    break;

  case 264: /* t_ident: aKNOWNTYPE  */
#line 797 "tools/widl/parser.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 4736 "tools/widl/parser.tab.c"
    break;

  case 265: /* ident: aIDENTIFIER  */
#line 800 "tools/widl/parser.y"
                                                { (yyval.var) = make_var((yyvsp[0].str)); }
#line 4742 "tools/widl/parser.tab.c"
    break;

  case 266: /* ident: aKNOWNTYPE  */
#line 802 "tools/widl/parser.y"
                                                { (yyval.var) = make_var((yyvsp[0].str)); }
#line 4748 "tools/widl/parser.tab.c"
    break;

  case 267: /* base_type: tBYTE  */
#line 805 "tools/widl/parser.y"
                                                { (yyval.type) = find_type_or_error((yyvsp[0].str), 0); }
#line 4754 "tools/widl/parser.tab.c"
    break;

  case 268: /* base_type: tWCHAR  */
#line 806 "tools/widl/parser.y"
                                                { (yyval.type) = find_type_or_error((yyvsp[0].str), 0); }
#line 4760 "tools/widl/parser.tab.c"
    break;

  case 270: /* base_type: tSIGNED int_std  */
#line 808 "tools/widl/parser.y"
                                                { (yyval.type) = type_new_int(type_basic_get_type((yyvsp[0].type)), -1); }
#line 4766 "tools/widl/parser.tab.c"
    break;

  case 271: /* base_type: tUNSIGNED int_std  */
#line 809 "tools/widl/parser.y"
                                                { (yyval.type) = type_new_int(type_basic_get_type((yyvsp[0].type)), 1); }
#line 4772 "tools/widl/parser.tab.c"
    break;

  case 272: /* base_type: tUNSIGNED  */
#line 810 "tools/widl/parser.y"
                                                { (yyval.type) = type_new_int(TYPE_BASIC_INT, 1); }
#line 4778 "tools/widl/parser.tab.c"
    break;

  case 273: /* base_type: tFLOAT  */
#line 811 "tools/widl/parser.y"
                                                { (yyval.type) = find_type_or_error((yyvsp[0].str), 0); }
#line 4784 "tools/widl/parser.tab.c"
    break;

  case 274: /* base_type: tDOUBLE  */
#line 812 "tools/widl/parser.y"
                                                { (yyval.type) = find_type_or_error((yyvsp[0].str), 0); }
#line 4790 "tools/widl/parser.tab.c"
    break;

  case 275: /* base_type: tBOOLEAN  */
#line 813 "tools/widl/parser.y"
                                                { (yyval.type) = find_type_or_error((yyvsp[0].str), 0); }
#line 4796 "tools/widl/parser.tab.c"
    break;

  case 276: /* base_type: tERRORSTATUST  */
#line 814 "tools/widl/parser.y"
                                                { (yyval.type) = find_type_or_error((yyvsp[0].str), 0); }
#line 4802 "tools/widl/parser.tab.c"
    break;

  case 277: /* base_type: tHANDLET  */
#line 815 "tools/widl/parser.y"
                                                { (yyval.type) = find_type_or_error((yyvsp[0].str), 0); }
#line 4808 "tools/widl/parser.tab.c"
    break;

  case 280: /* int_std: tINT  */
#line 822 "tools/widl/parser.y"
                                                { (yyval.type) = type_new_int(TYPE_BASIC_INT, 0); }
#line 4814 "tools/widl/parser.tab.c"
    break;

  case 281: /* int_std: tSHORT m_int  */
#line 823 "tools/widl/parser.y"
                                                { (yyval.type) = type_new_int(TYPE_BASIC_INT16, 0); }
#line 4820 "tools/widl/parser.tab.c"
    break;

  case 282: /* int_std: tSMALL  */
#line 824 "tools/widl/parser.y"
                                                { (yyval.type) = type_new_int(TYPE_BASIC_INT8, 0); }
#line 4826 "tools/widl/parser.tab.c"
    break;

  case 283: /* int_std: tLONG m_int  */
#line 825 "tools/widl/parser.y"
                                                { (yyval.type) = type_new_int(TYPE_BASIC_LONG, 0); }
#line 4832 "tools/widl/parser.tab.c"
    break;

  case 284: /* int_std: tHYPER m_int  */
#line 826 "tools/widl/parser.y"
                                                { (yyval.type) = type_new_int(TYPE_BASIC_HYPER, 0); }
#line 4838 "tools/widl/parser.tab.c"
    break;

  case 285: /* int_std: tINT64  */
#line 827 "tools/widl/parser.y"
                                                { (yyval.type) = type_new_int(TYPE_BASIC_INT64, 0); }
#line 4844 "tools/widl/parser.tab.c"
    break;

  case 286: /* int_std: tCHAR  */
#line 828 "tools/widl/parser.y"
                                                { (yyval.type) = type_new_int(TYPE_BASIC_CHAR, 0); }
#line 4850 "tools/widl/parser.tab.c"
    break;

  case 287: /* int_std: tINT32  */
#line 829 "tools/widl/parser.y"
                                                { (yyval.type) = type_new_int(TYPE_BASIC_INT32, 0); }
#line 4856 "tools/widl/parser.tab.c"
    break;

  case 288: /* int_std: tINT3264  */
#line 830 "tools/widl/parser.y"
                                                { (yyval.type) = type_new_int(TYPE_BASIC_INT3264, 0); }
#line 4862 "tools/widl/parser.tab.c"
    break;

  case 289: /* qualified_seq: aKNOWNTYPE  */
#line 834 "tools/widl/parser.y"
                      { (yyval.type) = find_type_or_error((yyvsp[0].str), 0); }
#line 4868 "tools/widl/parser.tab.c"
    break;

  case 290: /* $@3: %empty  */
#line 835 "tools/widl/parser.y"
                      { push_lookup_namespace((yyvsp[-1].str)); }
#line 4874 "tools/widl/parser.tab.c"
    break;

  case 291: /* qualified_seq: aIDENTIFIER '.' $@3 qualified_seq  */
#line 835 "tools/widl/parser.y"
                                                                   { (yyval.type) = (yyvsp[0].type); }
#line 4880 "tools/widl/parser.tab.c"
    break;

  case 292: /* qualified_type: aKNOWNTYPE  */
#line 839 "tools/widl/parser.y"
                     { (yyval.type) = find_type_or_error((yyvsp[0].str), 0); }
#line 4886 "tools/widl/parser.tab.c"
    break;

  case 293: /* $@4: %empty  */
#line 840 "tools/widl/parser.y"
                     { init_lookup_namespace((yyvsp[-1].str)); }
#line 4892 "tools/widl/parser.tab.c"
    break;

  case 294: /* qualified_type: aNAMESPACE '.' $@4 qualified_seq  */
#line 840 "tools/widl/parser.y"
                                                                  { (yyval.type) = (yyvsp[0].type); }
#line 4898 "tools/widl/parser.tab.c"
    break;

  case 295: /* coclass: tCOCLASS aIDENTIFIER  */
#line 843 "tools/widl/parser.y"
                                                { (yyval.type) = type_new_coclass((yyvsp[0].str)); }
#line 4904 "tools/widl/parser.tab.c"
    break;

  case 296: /* coclass: tCOCLASS aKNOWNTYPE  */
#line 844 "tools/widl/parser.y"
                                                { (yyval.type) = find_type((yyvsp[0].str), NULL, 0);
						  if (type_get_type_detect_alias((yyval.type)) != TYPE_COCLASS)
						    error_loc("%s was not declared a coclass at %s:%d\n",
							      (yyvsp[0].str), (yyval.type)->loc_info.input_name,
							      (yyval.type)->loc_info.line_number);
						}
#line 4915 "tools/widl/parser.tab.c"
    break;

  case 297: /* coclasshdr: attributes coclass  */
#line 852 "tools/widl/parser.y"
                                                { (yyval.type) = (yyvsp[0].type);
						  check_def((yyval.type));
						  (yyval.type)->attrs = check_coclass_attrs((yyvsp[0].type)->name, (yyvsp[-1].attr_list));
						}
#line 4924 "tools/widl/parser.tab.c"
    break;

  case 298: /* coclassdef: coclasshdr '{' coclass_ints '}' semicolon_opt  */
#line 859 "tools/widl/parser.y"
                                                { (yyval.type) = type_coclass_define((yyvsp[-4].type), (yyvsp[-2].ifref_list)); }
#line 4930 "tools/widl/parser.tab.c"
    break;

  case 299: /* namespacedef: tNAMESPACE aIDENTIFIER  */
#line 862 "tools/widl/parser.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 4936 "tools/widl/parser.tab.c"
    break;

  case 300: /* namespacedef: tNAMESPACE aNAMESPACE  */
#line 863 "tools/widl/parser.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 4942 "tools/widl/parser.tab.c"
    break;

  case 301: /* coclass_ints: %empty  */
#line 866 "tools/widl/parser.y"
                                                { (yyval.ifref_list) = NULL; }
#line 4948 "tools/widl/parser.tab.c"
    break;

  case 302: /* coclass_ints: coclass_ints coclass_int  */
#line 867 "tools/widl/parser.y"
                                                { (yyval.ifref_list) = append_ifref( (yyvsp[-1].ifref_list), (yyvsp[0].ifref) ); }
#line 4954 "tools/widl/parser.tab.c"
    break;

  case 303: /* coclass_int: m_attributes interfacedec  */
#line 871 "tools/widl/parser.y"
                                                { (yyval.ifref) = make_ifref((yyvsp[0].type)); (yyval.ifref)->attrs = (yyvsp[-1].attr_list); }
#line 4960 "tools/widl/parser.tab.c"
    break;

  case 304: /* dispinterface: tDISPINTERFACE aIDENTIFIER  */
#line 874 "tools/widl/parser.y"
                                                { (yyval.type) = get_type(TYPE_INTERFACE, (yyvsp[0].str), current_namespace, 0); }
#line 4966 "tools/widl/parser.tab.c"
    break;

  case 305: /* dispinterface: tDISPINTERFACE aKNOWNTYPE  */
#line 875 "tools/widl/parser.y"
                                                { (yyval.type) = get_type(TYPE_INTERFACE, (yyvsp[0].str), current_namespace, 0); }
#line 4972 "tools/widl/parser.tab.c"
    break;

  case 306: /* dispinterfacehdr: attributes dispinterface  */
#line 878 "tools/widl/parser.y"
                                                { attr_t *attrs;
						  (yyval.type) = (yyvsp[0].type);
						  check_def((yyval.type));
						  attrs = make_attr(ATTR_DISPINTERFACE);
						  (yyval.type)->attrs = append_attr( check_dispiface_attrs((yyvsp[0].type)->name, (yyvsp[-1].attr_list)), attrs );
						  (yyval.type)->defined = TRUE;
						}
#line 4984 "tools/widl/parser.tab.c"
    break;

  case 307: /* dispint_props: tPROPERTIES ':'  */
#line 887 "tools/widl/parser.y"
                                                { (yyval.var_list) = NULL; }
#line 4990 "tools/widl/parser.tab.c"
    break;

  case 308: /* dispint_props: dispint_props s_field ';'  */
#line 888 "tools/widl/parser.y"
                                                { (yyval.var_list) = append_var( (yyvsp[-2].var_list), (yyvsp[-1].var) ); }
#line 4996 "tools/widl/parser.tab.c"
    break;

  case 309: /* dispint_meths: tMETHODS ':'  */
#line 891 "tools/widl/parser.y"
                                                { (yyval.var_list) = NULL; }
#line 5002 "tools/widl/parser.tab.c"
    break;

  case 310: /* dispint_meths: dispint_meths funcdef ';'  */
#line 892 "tools/widl/parser.y"
                                                { (yyval.var_list) = append_var( (yyvsp[-2].var_list), (yyvsp[-1].var) ); }
#line 5008 "tools/widl/parser.tab.c"
    break;

  case 311: /* dispinterfacedef: dispinterfacehdr '{' dispint_props dispint_meths '}'  */
#line 898 "tools/widl/parser.y"
                                                { (yyval.type) = (yyvsp[-4].type);
						  type_dispinterface_define((yyval.type), (yyvsp[-2].var_list), (yyvsp[-1].var_list));
						}
#line 5016 "tools/widl/parser.tab.c"
    break;

  case 312: /* dispinterfacedef: dispinterfacehdr '{' interface ';' '}'  */
#line 902 "tools/widl/parser.y"
                                                { (yyval.type) = (yyvsp[-4].type);
						  type_dispinterface_define_from_iface((yyval.type), (yyvsp[-2].type));
						}
#line 5024 "tools/widl/parser.tab.c"
    break;

  case 313: /* inherit: %empty  */
#line 907 "tools/widl/parser.y"
                                                { (yyval.type) = NULL; }
#line 5030 "tools/widl/parser.tab.c"
    break;

  case 314: /* inherit: ':' qualified_type  */
#line 908 "tools/widl/parser.y"
                                                { (yyval.type) = (yyvsp[0].type); }
#line 5036 "tools/widl/parser.tab.c"
    break;

  case 315: /* interface: tINTERFACE aIDENTIFIER  */
#line 911 "tools/widl/parser.y"
                                                { (yyval.type) = get_type(TYPE_INTERFACE, (yyvsp[0].str), current_namespace, 0); }
#line 5042 "tools/widl/parser.tab.c"
    break;

  case 316: /* interface: tINTERFACE aKNOWNTYPE  */
#line 912 "tools/widl/parser.y"
                                                { (yyval.type) = get_type(TYPE_INTERFACE, (yyvsp[0].str), current_namespace, 0); }
#line 5048 "tools/widl/parser.tab.c"
    break;

  case 317: /* interfacehdr: attributes interface  */
#line 915 "tools/widl/parser.y"
                                                { (yyval.type) = (yyvsp[0].type);
						  check_def((yyvsp[0].type));
						  (yyvsp[0].type)->attrs = check_iface_attrs((yyvsp[0].type)->name, (yyvsp[-1].attr_list));
						  (yyvsp[0].type)->defined = TRUE;
						}
#line 5058 "tools/widl/parser.tab.c"
    break;

  case 318: /* interfacedef: interfacehdr inherit '{' int_statements '}' semicolon_opt  */
#line 923 "tools/widl/parser.y"
                                                { (yyval.type) = (yyvsp[-5].type);
						  if((yyval.type) == (yyvsp[-4].type))
						    error_loc("Interface can't inherit from itself\n");
						  type_interface_define((yyval.type), (yyvsp[-4].type), (yyvsp[-2].stmt_list));
						  check_async_uuid((yyval.type));
						}
#line 5069 "tools/widl/parser.tab.c"
    break;

  case 319: /* interfacedef: interfacehdr ':' aIDENTIFIER '{' import int_statements '}' semicolon_opt  */
#line 933 "tools/widl/parser.y"
                                                { (yyval.type) = (yyvsp[-7].type);
						  type_interface_define((yyval.type), find_type_or_error2((yyvsp[-5].str), 0), (yyvsp[-2].stmt_list));
						}
#line 5077 "tools/widl/parser.tab.c"
    break;

  case 320: /* interfacedef: dispinterfacedef semicolon_opt  */
#line 936 "tools/widl/parser.y"
                                                { (yyval.type) = (yyvsp[-1].type); }
#line 5083 "tools/widl/parser.tab.c"
    break;

  case 321: /* interfacedec: interface ';'  */
#line 940 "tools/widl/parser.y"
                                                { (yyval.type) = (yyvsp[-1].type); }
#line 5089 "tools/widl/parser.tab.c"
    break;

  case 322: /* interfacedec: dispinterface ';'  */
#line 941 "tools/widl/parser.y"
                                                { (yyval.type) = (yyvsp[-1].type); }
#line 5095 "tools/widl/parser.tab.c"
    break;

  case 323: /* module: tMODULE aIDENTIFIER  */
#line 944 "tools/widl/parser.y"
                                                { (yyval.type) = type_new_module((yyvsp[0].str)); }
#line 5101 "tools/widl/parser.tab.c"
    break;

  case 324: /* module: tMODULE aKNOWNTYPE  */
#line 945 "tools/widl/parser.y"
                                                { (yyval.type) = type_new_module((yyvsp[0].str)); }
#line 5107 "tools/widl/parser.tab.c"
    break;

  case 325: /* modulehdr: attributes module  */
#line 948 "tools/widl/parser.y"
                                                { (yyval.type) = (yyvsp[0].type);
						  (yyval.type)->attrs = check_module_attrs((yyvsp[0].type)->name, (yyvsp[-1].attr_list));
						}
#line 5115 "tools/widl/parser.tab.c"
    break;

  case 326: /* moduledef: modulehdr '{' int_statements '}' semicolon_opt  */
#line 954 "tools/widl/parser.y"
                                                { (yyval.type) = (yyvsp[-4].type);
                                                  type_module_define((yyval.type), (yyvsp[-2].stmt_list));
						}
#line 5123 "tools/widl/parser.tab.c"
    break;

  case 327: /* storage_cls_spec: tEXTERN  */
#line 960 "tools/widl/parser.y"
                                                { (yyval.stgclass) = STG_EXTERN; }
#line 5129 "tools/widl/parser.tab.c"
    break;

  case 328: /* storage_cls_spec: tSTATIC  */
#line 961 "tools/widl/parser.y"
                                                { (yyval.stgclass) = STG_STATIC; }
#line 5135 "tools/widl/parser.tab.c"
    break;

  case 329: /* storage_cls_spec: tREGISTER  */
#line 962 "tools/widl/parser.y"
                                                { (yyval.stgclass) = STG_REGISTER; }
#line 5141 "tools/widl/parser.tab.c"
    break;

  case 330: /* function_specifier: tINLINE  */
#line 966 "tools/widl/parser.y"
                                                { (yyval.function_specifier) = FUNCTION_SPECIFIER_INLINE; }
#line 5147 "tools/widl/parser.tab.c"
    break;

  case 331: /* type_qualifier: tCONST  */
#line 970 "tools/widl/parser.y"
                                                { (yyval.type_qualifier) = TYPE_QUALIFIER_CONST; }
#line 5153 "tools/widl/parser.tab.c"
    break;

  case 332: /* m_type_qual_list: %empty  */
#line 973 "tools/widl/parser.y"
                                                { (yyval.type_qualifier) = 0; }
#line 5159 "tools/widl/parser.tab.c"
    break;

  case 333: /* m_type_qual_list: m_type_qual_list type_qualifier  */
#line 974 "tools/widl/parser.y"
                                                { (yyval.type_qualifier) = (yyvsp[-1].type_qualifier) | (yyvsp[0].type_qualifier); }
#line 5165 "tools/widl/parser.tab.c"
    break;

  case 334: /* decl_spec: type m_decl_spec_no_type  */
#line 977 "tools/widl/parser.y"
                                                { (yyval.declspec) = make_decl_spec((yyvsp[-1].type), (yyvsp[0].declspec), NULL, STG_NONE, 0, 0); }
#line 5171 "tools/widl/parser.tab.c"
    break;

  case 335: /* decl_spec: decl_spec_no_type type m_decl_spec_no_type  */
#line 979 "tools/widl/parser.y"
                                                { (yyval.declspec) = make_decl_spec((yyvsp[-1].type), (yyvsp[-2].declspec), (yyvsp[0].declspec), STG_NONE, 0, 0); }
#line 5177 "tools/widl/parser.tab.c"
    break;

  case 336: /* m_decl_spec_no_type: %empty  */
#line 982 "tools/widl/parser.y"
                                                { (yyval.declspec) = NULL; }
#line 5183 "tools/widl/parser.tab.c"
    break;

  case 338: /* decl_spec_no_type: type_qualifier m_decl_spec_no_type  */
#line 987 "tools/widl/parser.y"
                                                { (yyval.declspec) = make_decl_spec(NULL, (yyvsp[0].declspec), NULL, STG_NONE, (yyvsp[-1].type_qualifier), 0); }
#line 5189 "tools/widl/parser.tab.c"
    break;

  case 339: /* decl_spec_no_type: function_specifier m_decl_spec_no_type  */
#line 988 "tools/widl/parser.y"
                                                  { (yyval.declspec) = make_decl_spec(NULL, (yyvsp[0].declspec), NULL, STG_NONE, 0, (yyvsp[-1].function_specifier)); }
#line 5195 "tools/widl/parser.tab.c"
    break;

  case 340: /* decl_spec_no_type: storage_cls_spec m_decl_spec_no_type  */
#line 989 "tools/widl/parser.y"
                                                { (yyval.declspec) = make_decl_spec(NULL, (yyvsp[0].declspec), NULL, (yyvsp[-1].stgclass), 0, 0); }
#line 5201 "tools/widl/parser.tab.c"
    break;

  case 341: /* declarator: '*' m_type_qual_list declarator  */
#line 994 "tools/widl/parser.y"
                                                { (yyval.declarator) = (yyvsp[0].declarator); append_chain_type((yyval.declarator), type_new_pointer(NULL), (yyvsp[-1].type_qualifier)); }
#line 5207 "tools/widl/parser.tab.c"
    break;

  case 342: /* declarator: callconv declarator  */
#line 995 "tools/widl/parser.y"
                                                { (yyval.declarator) = (yyvsp[0].declarator); append_chain_callconv((yyval.declarator)->type, (yyvsp[-1].str)); }
#line 5213 "tools/widl/parser.tab.c"
    break;

  case 344: /* direct_declarator: ident  */
#line 1000 "tools/widl/parser.y"
                                                { (yyval.declarator) = make_declarator((yyvsp[0].var)); }
#line 5219 "tools/widl/parser.tab.c"
    break;

  case 345: /* direct_declarator: '(' declarator ')'  */
#line 1001 "tools/widl/parser.y"
                                                { (yyval.declarator) = (yyvsp[-1].declarator); }
#line 5225 "tools/widl/parser.tab.c"
    break;

  case 346: /* direct_declarator: direct_declarator array  */
#line 1002 "tools/widl/parser.y"
                                                { (yyval.declarator) = (yyvsp[-1].declarator); append_array((yyval.declarator), (yyvsp[0].expr)); }
#line 5231 "tools/widl/parser.tab.c"
    break;

  case 347: /* direct_declarator: direct_declarator '(' m_args ')'  */
#line 1003 "tools/widl/parser.y"
                                                { (yyval.declarator) = (yyvsp[-3].declarator); append_chain_type((yyval.declarator), type_new_function((yyvsp[-1].var_list)), 0); }
#line 5237 "tools/widl/parser.tab.c"
    break;

  case 348: /* abstract_declarator: '*' m_type_qual_list m_abstract_declarator  */
#line 1009 "tools/widl/parser.y"
                                                { (yyval.declarator) = (yyvsp[0].declarator); append_chain_type((yyval.declarator), type_new_pointer(NULL), (yyvsp[-1].type_qualifier)); }
#line 5243 "tools/widl/parser.tab.c"
    break;

  case 349: /* abstract_declarator: callconv m_abstract_declarator  */
#line 1010 "tools/widl/parser.y"
                                                { (yyval.declarator) = (yyvsp[0].declarator); append_chain_callconv((yyval.declarator)->type, (yyvsp[-1].str)); }
#line 5249 "tools/widl/parser.tab.c"
    break;

  case 351: /* abstract_declarator_no_direct: '*' m_type_qual_list m_any_declarator  */
#line 1017 "tools/widl/parser.y"
                                                { (yyval.declarator) = (yyvsp[0].declarator); append_chain_type((yyval.declarator), type_new_pointer(NULL), (yyvsp[-1].type_qualifier)); }
#line 5255 "tools/widl/parser.tab.c"
    break;

  case 352: /* abstract_declarator_no_direct: callconv m_any_declarator  */
#line 1018 "tools/widl/parser.y"
                                                { (yyval.declarator) = (yyvsp[0].declarator); append_chain_callconv((yyval.declarator)->type, (yyvsp[-1].str)); }
#line 5261 "tools/widl/parser.tab.c"
    break;

  case 353: /* m_abstract_declarator: %empty  */
#line 1022 "tools/widl/parser.y"
                                                { (yyval.declarator) = make_declarator(NULL); }
#line 5267 "tools/widl/parser.tab.c"
    break;

  case 355: /* abstract_direct_declarator: '(' abstract_declarator_no_direct ')'  */
#line 1028 "tools/widl/parser.y"
                                                { (yyval.declarator) = (yyvsp[-1].declarator); }
#line 5273 "tools/widl/parser.tab.c"
    break;

  case 356: /* abstract_direct_declarator: abstract_direct_declarator array  */
#line 1029 "tools/widl/parser.y"
                                                { (yyval.declarator) = (yyvsp[-1].declarator); append_array((yyval.declarator), (yyvsp[0].expr)); }
#line 5279 "tools/widl/parser.tab.c"
    break;

  case 357: /* abstract_direct_declarator: array  */
#line 1030 "tools/widl/parser.y"
                                                { (yyval.declarator) = make_declarator(NULL); append_array((yyval.declarator), (yyvsp[0].expr)); }
#line 5285 "tools/widl/parser.tab.c"
    break;

  case 358: /* abstract_direct_declarator: '(' m_args ')'  */
#line 1032 "tools/widl/parser.y"
                                                { (yyval.declarator) = make_declarator(NULL);
						  append_chain_type((yyval.declarator), type_new_function((yyvsp[-1].var_list)), 0);
						}
#line 5293 "tools/widl/parser.tab.c"
    break;

  case 359: /* abstract_direct_declarator: abstract_direct_declarator '(' m_args ')'  */
#line 1036 "tools/widl/parser.y"
                                                { (yyval.declarator) = (yyvsp[-3].declarator);
						  append_chain_type((yyval.declarator), type_new_function((yyvsp[-1].var_list)), 0);
						}
#line 5301 "tools/widl/parser.tab.c"
    break;

  case 360: /* any_declarator: '*' m_type_qual_list m_any_declarator  */
#line 1044 "tools/widl/parser.y"
                                                { (yyval.declarator) = (yyvsp[0].declarator); append_chain_type((yyval.declarator), type_new_pointer(NULL), (yyvsp[-1].type_qualifier)); }
#line 5307 "tools/widl/parser.tab.c"
    break;

  case 361: /* any_declarator: callconv m_any_declarator  */
#line 1045 "tools/widl/parser.y"
                                                { (yyval.declarator) = (yyvsp[0].declarator); append_chain_callconv((yyval.declarator)->type, (yyvsp[-1].str)); }
#line 5313 "tools/widl/parser.tab.c"
    break;

  case 363: /* any_declarator_no_direct: '*' m_type_qual_list m_any_declarator  */
#line 1052 "tools/widl/parser.y"
                                                { (yyval.declarator) = (yyvsp[0].declarator); append_chain_type((yyval.declarator), type_new_pointer(NULL), (yyvsp[-1].type_qualifier)); }
#line 5319 "tools/widl/parser.tab.c"
    break;

  case 364: /* any_declarator_no_direct: callconv m_any_declarator  */
#line 1053 "tools/widl/parser.y"
                                                { (yyval.declarator) = (yyvsp[0].declarator); append_chain_callconv((yyval.declarator)->type, (yyvsp[-1].str)); }
#line 5325 "tools/widl/parser.tab.c"
    break;

  case 365: /* m_any_declarator: %empty  */
#line 1057 "tools/widl/parser.y"
                                                { (yyval.declarator) = make_declarator(NULL); }
#line 5331 "tools/widl/parser.tab.c"
    break;

  case 367: /* any_direct_declarator: ident  */
#line 1065 "tools/widl/parser.y"
                                                { (yyval.declarator) = make_declarator((yyvsp[0].var)); }
#line 5337 "tools/widl/parser.tab.c"
    break;

  case 368: /* any_direct_declarator: '(' any_declarator_no_direct ')'  */
#line 1066 "tools/widl/parser.y"
                                                { (yyval.declarator) = (yyvsp[-1].declarator); }
#line 5343 "tools/widl/parser.tab.c"
    break;

  case 369: /* any_direct_declarator: any_direct_declarator array  */
#line 1067 "tools/widl/parser.y"
                                                { (yyval.declarator) = (yyvsp[-1].declarator); append_array((yyval.declarator), (yyvsp[0].expr)); }
#line 5349 "tools/widl/parser.tab.c"
    break;

  case 370: /* any_direct_declarator: array  */
#line 1068 "tools/widl/parser.y"
                                                { (yyval.declarator) = make_declarator(NULL); append_array((yyval.declarator), (yyvsp[0].expr)); }
#line 5355 "tools/widl/parser.tab.c"
    break;

  case 371: /* any_direct_declarator: '(' m_args ')'  */
#line 1070 "tools/widl/parser.y"
                                                { (yyval.declarator) = make_declarator(NULL);
						  append_chain_type((yyval.declarator), type_new_function((yyvsp[-1].var_list)), 0);
						}
#line 5363 "tools/widl/parser.tab.c"
    break;

  case 372: /* any_direct_declarator: any_direct_declarator '(' m_args ')'  */
#line 1074 "tools/widl/parser.y"
                                                { (yyval.declarator) = (yyvsp[-3].declarator);
						  append_chain_type((yyval.declarator), type_new_function((yyvsp[-1].var_list)), 0);
						}
#line 5371 "tools/widl/parser.tab.c"
    break;

  case 373: /* declarator_list: declarator  */
#line 1080 "tools/widl/parser.y"
                                                { (yyval.declarator_list) = append_declarator( NULL, (yyvsp[0].declarator) ); }
#line 5377 "tools/widl/parser.tab.c"
    break;

  case 374: /* declarator_list: declarator_list ',' declarator  */
#line 1081 "tools/widl/parser.y"
                                                { (yyval.declarator_list) = append_declarator( (yyvsp[-2].declarator_list), (yyvsp[0].declarator) ); }
#line 5383 "tools/widl/parser.tab.c"
    break;

  case 375: /* m_bitfield: %empty  */
#line 1084 "tools/widl/parser.y"
                                                { (yyval.expr) = NULL; }
#line 5389 "tools/widl/parser.tab.c"
    break;

  case 376: /* m_bitfield: ':' expr_const  */
#line 1085 "tools/widl/parser.y"
                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 5395 "tools/widl/parser.tab.c"
    break;

  case 377: /* struct_declarator: any_declarator m_bitfield  */
#line 1088 "tools/widl/parser.y"
                                                { (yyval.declarator) = (yyvsp[-1].declarator); (yyval.declarator)->bits = (yyvsp[0].expr);
						  if (!(yyval.declarator)->bits && !(yyval.declarator)->var->name)
						    error_loc("unnamed fields are not allowed\n");
						}
#line 5404 "tools/widl/parser.tab.c"
    break;

  case 378: /* struct_declarator_list: struct_declarator  */
#line 1095 "tools/widl/parser.y"
                                                { (yyval.declarator_list) = append_declarator( NULL, (yyvsp[0].declarator) ); }
#line 5410 "tools/widl/parser.tab.c"
    break;

  case 379: /* struct_declarator_list: struct_declarator_list ',' struct_declarator  */
#line 1097 "tools/widl/parser.y"
                                                { (yyval.declarator_list) = append_declarator( (yyvsp[-2].declarator_list), (yyvsp[0].declarator) ); }
#line 5416 "tools/widl/parser.tab.c"
    break;

  case 380: /* init_declarator: declarator  */
#line 1101 "tools/widl/parser.y"
                                                { (yyval.declarator) = (yyvsp[0].declarator); }
#line 5422 "tools/widl/parser.tab.c"
    break;

  case 381: /* init_declarator: declarator '=' expr_const  */
#line 1102 "tools/widl/parser.y"
                                                { (yyval.declarator) = (yyvsp[-2].declarator); (yyvsp[-2].declarator)->var->eval = (yyvsp[0].expr); }
#line 5428 "tools/widl/parser.tab.c"
    break;

  case 382: /* threading_type: tAPARTMENT  */
#line 1106 "tools/widl/parser.y"
                                                { (yyval.num) = THREADING_APARTMENT; }
#line 5434 "tools/widl/parser.tab.c"
    break;

  case 383: /* threading_type: tNEUTRAL  */
#line 1107 "tools/widl/parser.y"
                                                { (yyval.num) = THREADING_NEUTRAL; }
#line 5440 "tools/widl/parser.tab.c"
    break;

  case 384: /* threading_type: tSINGLE  */
#line 1108 "tools/widl/parser.y"
                                                { (yyval.num) = THREADING_SINGLE; }
#line 5446 "tools/widl/parser.tab.c"
    break;

  case 385: /* threading_type: tFREE  */
#line 1109 "tools/widl/parser.y"
                                                { (yyval.num) = THREADING_FREE; }
#line 5452 "tools/widl/parser.tab.c"
    break;

  case 386: /* threading_type: tBOTH  */
#line 1110 "tools/widl/parser.y"
                                                { (yyval.num) = THREADING_BOTH; }
#line 5458 "tools/widl/parser.tab.c"
    break;

  case 387: /* pointer_type: tREF  */
#line 1114 "tools/widl/parser.y"
                                                { (yyval.num) = FC_RP; }
#line 5464 "tools/widl/parser.tab.c"
    break;

  case 388: /* pointer_type: tUNIQUE  */
#line 1115 "tools/widl/parser.y"
                                                { (yyval.num) = FC_UP; }
#line 5470 "tools/widl/parser.tab.c"
    break;

  case 389: /* pointer_type: tPTR  */
#line 1116 "tools/widl/parser.y"
                                                { (yyval.num) = FC_FP; }
#line 5476 "tools/widl/parser.tab.c"
    break;

  case 390: /* structdef: tSTRUCT t_ident '{' fields '}'  */
#line 1119 "tools/widl/parser.y"
                                                { (yyval.type) = type_new_struct((yyvsp[-3].str), current_namespace, TRUE, (yyvsp[-1].var_list)); }
#line 5482 "tools/widl/parser.tab.c"
    break;

  case 391: /* type: tVOID  */
#line 1122 "tools/widl/parser.y"
                                                { (yyval.type) = type_new_void(); }
#line 5488 "tools/widl/parser.tab.c"
    break;

  case 392: /* type: qualified_type  */
#line 1123 "tools/widl/parser.y"
                                                { (yyval.type) = (yyvsp[0].type); }
#line 5494 "tools/widl/parser.tab.c"
    break;

  case 393: /* type: base_type  */
#line 1124 "tools/widl/parser.y"
                                                { (yyval.type) = (yyvsp[0].type); }
#line 5500 "tools/widl/parser.tab.c"
    break;

  case 394: /* type: enumdef  */
#line 1125 "tools/widl/parser.y"
                                                { (yyval.type) = (yyvsp[0].type); }
#line 5506 "tools/widl/parser.tab.c"
    break;

  case 395: /* type: tENUM aIDENTIFIER  */
#line 1126 "tools/widl/parser.y"
                                                { (yyval.type) = type_new_enum((yyvsp[0].str), current_namespace, FALSE, NULL); }
#line 5512 "tools/widl/parser.tab.c"
    break;

  case 396: /* type: structdef  */
#line 1127 "tools/widl/parser.y"
                                                { (yyval.type) = (yyvsp[0].type); }
#line 5518 "tools/widl/parser.tab.c"
    break;

  case 397: /* type: tSTRUCT aIDENTIFIER  */
#line 1128 "tools/widl/parser.y"
                                                { (yyval.type) = type_new_struct((yyvsp[0].str), current_namespace, FALSE, NULL); }
#line 5524 "tools/widl/parser.tab.c"
    break;

  case 398: /* type: uniondef  */
#line 1129 "tools/widl/parser.y"
                                                { (yyval.type) = (yyvsp[0].type); }
#line 5530 "tools/widl/parser.tab.c"
    break;

  case 399: /* type: tUNION aIDENTIFIER  */
#line 1130 "tools/widl/parser.y"
                                                { (yyval.type) = type_new_nonencapsulated_union((yyvsp[0].str), FALSE, NULL); }
#line 5536 "tools/widl/parser.tab.c"
    break;

  case 400: /* type: tSAFEARRAY '(' type ')'  */
#line 1131 "tools/widl/parser.y"
                                                { (yyval.type) = make_safearray((yyvsp[-1].type)); }
#line 5542 "tools/widl/parser.tab.c"
    break;

  case 401: /* typedef: m_attributes tTYPEDEF m_attributes decl_spec declarator_list  */
#line 1135 "tools/widl/parser.y"
                                                { (yyvsp[-4].attr_list) = append_attribs((yyvsp[-4].attr_list), (yyvsp[-2].attr_list));
						  reg_typedefs((yyvsp[-1].declspec), (yyvsp[0].declarator_list), check_typedef_attrs((yyvsp[-4].attr_list)));
						  (yyval.statement) = make_statement_typedef((yyvsp[0].declarator_list), !(yyvsp[-1].declspec)->type->defined);
						}
#line 5551 "tools/widl/parser.tab.c"
    break;

  case 402: /* uniondef: tUNION t_ident '{' ne_union_fields '}'  */
#line 1142 "tools/widl/parser.y"
                                                { (yyval.type) = type_new_nonencapsulated_union((yyvsp[-3].str), TRUE, (yyvsp[-1].var_list)); }
#line 5557 "tools/widl/parser.tab.c"
    break;

  case 403: /* uniondef: tUNION t_ident tSWITCH '(' s_field ')' m_ident '{' cases '}'  */
#line 1145 "tools/widl/parser.y"
                                                { (yyval.type) = type_new_encapsulated_union((yyvsp[-8].str), (yyvsp[-5].var), (yyvsp[-3].var), (yyvsp[-1].var_list)); }
#line 5563 "tools/widl/parser.tab.c"
    break;

  case 404: /* version: aNUM  */
#line 1149 "tools/widl/parser.y"
                                                { (yyval.num) = MAKEVERSION((yyvsp[0].num), 0); }
#line 5569 "tools/widl/parser.tab.c"
    break;

  case 405: /* version: aNUM '.' aNUM  */
#line 1150 "tools/widl/parser.y"
                                                { (yyval.num) = MAKEVERSION((yyvsp[-2].num), (yyvsp[0].num)); }
#line 5575 "tools/widl/parser.tab.c"
    break;

  case 406: /* version: aHEXNUM  */
#line 1151 "tools/widl/parser.y"
                                                { (yyval.num) = (yyvsp[0].num); }
#line 5581 "tools/widl/parser.tab.c"
    break;

  case 411: /* acf_int_statement: tTYPEDEF acf_attributes aKNOWNTYPE ';'  */
#line 1166 "tools/widl/parser.y"
                                                { type_t *type = find_type_or_error((yyvsp[-1].str), 0);
                                                  type->attrs = append_attr_list(type->attrs, (yyvsp[-2].attr_list));
                                                }
#line 5589 "tools/widl/parser.tab.c"
    break;

  case 412: /* acf_interface: acf_attributes tINTERFACE aKNOWNTYPE '{' acf_int_statements '}'  */
#line 1173 "tools/widl/parser.y"
                                                {  type_t *iface = find_type_or_error2((yyvsp[-3].str), 0);
                                                   if (type_get_type(iface) != TYPE_INTERFACE)
                                                       error_loc("%s is not an interface\n", iface->name);
                                                   iface->attrs = append_attr_list(iface->attrs, (yyvsp[-5].attr_list));
                                                }
#line 5599 "tools/widl/parser.tab.c"
    break;

  case 413: /* acf_attributes: %empty  */
#line 1181 "tools/widl/parser.y"
                                                { (yyval.attr_list) = NULL; }
#line 5605 "tools/widl/parser.tab.c"
    break;

  case 414: /* acf_attributes: '[' acf_attribute_list ']'  */
#line 1182 "tools/widl/parser.y"
                                                { (yyval.attr_list) = (yyvsp[-1].attr_list); }
#line 5611 "tools/widl/parser.tab.c"
    break;

  case 415: /* acf_attribute_list: acf_attribute  */
#line 1186 "tools/widl/parser.y"
                                                { (yyval.attr_list) = append_attr(NULL, (yyvsp[0].attr)); }
#line 5617 "tools/widl/parser.tab.c"
    break;

  case 416: /* acf_attribute_list: acf_attribute_list ',' acf_attribute  */
#line 1187 "tools/widl/parser.y"
                                                { (yyval.attr_list) = append_attr((yyvsp[-2].attr_list), (yyvsp[0].attr)); }
#line 5623 "tools/widl/parser.tab.c"
    break;

  case 417: /* acf_attribute: tALLOCATE '(' allocate_option_list ')'  */
#line 1192 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attrv(ATTR_ALLOCATE, (yyvsp[-1].num)); }
#line 5629 "tools/widl/parser.tab.c"
    break;

  case 418: /* acf_attribute: tENCODE  */
#line 1193 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_ENCODE); }
#line 5635 "tools/widl/parser.tab.c"
    break;

  case 419: /* acf_attribute: tDECODE  */
#line 1194 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_DECODE); }
#line 5641 "tools/widl/parser.tab.c"
    break;

  case 420: /* acf_attribute: tEXPLICITHANDLE  */
#line 1195 "tools/widl/parser.y"
                                                { (yyval.attr) = make_attr(ATTR_EXPLICIT_HANDLE); }
#line 5647 "tools/widl/parser.tab.c"
    break;

  case 421: /* allocate_option_list: allocate_option  */
#line 1199 "tools/widl/parser.y"
                                                { (yyval.num) = (yyvsp[0].num); }
#line 5653 "tools/widl/parser.tab.c"
    break;

  case 422: /* allocate_option_list: allocate_option_list ',' allocate_option  */
#line 1201 "tools/widl/parser.y"
                                                { (yyval.num) = (yyvsp[-2].num) | (yyvsp[0].num); }
#line 5659 "tools/widl/parser.tab.c"
    break;

  case 423: /* allocate_option: tDONTFREE  */
#line 1205 "tools/widl/parser.y"
                                                { (yyval.num) = FC_DONT_FREE; }
#line 5665 "tools/widl/parser.tab.c"
    break;

  case 424: /* allocate_option: tFREE  */
#line 1206 "tools/widl/parser.y"
                                                { (yyval.num) = 0; }
#line 5671 "tools/widl/parser.tab.c"
    break;

  case 425: /* allocate_option: tALLNODES  */
#line 1207 "tools/widl/parser.y"
                                                { (yyval.num) = FC_ALLOCATE_ALL_NODES; }
#line 5677 "tools/widl/parser.tab.c"
    break;

  case 426: /* allocate_option: tSINGLENODE  */
#line 1208 "tools/widl/parser.y"
                                                { (yyval.num) = 0; }
#line 5683 "tools/widl/parser.tab.c"
    break;


#line 5687 "tools/widl/parser.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yytoken};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          goto yyexhaustedlab;
      }
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if 1
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;
#endif


/*-------------------------------------------------------.
| yyreturn -- parsing is finished, clean up and return.  |
`-------------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

#line 1211 "tools/widl/parser.y"


static void decl_builtin_basic(const char *name, enum type_basic_type type)
{
  type_t *t = type_new_basic(type);
  reg_type(t, name, NULL, 0);
}

static void decl_builtin_alias(const char *name, type_t *t)
{
    const decl_spec_t ds = {.type = t};
    reg_type(type_new_alias(&ds, name), name, NULL, 0);
}

void init_types(void)
{
  decl_builtin_basic("byte", TYPE_BASIC_BYTE);
  decl_builtin_basic("wchar_t", TYPE_BASIC_WCHAR);
  decl_builtin_basic("float", TYPE_BASIC_FLOAT);
  decl_builtin_basic("double", TYPE_BASIC_DOUBLE);
  decl_builtin_basic("error_status_t", TYPE_BASIC_ERROR_STATUS_T);
  decl_builtin_basic("handle_t", TYPE_BASIC_HANDLE);
  decl_builtin_alias("boolean", type_new_basic(TYPE_BASIC_CHAR));
}

static str_list_t *append_str(str_list_t *list, char *str)
{
    struct str_list_entry_t *entry;

    if (!str) return list;
    if (!list)
    {
        list = xmalloc( sizeof(*list) );
        list_init( list );
    }
    entry = xmalloc( sizeof(*entry) );
    entry->str = str;
    list_add_tail( list, &entry->entry );
    return list;
}

static attr_list_t *move_attr(attr_list_t *dst, attr_list_t *src, enum attr_type type)
{
  attr_t *attr;
  if (!src) return dst;
  LIST_FOR_EACH_ENTRY(attr, src, attr_t, entry)
    if (attr->type == type)
    {
      list_remove(&attr->entry);
      return append_attr(dst, attr);
    }
  return dst;
}

static attr_list_t *append_attr_list(attr_list_t *new_list, attr_list_t *old_list)
{
  struct list *entry;

  if (!old_list) return new_list;

  while ((entry = list_head(old_list)))
  {
    attr_t *attr = LIST_ENTRY(entry, attr_t, entry);
    list_remove(entry);
    new_list = append_attr(new_list, attr);
  }
  return new_list;
}

typedef int (*map_attrs_filter_t)(attr_list_t*,const attr_t*);

static attr_list_t *map_attrs(const attr_list_t *list, map_attrs_filter_t filter)
{
  attr_list_t *new_list;
  const attr_t *attr;
  attr_t *new_attr;

  if (!list) return NULL;

  new_list = xmalloc( sizeof(*list) );
  list_init( new_list );
  LIST_FOR_EACH_ENTRY(attr, list, const attr_t, entry)
  {
    if (filter && !filter(new_list, attr)) continue;
    new_attr = xmalloc(sizeof(*new_attr));
    *new_attr = *attr;
    list_add_tail(new_list, &new_attr->entry);
  }
  return new_list;
}

static decl_spec_t *make_decl_spec(type_t *type, decl_spec_t *left, decl_spec_t *right,
        enum storage_class stgclass, enum type_qualifier qual, enum function_specifier func_specifier)
{
  decl_spec_t *declspec = left ? left : right;
  if (!declspec)
  {
    declspec = xmalloc(sizeof(*declspec));
    declspec->type = NULL;
    declspec->stgclass = STG_NONE;
    declspec->qualifier = 0;
    declspec->func_specifier = 0;
  }
  declspec->type = type;
  if (left && declspec != left)
  {
    if (declspec->stgclass == STG_NONE)
      declspec->stgclass = left->stgclass;
    else if (left->stgclass != STG_NONE)
      error_loc("only one storage class can be specified\n");
    declspec->qualifier |= left->qualifier;
    declspec->func_specifier |= left->func_specifier;
    assert(!left->type);
    free(left);
  }
  if (right && declspec != right)
  {
    if (declspec->stgclass == STG_NONE)
      declspec->stgclass = right->stgclass;
    else if (right->stgclass != STG_NONE)
      error_loc("only one storage class can be specified\n");
    declspec->qualifier |= right->qualifier;
    declspec->func_specifier |= right->func_specifier;
    assert(!right->type);
    free(right);
  }

  if (declspec->stgclass == STG_NONE)
    declspec->stgclass = stgclass;
  else if (stgclass != STG_NONE)
    error_loc("only one storage class can be specified\n");
  declspec->qualifier |= qual;
  declspec->func_specifier |= func_specifier;

  return declspec;
}

static attr_t *make_attr(enum attr_type type)
{
  attr_t *a = xmalloc(sizeof(attr_t));
  a->type = type;
  a->u.ival = 0;
  return a;
}

static attr_t *make_attrv(enum attr_type type, unsigned int val)
{
  attr_t *a = xmalloc(sizeof(attr_t));
  a->type = type;
  a->u.ival = val;
  return a;
}

static attr_t *make_attrp(enum attr_type type, void *val)
{
  attr_t *a = xmalloc(sizeof(attr_t));
  a->type = type;
  a->u.pval = val;
  return a;
}

static attr_t *make_custom_attr(UUID *id, expr_t *pval)
{
  attr_t *a = xmalloc(sizeof(attr_t));
  attr_custdata_t *cstdata = xmalloc(sizeof(attr_custdata_t));
  a->type = ATTR_CUSTOM;
  cstdata->id = *id;
  cstdata->pval = pval;
  a->u.pval = cstdata;
  return a;
}

static expr_list_t *append_expr(expr_list_t *list, expr_t *expr)
{
    if (!expr) return list;
    if (!list)
    {
        list = xmalloc( sizeof(*list) );
        list_init( list );
    }
    list_add_tail( list, &expr->entry );
    return list;
}

static void append_array(declarator_t *decl, expr_t *expr)
{
    type_t *array;

    if (!expr)
        return;

    /* An array is always a reference pointer unless explicitly marked otherwise
     * (regardless of what the default pointer attribute is). */
    array = type_new_array(NULL, NULL, FALSE, expr->is_const ? expr->cval : 0,
            expr->is_const ? NULL : expr, NULL);

    append_chain_type(decl, array, 0);
}

static struct list type_pool = LIST_INIT(type_pool);
typedef struct
{
  type_t data;
  struct list link;
} type_pool_node_t;

type_t *alloc_type(void)
{
  type_pool_node_t *node = xmalloc(sizeof *node);
  list_add_tail(&type_pool, &node->link);
  return &node->data;
}

void set_all_tfswrite(int val)
{
  type_pool_node_t *node;
  LIST_FOR_EACH_ENTRY(node, &type_pool, type_pool_node_t, link)
    node->data.tfswrite = val;
}

void clear_all_offsets(void)
{
  type_pool_node_t *node;
  LIST_FOR_EACH_ENTRY(node, &type_pool, type_pool_node_t, link)
    node->data.typestring_offset = node->data.ptrdesc = 0;
}

static void type_function_add_head_arg(type_t *type, var_t *arg)
{
    if (!type->details.function->args)
    {
        type->details.function->args = xmalloc( sizeof(*type->details.function->args) );
        list_init( type->details.function->args );
    }
    list_add_head( type->details.function->args, &arg->entry );
}

static int is_allowed_range_type(const type_t *type)
{
    switch (type_get_type(type))
    {
    case TYPE_ENUM:
        return TRUE;
    case TYPE_BASIC:
        switch (type_basic_get_type(type))
        {
        case TYPE_BASIC_INT8:
        case TYPE_BASIC_INT16:
        case TYPE_BASIC_INT32:
        case TYPE_BASIC_INT64:
        case TYPE_BASIC_INT:
        case TYPE_BASIC_INT3264:
        case TYPE_BASIC_LONG:
        case TYPE_BASIC_BYTE:
        case TYPE_BASIC_CHAR:
        case TYPE_BASIC_WCHAR:
        case TYPE_BASIC_HYPER:
            return TRUE;
        case TYPE_BASIC_FLOAT:
        case TYPE_BASIC_DOUBLE:
        case TYPE_BASIC_ERROR_STATUS_T:
        case TYPE_BASIC_HANDLE:
            return FALSE;
        }
        return FALSE;
    default:
        return FALSE;
    }
}

static type_t *get_chain_ref(type_t *type)
{
    if (is_ptr(type))
        return type_pointer_get_ref_type(type);
    else if (is_array(type))
        return type_array_get_element_type(type);
    else if (is_func(type))
        return type_function_get_rettype(type);
    return NULL;
}

static type_t *get_chain_end(type_t *type)
{
    type_t *inner;
    while ((inner = get_chain_ref(type)))
        type = inner;
    return type;
}

static void append_chain_type(declarator_t *decl, type_t *type, enum type_qualifier qual)
{
    type_t *chain_type;

    if (!decl->type)
    {
        decl->type = type;
        decl->qualifier = qual;
        return;
    }
    chain_type = get_chain_end(decl->type);

    if (is_ptr(chain_type))
    {
        chain_type->details.pointer.ref.type = type;
        chain_type->details.pointer.ref.qualifier = qual;
    }
    else if (is_array(chain_type))
    {
        chain_type->details.array.elem.type = type;
        chain_type->details.array.elem.qualifier = qual;
    }
    else if (is_func(chain_type))
    {
        chain_type->details.function->retval->declspec.type = type;
        chain_type->details.function->retval->declspec.qualifier = qual;
    }
    else
        assert(0);

    if (!is_func(chain_type))
        type->attrs = move_attr(type->attrs, chain_type->attrs, ATTR_CALLCONV);
}

static void append_chain_callconv(type_t *chain, char *callconv)
{
    type_t *chain_end;

    if (chain && (chain_end = get_chain_end(chain)))
        chain_end->attrs = append_attr(chain_end->attrs, make_attrp(ATTR_CALLCONV, callconv));
    else
        error_loc("calling convention applied to non-function type\n");
}

static warning_list_t *append_warning(warning_list_t *list, int num)
{
    warning_t *entry;

    if(!list)
    {
        list = xmalloc( sizeof(*list) );
        list_init( list );
    }
    entry = xmalloc( sizeof(*entry) );
    entry->num = num;
    list_add_tail( list, &entry->entry );
    return list;
}

static var_t *declare_var(attr_list_t *attrs, decl_spec_t *decl_spec, declarator_t *decl,
                       int top)
{
  var_t *v = decl->var;
  expr_list_t *sizes = get_attrp(attrs, ATTR_SIZEIS);
  expr_list_t *lengs = get_attrp(attrs, ATTR_LENGTHIS);
  expr_t *dim;
  type_t **ptype;
  type_t *type = decl_spec->type;

  if (decl_spec->func_specifier & FUNCTION_SPECIFIER_INLINE)
  {
    if (!decl || !is_func(decl->type))
      error_loc("inline attribute applied to non-function type\n");
  }

  /* add type onto the end of the pointers in pident->type */
  append_chain_type(decl, type, decl_spec->qualifier);
  v->declspec = *decl_spec;
  v->declspec.type = decl->type;
  v->declspec.qualifier = decl->qualifier;
  v->attrs = attrs;
  v->declonly = !type->defined;

  if (is_attr(type->attrs, ATTR_CALLCONV) && !is_func(type))
    error_loc("calling convention applied to non-function type\n");

  /* check for pointer attribute being applied to non-pointer, non-array
   * type */
  if (!is_array(v->declspec.type))
  {
    int ptr_attr = get_attrv(v->attrs, ATTR_POINTERTYPE);
    const type_t *ptr = NULL;
    for (ptr = v->declspec.type; ptr && !ptr_attr; )
    {
      ptr_attr = get_attrv(ptr->attrs, ATTR_POINTERTYPE);
      if (!ptr_attr && type_is_alias(ptr))
        ptr = type_alias_get_aliasee_type(ptr);
      else
        break;
    }
    if (is_ptr(ptr))
    {
      if (ptr_attr && ptr_attr != FC_UP &&
          type_get_type(type_pointer_get_ref_type(ptr)) == TYPE_INTERFACE)
          warning_loc_info(&v->loc_info,
                           "%s: pointer attribute applied to interface "
                           "pointer type has no effect\n", v->name);
      if (!ptr_attr && top)
      {
        /* FIXME: this is a horrible hack to cope with the issue that we
         * store an offset to the typeformat string in the type object, but
         * two typeformat strings may be written depending on whether the
         * pointer is a toplevel parameter or not */
        v->declspec.type = duptype(v->declspec.type, 1);
      }
    }
    else if (ptr_attr)
       error_loc("%s: pointer attribute applied to non-pointer type\n", v->name);
  }

  if (is_attr(v->attrs, ATTR_STRING))
  {
    type_t *t = type;

    if (!is_ptr(v->declspec.type) && !is_array(v->declspec.type))
      error_loc("'%s': [string] attribute applied to non-pointer, non-array type\n",
                v->name);

    for (;;)
    {
        if (is_ptr(t))
            t = type_pointer_get_ref_type(t);
        else if (is_array(t))
            t = type_array_get_element_type(t);
        else
            break;
    }

    if (type_get_type(t) != TYPE_BASIC &&
        (get_basic_fc(t) != FC_CHAR &&
         get_basic_fc(t) != FC_BYTE &&
         get_basic_fc(t) != FC_WCHAR))
    {
      error_loc("'%s': [string] attribute is only valid on 'char', 'byte', or 'wchar_t' pointers and arrays\n",
                v->name);
    }
  }

  if (is_attr(v->attrs, ATTR_V1ENUM))
  {
    if (type_get_type_detect_alias(v->declspec.type) != TYPE_ENUM)
      error_loc("'%s': [v1_enum] attribute applied to non-enum type\n", v->name);
  }

  if (is_attr(v->attrs, ATTR_RANGE) && !is_allowed_range_type(v->declspec.type))
    error_loc("'%s': [range] attribute applied to non-integer type\n",
              v->name);

  ptype = &v->declspec.type;
  if (sizes) LIST_FOR_EACH_ENTRY(dim, sizes, expr_t, entry)
  {
    if (dim->type != EXPR_VOID)
    {
      if (is_array(*ptype))
      {
        if (!type_array_get_conformance(*ptype) ||
            type_array_get_conformance(*ptype)->type != EXPR_VOID)
          error_loc("%s: cannot specify size_is for an already sized array\n", v->name);
        else
          *ptype = type_new_array((*ptype)->name,
                                  type_array_get_element(*ptype), FALSE,
                                  0, dim, NULL);
      }
      else if (is_ptr(*ptype))
        *ptype = type_new_array((*ptype)->name, type_pointer_get_ref(*ptype), TRUE,
                                0, dim, NULL);
      else
        error_loc("%s: size_is attribute applied to illegal type\n", v->name);
    }

    if (is_ptr(*ptype))
      ptype = &(*ptype)->details.pointer.ref.type;
    else if (is_array(*ptype))
      ptype = &(*ptype)->details.array.elem.type;
    else
      error_loc("%s: too many expressions in size_is attribute\n", v->name);
  }

  ptype = &v->declspec.type;
  if (lengs) LIST_FOR_EACH_ENTRY(dim, lengs, expr_t, entry)
  {
    if (dim->type != EXPR_VOID)
    {
      if (is_array(*ptype))
      {
        *ptype = type_new_array((*ptype)->name,
                                type_array_get_element(*ptype),
                                type_array_is_decl_as_ptr(*ptype),
                                type_array_get_dim(*ptype),
                                type_array_get_conformance(*ptype), dim);
      }
      else
        error_loc("%s: length_is attribute applied to illegal type\n", v->name);
    }

    if (is_ptr(*ptype))
      ptype = &(*ptype)->details.pointer.ref.type;
    else if (is_array(*ptype))
      ptype = &(*ptype)->details.array.elem.type;
    else
      error_loc("%s: too many expressions in length_is attribute\n", v->name);
  }

  if (decl->bits)
    v->declspec.type = type_new_bitfield(v->declspec.type, decl->bits);

  return v;
}

static var_list_t *set_var_types(attr_list_t *attrs, decl_spec_t *decl_spec, declarator_list_t *decls)
{
  declarator_t *decl, *next;
  var_list_t *var_list = NULL;

  LIST_FOR_EACH_ENTRY_SAFE( decl, next, decls, declarator_t, entry )
  {
    var_t *var = declare_var(attrs, decl_spec, decl, 0);
    var_list = append_var(var_list, var);
    free(decl);
  }
  free(decl_spec);
  return var_list;
}

static ifref_list_t *append_ifref(ifref_list_t *list, ifref_t *iface)
{
    if (!iface) return list;
    if (!list)
    {
        list = xmalloc( sizeof(*list) );
        list_init( list );
    }
    list_add_tail( list, &iface->entry );
    return list;
}

static ifref_t *make_ifref(type_t *iface)
{
  ifref_t *l = xmalloc(sizeof(ifref_t));
  l->iface = iface;
  l->attrs = NULL;
  return l;
}

var_list_t *append_var(var_list_t *list, var_t *var)
{
    if (!var) return list;
    if (!list)
    {
        list = xmalloc( sizeof(*list) );
        list_init( list );
    }
    list_add_tail( list, &var->entry );
    return list;
}

static var_list_t *append_var_list(var_list_t *list, var_list_t *vars)
{
    if (!vars) return list;
    if (!list)
    {
        list = xmalloc( sizeof(*list) );
        list_init( list );
    }
    list_move_tail( list, vars );
    return list;
}

var_t *make_var(char *name)
{
  var_t *v = xmalloc(sizeof(var_t));
  v->name = name;
  init_declspec(&v->declspec, NULL);
  v->attrs = NULL;
  v->eval = NULL;
  init_loc_info(&v->loc_info);
  v->declonly = FALSE;
  return v;
}

static var_t *copy_var(var_t *src, char *name, map_attrs_filter_t attr_filter)
{
  var_t *v = xmalloc(sizeof(var_t));
  v->name = name;
  v->declspec = src->declspec;
  v->attrs = map_attrs(src->attrs, attr_filter);
  v->eval = src->eval;
  v->loc_info = src->loc_info;
  return v;
}

static declarator_list_t *append_declarator(declarator_list_t *list, declarator_t *d)
{
  if (!d) return list;
  if (!list) {
    list = xmalloc(sizeof(*list));
    list_init(list);
  }
  list_add_tail(list, &d->entry);
  return list;
}

static declarator_t *make_declarator(var_t *var)
{
  declarator_t *d = xmalloc(sizeof(*d));
  d->var = var ? var : make_var(NULL);
  d->type = NULL;
  d->qualifier = 0;
  d->bits = NULL;
  return d;
}

static type_t *make_safearray(type_t *type)
{
    decl_spec_t ds = {.type = type};
    ds.type = type_new_alias(&ds, "SAFEARRAY");
    return type_new_array(NULL, &ds, TRUE, 0, NULL, NULL);
}

static typelib_t *make_library(const char *name, const attr_list_t *attrs)
{
    typelib_t *typelib = xmalloc(sizeof(*typelib));
    memset(typelib, 0, sizeof(*typelib));
    typelib->name = xstrdup(name);
    typelib->attrs = attrs;
    list_init( &typelib->importlibs );
    return typelib;
}

static int hash_ident(const char *name)
{
  const char *p = name;
  int sum = 0;
  /* a simple sum hash is probably good enough */
  while (*p) {
    sum += *p;
    p++;
  }
  return sum & (HASHMAX-1);
}

/***** type repository *****/

static struct namespace *find_sub_namespace(struct namespace *namespace, const char *name)
{
  struct namespace *cur;

  LIST_FOR_EACH_ENTRY(cur, &namespace->children, struct namespace, entry) {
    if(!strcmp(cur->name, name))
      return cur;
  }

  return NULL;
}

static void push_namespace(const char *name)
{
  struct namespace *namespace;

  namespace = find_sub_namespace(current_namespace, name);
  if(!namespace) {
    namespace = xmalloc(sizeof(*namespace));
    namespace->name = xstrdup(name);
    namespace->parent = current_namespace;
    list_add_tail(&current_namespace->children, &namespace->entry);
    list_init(&namespace->children);
    memset(namespace->type_hash, 0, sizeof(namespace->type_hash));
  }

  current_namespace = namespace;
}

static void pop_namespace(const char *name)
{
  assert(!strcmp(current_namespace->name, name) && current_namespace->parent);
  current_namespace = current_namespace->parent;
}

static void init_lookup_namespace(const char *name)
{
    if (!(lookup_namespace = find_sub_namespace(&global_namespace, name)))
        error_loc("namespace '%s' not found\n", name);
}

static void push_lookup_namespace(const char *name)
{
    struct namespace *namespace;
    if (!(namespace = find_sub_namespace(lookup_namespace, name)))
        error_loc("namespace '%s' not found\n", name);
    lookup_namespace = namespace;
}

struct rtype {
  const char *name;
  type_t *type;
  int t;
  struct rtype *next;
};

type_t *reg_type(type_t *type, const char *name, struct namespace *namespace, int t)
{
  struct rtype *nt;
  int hash;
  if (!name) {
    error_loc("registering named type without name\n");
    return type;
  }
  if (!namespace)
    namespace = &global_namespace;
  hash = hash_ident(name);
  nt = xmalloc(sizeof(struct rtype));
  nt->name = name;
  if (is_global_namespace(namespace))
    type->c_name = name;
  else
    type->c_name = format_namespace(namespace, "__x_", "_C", name);
  nt->type = type;
  nt->t = t;
  nt->next = namespace->type_hash[hash];
  namespace->type_hash[hash] = nt;
  return type;
}

static type_t *reg_typedefs(decl_spec_t *decl_spec, declarator_list_t *decls, attr_list_t *attrs)
{
  declarator_t *decl;
  type_t *type = decl_spec->type;

  if (is_attr(attrs, ATTR_UUID) && !is_attr(attrs, ATTR_PUBLIC))
    attrs = append_attr( attrs, make_attr(ATTR_PUBLIC) );

  /* We must generate names for tagless enum, struct or union.
     Typedef-ing a tagless enum, struct or union means we want the typedef
     to be included in a library hence the public attribute.  */
  if (type_get_type_detect_alias(type) == TYPE_ENUM ||
      type_get_type_detect_alias(type) == TYPE_STRUCT ||
      type_get_type_detect_alias(type) == TYPE_UNION ||
      type_get_type_detect_alias(type) == TYPE_ENCAPSULATED_UNION)
  {
    if (!type->name)
    {
      type->name = gen_name();
      if (!is_attr(attrs, ATTR_PUBLIC))
        attrs = append_attr(attrs, make_attr(ATTR_PUBLIC));
    }

    /* replace existing attributes when generating a typelib */
    if (do_typelib)
        type->attrs = attrs;
  }

  LIST_FOR_EACH_ENTRY( decl, decls, declarator_t, entry )
  {

    if (decl->var->name) {
      type_t *cur;
      var_t *name;

      cur = find_type(decl->var->name, current_namespace, 0);

      /*
       * MIDL allows shadowing types that are declared in imported files.
       * We don't throw an error in this case and instead add a new type
       * (which is earlier on the list in hash table, so it will be used
       * instead of shadowed type).
       *
       * FIXME: We may consider string separated type tables for each input
       *        for cleaner solution.
       */
      if (cur && input_name == cur->loc_info.input_name)
          error_loc("%s: redefinition error; original definition was at %s:%d\n",
                    cur->name, cur->loc_info.input_name,
                    cur->loc_info.line_number);

      name = declare_var(attrs, decl_spec, decl, 0);
      cur = type_new_alias(&name->declspec, name->name);
      cur->attrs = attrs;

      reg_type(cur, cur->name, current_namespace, 0);
    }
  }
  return type;
}

type_t *find_type(const char *name, struct namespace *namespace, int t)
{
  struct rtype *cur;

  if(namespace && namespace != &global_namespace) {
    for(cur = namespace->type_hash[hash_ident(name)]; cur; cur = cur->next) {
      if(cur->t == t && !strcmp(cur->name, name))
        return cur->type;
    }
  }
  for(cur = global_namespace.type_hash[hash_ident(name)]; cur; cur = cur->next) {
    if(cur->t == t && !strcmp(cur->name, name))
      return cur->type;
  }
  return NULL;
}

static type_t *find_type_or_error(const char *name, int t)
{
    type_t *type;
    if (!(type = find_type(name, current_namespace, t)) &&
        !(type = find_type(name, lookup_namespace, t)))
    {
        error_loc("type '%s' not found\n", name);
        return NULL;
    }
    return type;
}

static type_t *find_type_or_error2(char *name, int t)
{
  type_t *tp = find_type_or_error(name, t);
  free(name);
  return tp;
}

int is_type(const char *name)
{
    return find_type(name, current_namespace, 0) != NULL ||
           find_type(name, lookup_namespace, 0) != NULL;
}

int is_namespace(const char *name)
{
    if (!winrt_mode) return 0;
    return find_sub_namespace(current_namespace, name) != NULL ||
           find_sub_namespace(&global_namespace, name) != NULL;
}

type_t *get_type(enum type_type type, char *name, struct namespace *namespace, int t)
{
  type_t *tp;
  if (!namespace)
    namespace = &global_namespace;
  if (name) {
    tp = find_type(name, namespace, t);
    if (tp) {
      free(name);
      return tp;
    }
  }
  tp = make_type(type);
  tp->name = name;
  tp->namespace = namespace;
  if (!name) return tp;
  return reg_type(tp, name, namespace, t);
}

/***** constant repository *****/

struct rconst {
  char *name;
  var_t *var;
  struct rconst *next;
};

struct rconst *const_hash[HASHMAX];

static var_t *reg_const(var_t *var)
{
  struct rconst *nc;
  int hash;
  if (!var->name) {
    error_loc("registering constant without name\n");
    return var;
  }
  hash = hash_ident(var->name);
  nc = xmalloc(sizeof(struct rconst));
  nc->name = var->name;
  nc->var = var;
  nc->next = const_hash[hash];
  const_hash[hash] = nc;
  return var;
}

var_t *find_const(const char *name, int f)
{
  struct rconst *cur = const_hash[hash_ident(name)];
  while (cur && strcmp(cur->name, name))
    cur = cur->next;
  if (!cur) {
    if (f) error_loc("constant '%s' not found\n", name);
    return NULL;
  }
  return cur->var;
}

char *gen_name(void)
{
  static unsigned long n = 0;
  static const char *file_id;

  if (! file_id)
  {
    char *dst = dup_basename(input_idl_name, ".idl");
    file_id = dst;

    for (; *dst; ++dst)
      if (! isalnum((unsigned char) *dst))
        *dst = '_';
  }
  return strmake("__WIDL_%s_generated_name_%08lX", file_id, n++);
}

struct allowed_attr
{
    unsigned int dce_compatible : 1;
    unsigned int acf : 1;
    unsigned int multiple : 1;

    unsigned int on_interface : 1;
    unsigned int on_function : 1;
    unsigned int on_arg : 1;
    unsigned int on_type : 1;
    unsigned int on_enum : 1;
    unsigned int on_enum_member : 1;
    unsigned int on_struct : 2;
    unsigned int on_union : 1;
    unsigned int on_field : 1;
    unsigned int on_library : 1;
    unsigned int on_dispinterface : 1;
    unsigned int on_module : 1;
    unsigned int on_coclass : 1;
    const char *display_name;
};

struct allowed_attr allowed_attr[] =
{
    /* attr                        { D ACF M   I Fn ARG T En Enm St Un Fi L  DI M  C  <display name> } */
    /* ATTR_AGGREGATABLE */        { 0, 0, 0,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, "aggregatable" },
    /* ATTR_ALLOCATE */            { 0, 1, 0,  0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, "allocate" },
    /* ATTR_ANNOTATION */          { 0, 0, 0,  0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "annotation" },
    /* ATTR_APPOBJECT */           { 0, 0, 0,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, "appobject" },
    /* ATTR_ASYNC */               { 0, 1, 0,  0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "async" },
    /* ATTR_ASYNCUUID */           { 1, 0, 0,  1, 0, 0, 1, 1, 0, 0, 0, 0, 1, 1, 1, 1, "async_uuid" },
    /* ATTR_AUTO_HANDLE */         { 1, 1, 0,  1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "auto_handle" },
    /* ATTR_BINDABLE */            { 0, 0, 0,  0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "bindable" },
    /* ATTR_BROADCAST */           { 1, 0, 0,  0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "broadcast" },
    /* ATTR_CALLAS */              { 0, 0, 0,  0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "call_as" },
    /* ATTR_CALLCONV */            { 0, 0, 0,  0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL },
    /* ATTR_CASE */                { 1, 0, 0,  0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, "case" },
    /* ATTR_CODE */                { 0, 1, 0,  1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "code" },
    /* ATTR_COMMSTATUS */          { 0, 0, 0,  0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "comm_status" },
    /* ATTR_CONTEXTHANDLE */       { 1, 0, 0,  0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, "context_handle" },
    /* ATTR_CONTROL */             { 0, 0, 0,  0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, "control" },
    /* ATTR_CUSTOM */              { 0, 0, 1,  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, "custom" },
    /* ATTR_DECODE */              { 0, 0, 0,  1, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, "decode" },
    /* ATTR_DEFAULT */             { 0, 0, 0,  1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, "default" },
    /* ATTR_DEFAULTBIND */         { 0, 0, 0,  0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "defaultbind" },
    /* ATTR_DEFAULTCOLLELEM */     { 0, 0, 0,  0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "defaultcollelem" },
    /* ATTR_DEFAULTVALUE */        { 0, 0, 0,  0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "defaultvalue" },
    /* ATTR_DEFAULTVTABLE */       { 0, 0, 0,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, "defaultvtable" },
 /* ATTR_DISABLECONSISTENCYCHECK */{ 0, 0, 0,  0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "disable_consistency_check" },
    /* ATTR_DISPINTERFACE */       { 0, 0, 0,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL },
    /* ATTR_DISPLAYBIND */         { 0, 0, 0,  0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "displaybind" },
    /* ATTR_DLLNAME */             { 0, 0, 0,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, "dllname" },
    /* ATTR_DUAL */                { 0, 0, 0,  1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "dual" },
    /* ATTR_ENABLEALLOCATE */      { 0, 0, 0,  1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "enable_allocate" },
    /* ATTR_ENCODE */              { 0, 0, 0,  1, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, "encode" },
    /* ATTR_ENDPOINT */            { 1, 0, 0,  1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "endpoint" },
    /* ATTR_ENTRY */               { 0, 0, 0,  0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "entry" },
    /* ATTR_EXPLICIT_HANDLE */     { 1, 1, 0,  1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "explicit_handle" },
    /* ATTR_FAULTSTATUS */         { 0, 0, 0,  0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "fault_status" },
    /* ATTR_FORCEALLOCATE */       { 0, 0, 0,  0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "force_allocate" },
    /* ATTR_HANDLE */              { 1, 0, 0,  0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, "handle" },
    /* ATTR_HELPCONTEXT */         { 0, 0, 0,  1, 1, 0, 1, 1, 0, 0, 0, 0, 1, 1, 1, 1, "helpcontext" },
    /* ATTR_HELPFILE */            { 0, 0, 0,  0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, "helpfile" },
    /* ATTR_HELPSTRING */          { 0, 0, 0,  1, 1, 0, 1, 1, 0, 0, 0, 0, 1, 1, 1, 1, "helpstring" },
    /* ATTR_HELPSTRINGCONTEXT */   { 0, 0, 0,  1, 1, 0, 1, 1, 0, 0, 0, 0, 1, 1, 1, 1, "helpstringcontext" },
    /* ATTR_HELPSTRINGDLL */       { 0, 0, 0,  0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, "helpstringdll" },
    /* ATTR_HIDDEN */              { 0, 0, 0,  1, 1, 0, 1, 1, 1, 0, 0, 0, 1, 1, 0, 1, "hidden" },
    /* ATTR_ID */                  { 0, 0, 0,  0, 1, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, "id" },
    /* ATTR_IDEMPOTENT */          { 1, 0, 0,  0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "idempotent" },
    /* ATTR_IGNORE */              { 0, 0, 0,  0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, "ignore" },
    /* ATTR_IIDIS */               { 0, 0, 0,  0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, "iid_is" },
    /* ATTR_IMMEDIATEBIND */       { 0, 0, 0,  0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "immediatebind" },
    /* ATTR_IMPLICIT_HANDLE */     { 1, 1, 0,  1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "implicit_handle" },
    /* ATTR_IN */                  { 0, 0, 0,  0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "in" },
    /* ATTR_INPUTSYNC */           { 0, 0, 0,  0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "inputsync" },
    /* ATTR_LENGTHIS */            { 0, 0, 0,  0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, "length_is" },
    /* ATTR_LIBLCID */             { 0, 0, 0,  0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, "lcid" },
    /* ATTR_LICENSED */            { 0, 0, 0,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, "licensed" },
    /* ATTR_LOCAL */               { 1, 0, 0,  1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "local" },
    /* ATTR_MAYBE */               { 0, 0, 0,  0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "maybe" },
    /* ATTR_MESSAGE */             { 0, 0, 0,  0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "message" },
    /* ATTR_NOCODE */              { 0, 1, 0,  1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "nocode" },
    /* ATTR_NONBROWSABLE */        { 0, 0, 0,  0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "nonbrowsable" },
    /* ATTR_NONCREATABLE */        { 0, 0, 0,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, "noncreatable" },
    /* ATTR_NONEXTENSIBLE */       { 0, 0, 0,  1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "nonextensible" },
    /* ATTR_NOTIFY */              { 0, 0, 0,  0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "notify" },
    /* ATTR_NOTIFYFLAG */          { 0, 0, 0,  0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "notify_flag" },
    /* ATTR_OBJECT */              { 0, 0, 0,  1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "object" },
    /* ATTR_ODL */                 { 0, 0, 0,  1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, "odl" },
    /* ATTR_OLEAUTOMATION */       { 0, 0, 0,  1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "oleautomation" },
    /* ATTR_OPTIMIZE */            { 0, 0, 0,  1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "optimize" },
    /* ATTR_OPTIONAL */            { 0, 0, 0,  0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "optional" },
    /* ATTR_OUT */                 { 1, 0, 0,  0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "out" },
    /* ATTR_PARAMLCID */           { 0, 0, 0,  0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "lcid" },
    /* ATTR_PARTIALIGNORE */       { 0, 0, 0,  0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "partial_ignore" },
    /* ATTR_POINTERDEFAULT */      { 1, 0, 0,  1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "pointer_default" },
    /* ATTR_POINTERTYPE */         { 1, 0, 0,  0, 0, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, "ref, unique or ptr" },
    /* ATTR_PROGID */              { 0, 0, 0,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, "progid" },
    /* ATTR_PROPGET */             { 0, 0, 0,  0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "propget" },
    /* ATTR_PROPPUT */             { 0, 0, 0,  0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "propput" },
    /* ATTR_PROPPUTREF */          { 0, 0, 0,  0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "propputref" },
    /* ATTR_PROXY */               { 0, 0, 0,  1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "proxy" },
    /* ATTR_PUBLIC */              { 0, 0, 0,  0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, "public" },
    /* ATTR_RANGE */               { 0, 0, 0,  0, 0, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, "range" },
    /* ATTR_READONLY */            { 0, 0, 0,  0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, "readonly" },
    /* ATTR_REPRESENTAS */         { 1, 0, 0,  0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, "represent_as" },
    /* ATTR_REQUESTEDIT */         { 0, 0, 0,  0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "requestedit" },
    /* ATTR_RESTRICTED */          { 0, 0, 0,  1, 1, 0, 1, 1, 0, 1, 0, 0, 1, 1, 1, 1, "restricted" },
    /* ATTR_RETVAL */              { 0, 0, 0,  0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "retval" },
    /* ATTR_SIZEIS */              { 0, 0, 0,  0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, "size_is" },
    /* ATTR_SOURCE */              { 0, 0, 0,  1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, "source" },
    /* ATTR_STRICTCONTEXTHANDLE */ { 0, 0, 0,  1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "strict_context_handle" },
    /* ATTR_STRING */              { 1, 0, 0,  0, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, "string" },
    /* ATTR_SWITCHIS */            { 1, 0, 0,  0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, "switch_is" },
    /* ATTR_SWITCHTYPE */          { 1, 0, 0,  0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, "switch_type" },
    /* ATTR_THREADING */           { 0, 0, 0,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, "threading" },
    /* ATTR_TRANSMITAS */          { 1, 0, 0,  0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, "transmit_as" },
    /* ATTR_UIDEFAULT */           { 0, 0, 0,  0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "uidefault" },
    /* ATTR_USESGETLASTERROR */    { 0, 0, 0,  0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "usesgetlasterror" },
    /* ATTR_USERMARSHAL */         { 0, 0, 0,  0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, "user_marshal" },
    /* ATTR_UUID */                { 1, 0, 0,  1, 0, 0, 1, 1, 0, 1, 0, 0, 1, 1, 1, 1, "uuid" },
    /* ATTR_V1ENUM */              { 0, 0, 0,  0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, "v1_enum" },
    /* ATTR_VARARG */              { 0, 0, 0,  0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "vararg" },
    /* ATTR_VERSION */             { 1, 0, 0,  1, 0, 0, 1, 1, 0, 2, 0, 0, 1, 0, 0, 1, "version" },
    /* ATTR_VIPROGID */            { 0, 0, 0,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, "vi_progid" },
    /* ATTR_WIREMARSHAL */         { 1, 0, 0,  0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, "wire_marshal" },
};

static attr_list_t *append_attr(attr_list_t *list, attr_t *attr)
{
    attr_t *attr_existing;
    if (!attr) return list;
    if (!list)
    {
        list = xmalloc( sizeof(*list) );
        list_init( list );
    }
    if (!allowed_attr[attr->type].multiple)
    {
        LIST_FOR_EACH_ENTRY(attr_existing, list, attr_t, entry)
            if (attr_existing->type == attr->type)
            {
                parser_warning("duplicate attribute %s\n", get_attr_display_name(attr->type));
                /* use the last attribute, like MIDL does */
                list_remove(&attr_existing->entry);
                break;
            }
    }
    list_add_tail( list, &attr->entry );
    return list;
}

const char *get_attr_display_name(enum attr_type type)
{
    return allowed_attr[type].display_name;
}

static attr_list_t *check_iface_attrs(const char *name, attr_list_t *attrs)
{
  const attr_t *attr;
  if (!attrs) return attrs;
  LIST_FOR_EACH_ENTRY(attr, attrs, const attr_t, entry)
  {
    if (!allowed_attr[attr->type].on_interface)
      error_loc("inapplicable attribute %s for interface %s\n",
                allowed_attr[attr->type].display_name, name);
    if (attr->type == ATTR_IMPLICIT_HANDLE)
    {
        const var_t *var = attr->u.pval;
        if (type_get_type( var->declspec.type) == TYPE_BASIC &&
            type_basic_get_type( var->declspec.type ) == TYPE_BASIC_HANDLE)
            continue;
        if (is_aliaschain_attr( var->declspec.type, ATTR_HANDLE ))
            continue;
      error_loc("attribute %s requires a handle type in interface %s\n",
                allowed_attr[attr->type].display_name, name);
    }
  }
  return attrs;
}

static attr_list_t *check_function_attrs(const char *name, attr_list_t *attrs)
{
  const attr_t *attr;
  if (!attrs) return attrs;
  LIST_FOR_EACH_ENTRY(attr, attrs, const attr_t, entry)
  {
    if (!allowed_attr[attr->type].on_function)
      error_loc("inapplicable attribute %s for function %s\n",
                allowed_attr[attr->type].display_name, name);
  }
  return attrs;
}

static void check_arg_attrs(const var_t *arg)
{
  const attr_t *attr;

  if (arg->attrs)
  {
    LIST_FOR_EACH_ENTRY(attr, arg->attrs, const attr_t, entry)
    {
      if (!allowed_attr[attr->type].on_arg)
        error_loc("inapplicable attribute %s for argument %s\n",
                  allowed_attr[attr->type].display_name, arg->name);
    }
  }
}

static attr_list_t *check_typedef_attrs(attr_list_t *attrs)
{
  const attr_t *attr;
  if (!attrs) return attrs;
  LIST_FOR_EACH_ENTRY(attr, attrs, const attr_t, entry)
  {
    if (!allowed_attr[attr->type].on_type)
      error_loc("inapplicable attribute %s for typedef\n",
                allowed_attr[attr->type].display_name);
  }
  return attrs;
}

static attr_list_t *check_enum_attrs(attr_list_t *attrs)
{
  const attr_t *attr;
  if (!attrs) return attrs;
  LIST_FOR_EACH_ENTRY(attr, attrs, const attr_t, entry)
  {
    if (!allowed_attr[attr->type].on_enum)
      error_loc("inapplicable attribute %s for enum\n",
                allowed_attr[attr->type].display_name);
  }
  return attrs;
}

static attr_list_t *check_enum_member_attrs(attr_list_t *attrs)
{
  const attr_t *attr;
  if (!attrs) return attrs;
  LIST_FOR_EACH_ENTRY(attr, attrs, const attr_t, entry)
  {
    if (!allowed_attr[attr->type].on_enum_member)
      error_loc("inapplicable attribute %s for enum member\n",
                allowed_attr[attr->type].display_name);
  }
  return attrs;
}

static attr_list_t *check_struct_attrs(attr_list_t *attrs)
{
  int mask = winrt_mode ? 3 : 1;
  const attr_t *attr;
  if (!attrs) return attrs;
  LIST_FOR_EACH_ENTRY(attr, attrs, const attr_t, entry)
  {
    if (!(allowed_attr[attr->type].on_struct & mask))
      error_loc("inapplicable attribute %s for struct\n",
                allowed_attr[attr->type].display_name);
  }
  return attrs;
}

static attr_list_t *check_union_attrs(attr_list_t *attrs)
{
  const attr_t *attr;
  if (!attrs) return attrs;
  LIST_FOR_EACH_ENTRY(attr, attrs, const attr_t, entry)
  {
    if (!allowed_attr[attr->type].on_union)
      error_loc("inapplicable attribute %s for union\n",
                allowed_attr[attr->type].display_name);
  }
  return attrs;
}

static attr_list_t *check_field_attrs(const char *name, attr_list_t *attrs)
{
  const attr_t *attr;
  if (!attrs) return attrs;
  LIST_FOR_EACH_ENTRY(attr, attrs, const attr_t, entry)
  {
    if (!allowed_attr[attr->type].on_field)
      error_loc("inapplicable attribute %s for field %s\n",
                allowed_attr[attr->type].display_name, name);
  }
  return attrs;
}

static attr_list_t *check_library_attrs(const char *name, attr_list_t *attrs)
{
  const attr_t *attr;
  if (!attrs) return attrs;
  LIST_FOR_EACH_ENTRY(attr, attrs, const attr_t, entry)
  {
    if (!allowed_attr[attr->type].on_library)
      error_loc("inapplicable attribute %s for library %s\n",
                allowed_attr[attr->type].display_name, name);
  }
  return attrs;
}

static attr_list_t *check_dispiface_attrs(const char *name, attr_list_t *attrs)
{
  const attr_t *attr;
  if (!attrs) return attrs;
  LIST_FOR_EACH_ENTRY(attr, attrs, const attr_t, entry)
  {
    if (!allowed_attr[attr->type].on_dispinterface)
      error_loc("inapplicable attribute %s for dispinterface %s\n",
                allowed_attr[attr->type].display_name, name);
  }
  return attrs;
}

static attr_list_t *check_module_attrs(const char *name, attr_list_t *attrs)
{
  const attr_t *attr;
  if (!attrs) return attrs;
  LIST_FOR_EACH_ENTRY(attr, attrs, const attr_t, entry)
  {
    if (!allowed_attr[attr->type].on_module)
      error_loc("inapplicable attribute %s for module %s\n",
                allowed_attr[attr->type].display_name, name);
  }
  return attrs;
}

static attr_list_t *check_coclass_attrs(const char *name, attr_list_t *attrs)
{
  const attr_t *attr;
  if (!attrs) return attrs;
  LIST_FOR_EACH_ENTRY(attr, attrs, const attr_t, entry)
  {
    if (!allowed_attr[attr->type].on_coclass)
      error_loc("inapplicable attribute %s for coclass %s\n",
                allowed_attr[attr->type].display_name, name);
  }
  return attrs;
}

static int is_allowed_conf_type(const type_t *type)
{
    switch (type_get_type(type))
    {
    case TYPE_ENUM:
        return TRUE;
    case TYPE_BASIC:
        switch (type_basic_get_type(type))
        {
        case TYPE_BASIC_INT8:
        case TYPE_BASIC_INT16:
        case TYPE_BASIC_INT32:
        case TYPE_BASIC_INT64:
        case TYPE_BASIC_INT:
        case TYPE_BASIC_LONG:
        case TYPE_BASIC_CHAR:
        case TYPE_BASIC_HYPER:
        case TYPE_BASIC_BYTE:
        case TYPE_BASIC_WCHAR:
            return TRUE;
        default:
            return FALSE;
        }
    case TYPE_ALIAS:
        /* shouldn't get here because of type_get_type call above */
        assert(0);
        /* fall through */
    case TYPE_STRUCT:
    case TYPE_UNION:
    case TYPE_ENCAPSULATED_UNION:
    case TYPE_ARRAY:
    case TYPE_POINTER:
    case TYPE_VOID:
    case TYPE_MODULE:
    case TYPE_COCLASS:
    case TYPE_FUNCTION:
    case TYPE_INTERFACE:
    case TYPE_BITFIELD:
        return FALSE;
    }
    return FALSE;
}

static int is_ptr_guid_type(const type_t *type)
{
    /* first, make sure it is a pointer to something */
    if (!is_ptr(type)) return FALSE;

    /* second, make sure it is a pointer to something of size sizeof(GUID),
     * i.e. 16 bytes */
    return (type_memsize(type_pointer_get_ref_type(type)) == 16);
}

static void check_conformance_expr_list(const char *attr_name, const var_t *arg, const type_t *container_type, expr_list_t *expr_list)
{
    expr_t *dim;
    struct expr_loc expr_loc;
    expr_loc.v = arg;
    expr_loc.attr = attr_name;
    if (expr_list) LIST_FOR_EACH_ENTRY(dim, expr_list, expr_t, entry)
    {
        if (dim->type != EXPR_VOID)
        {
            const type_t *expr_type = expr_resolve_type(&expr_loc, container_type, dim);
            if (!is_allowed_conf_type(expr_type))
                error_loc_info(&arg->loc_info, "expression must resolve to integral type <= 32bits for attribute %s\n",
                               attr_name);
        }
    }
}

static void check_remoting_fields(const var_t *var, type_t *type);

/* checks that properties common to fields and arguments are consistent */
static void check_field_common(const type_t *container_type,
                               const char *container_name, const var_t *arg)
{
    type_t *type = arg->declspec.type;
    int more_to_do;
    const char *container_type_name;
    const char *var_type;

    switch (type_get_type(container_type))
    {
    case TYPE_STRUCT:
        container_type_name = "struct";
        var_type = "field";
        break;
    case TYPE_UNION:
        container_type_name = "union";
        var_type = "arm";
        break;
    case TYPE_ENCAPSULATED_UNION:
        container_type_name = "encapsulated union";
        var_type = "arm";
        break;
    case TYPE_FUNCTION:
        container_type_name = "function";
        var_type = "parameter";
        break;
    default:
        /* should be no other container types */
        assert(0);
        return;
    }

    if (is_attr(arg->attrs, ATTR_LENGTHIS) &&
        (is_attr(arg->attrs, ATTR_STRING) || is_aliaschain_attr(arg->declspec.type, ATTR_STRING)))
        error_loc_info(&arg->loc_info,
                       "string and length_is specified for argument %s are mutually exclusive attributes\n",
                       arg->name);

    if (is_attr(arg->attrs, ATTR_SIZEIS))
    {
        expr_list_t *size_is_exprs = get_attrp(arg->attrs, ATTR_SIZEIS);
        check_conformance_expr_list("size_is", arg, container_type, size_is_exprs);
    }
    if (is_attr(arg->attrs, ATTR_LENGTHIS))
    {
        expr_list_t *length_is_exprs = get_attrp(arg->attrs, ATTR_LENGTHIS);
        check_conformance_expr_list("length_is", arg, container_type, length_is_exprs);
    }
    if (is_attr(arg->attrs, ATTR_IIDIS))
    {
        struct expr_loc expr_loc;
        expr_t *expr = get_attrp(arg->attrs, ATTR_IIDIS);
        if (expr->type != EXPR_VOID)
        {
            const type_t *expr_type;
            expr_loc.v = arg;
            expr_loc.attr = "iid_is";
            expr_type = expr_resolve_type(&expr_loc, container_type, expr);
            if (!expr_type || !is_ptr_guid_type(expr_type))
                error_loc_info(&arg->loc_info, "expression must resolve to pointer to GUID type for attribute iid_is\n");
        }
    }
    if (is_attr(arg->attrs, ATTR_SWITCHIS))
    {
        struct expr_loc expr_loc;
        expr_t *expr = get_attrp(arg->attrs, ATTR_SWITCHIS);
        if (expr->type != EXPR_VOID)
        {
            const type_t *expr_type;
            expr_loc.v = arg;
            expr_loc.attr = "switch_is";
            expr_type = expr_resolve_type(&expr_loc, container_type, expr);
            if (!expr_type || !is_allowed_conf_type(expr_type))
                error_loc_info(&arg->loc_info, "expression must resolve to integral type <= 32bits for attribute %s\n",
                               expr_loc.attr);
        }
    }

    do
    {
        more_to_do = FALSE;

        switch (typegen_detect_type(type, arg->attrs, TDT_IGNORE_STRINGS))
        {
        case TGT_STRUCT:
        case TGT_UNION:
            check_remoting_fields(arg, type);
            break;
        case TGT_INVALID:
        {
            const char *reason = "is invalid";
            switch (type_get_type(type))
            {
            case TYPE_VOID:
                reason = "cannot derive from void *";
                break;
            case TYPE_FUNCTION:
                reason = "cannot be a function pointer";
                break;
            case TYPE_BITFIELD:
                reason = "cannot be a bit-field";
                break;
            case TYPE_COCLASS:
                reason = "cannot be a class";
                break;
            case TYPE_INTERFACE:
                reason = "cannot be a non-pointer to an interface";
                break;
            case TYPE_MODULE:
                reason = "cannot be a module";
                break;
            default:
                break;
            }
            error_loc_info(&arg->loc_info, "%s \'%s\' of %s \'%s\' %s\n",
                           var_type, arg->name, container_type_name, container_name, reason);
            break;
        }
        case TGT_CTXT_HANDLE:
        case TGT_CTXT_HANDLE_POINTER:
            if (type_get_type(container_type) != TYPE_FUNCTION)
                error_loc_info(&arg->loc_info,
                               "%s \'%s\' of %s \'%s\' cannot be a context handle\n",
                               var_type, arg->name, container_type_name,
                               container_name);
            break;
        case TGT_STRING:
        {
            const type_t *t = type;
            while (is_ptr(t))
                t = type_pointer_get_ref_type(t);
            if (is_aliaschain_attr(t, ATTR_RANGE))
                warning_loc_info(&arg->loc_info, "%s: range not verified for a string of ranged types\n", arg->name);
            break;
        }
        case TGT_POINTER:
            type = type_pointer_get_ref_type(type);
            more_to_do = TRUE;
            break;
        case TGT_ARRAY:
            type = type_array_get_element_type(type);
            more_to_do = TRUE;
            break;
        case TGT_ENUM:
            type = type_get_real_type(type);
            if (!type_is_complete(type))
            {
                error_loc_info(&arg->loc_info, "undefined type declaration \"enum %s\"\n", type->name);
            }
        case TGT_USER_TYPE:
        case TGT_IFACE_POINTER:
        case TGT_BASIC:
        case TGT_RANGE:
            /* nothing to do */
            break;
        }
    } while (more_to_do);
}

static void check_remoting_fields(const var_t *var, type_t *type)
{
    const var_t *field;
    const var_list_t *fields = NULL;

    type = type_get_real_type(type);

    if (type->checked)
        return;

    type->checked = TRUE;

    if (type_get_type(type) == TYPE_STRUCT)
    {
        if (type_is_complete(type))
            fields = type_struct_get_fields(type);
        else
            error_loc_info(&var->loc_info, "undefined type declaration \"struct %s\"\n", type->name);
    }
    else if (type_get_type(type) == TYPE_UNION || type_get_type(type) == TYPE_ENCAPSULATED_UNION)
    {
        if (type_is_complete(type))
            fields = type_union_get_cases(type);
        else
            error_loc_info(&var->loc_info, "undefined type declaration \"union %s\"\n", type->name);
    }

    if (fields) LIST_FOR_EACH_ENTRY( field, fields, const var_t, entry )
        if (field->declspec.type) check_field_common(type, type->name, field);
}

/* checks that arguments for a function make sense for marshalling and unmarshalling */
static void check_remoting_args(const var_t *func)
{
    const char *funcname = func->name;
    const var_t *arg;

    if (!type_function_get_args(func->declspec.type))
        return;

    LIST_FOR_EACH_ENTRY( arg, type_function_get_args(func->declspec.type), const var_t, entry )
    {
        const type_t *type = arg->declspec.type;

        /* check that [out] parameters have enough pointer levels */
        if (is_attr(arg->attrs, ATTR_OUT))
        {
            switch (typegen_detect_type(type, arg->attrs, TDT_ALL_TYPES))
            {
            case TGT_BASIC:
            case TGT_ENUM:
            case TGT_RANGE:
            case TGT_STRUCT:
            case TGT_UNION:
            case TGT_CTXT_HANDLE:
            case TGT_USER_TYPE:
                error_loc_info(&arg->loc_info, "out parameter \'%s\' of function \'%s\' is not a pointer\n", arg->name, funcname);
                break;
            case TGT_IFACE_POINTER:
                error_loc_info(&arg->loc_info, "out interface pointer \'%s\' of function \'%s\' is not a double pointer\n", arg->name, funcname);
                break;
            case TGT_STRING:
                if (is_array(type))
                {
                    /* needs conformance or fixed dimension */
                    if (type_array_has_conformance(type) &&
                        type_array_get_conformance(type)->type != EXPR_VOID) break;
                    if (!type_array_has_conformance(type) && type_array_get_dim(type)) break;
                }
                if (is_attr( arg->attrs, ATTR_IN )) break;
                error_loc_info(&arg->loc_info, "out parameter \'%s\' of function \'%s\' cannot be an unsized string\n", arg->name, funcname);
                break;
            case TGT_INVALID:
                /* already error'd before we get here */
            case TGT_CTXT_HANDLE_POINTER:
            case TGT_POINTER:
            case TGT_ARRAY:
                /* OK */
                break;
            }
        }

        check_field_common(func->declspec.type, funcname, arg);
    }

    if (type_get_type(type_function_get_rettype(func->declspec.type)) != TYPE_VOID)
    {
        var_t var;
        var = *func;
        var.declspec.type = type_function_get_rettype(func->declspec.type);
        var.name = xstrdup("return value");
        check_field_common(func->declspec.type, funcname, &var);
        free(var.name);
    }
}

static void add_explicit_handle_if_necessary(const type_t *iface, var_t *func)
{
    unsigned char explicit_fc, implicit_fc;

    /* check for a defined binding handle */
    if (!get_func_handle_var( iface, func, &explicit_fc, &implicit_fc ) || !explicit_fc)
    {
        /* no explicit handle specified so add
         * "[in] handle_t IDL_handle" as the first parameter to the
         * function */
        var_t *idl_handle = make_var(xstrdup("IDL_handle"));
        idl_handle->attrs = append_attr(NULL, make_attr(ATTR_IN));
        idl_handle->declspec.type = find_type_or_error("handle_t", 0);
        type_function_add_head_arg(func->declspec.type, idl_handle);
    }
}

static void check_functions(const type_t *iface, int is_inside_library)
{
    const statement_t *stmt;
    /* check for duplicates */
    if (is_attr(iface->attrs, ATTR_DISPINTERFACE))
    {
        var_list_t *methods = type_dispiface_get_methods(iface);
        var_t *func, *func_iter;

        if (methods) LIST_FOR_EACH_ENTRY( func, methods, var_t, entry )
        {
            LIST_FOR_EACH_ENTRY( func_iter, methods, var_t, entry )
            {
                if (func == func_iter) break;
                if (strcmp(func->name, func_iter->name)) continue;
                if (is_attr(func->attrs, ATTR_PROPGET) != is_attr(func_iter->attrs, ATTR_PROPGET)) continue;
                if (is_attr(func->attrs, ATTR_PROPPUT) != is_attr(func_iter->attrs, ATTR_PROPPUT)) continue;
                if (is_attr(func->attrs, ATTR_PROPPUTREF) != is_attr(func_iter->attrs, ATTR_PROPPUTREF)) continue;
                error_loc_info(&func->loc_info, "duplicated function \'%s\'\n", func->name);
            }
        }
    }
    if (is_attr(iface->attrs, ATTR_EXPLICIT_HANDLE))
    {
        STATEMENTS_FOR_EACH_FUNC( stmt, type_iface_get_stmts(iface) )
        {
            var_t *func = stmt->u.var;
            add_explicit_handle_if_necessary(iface, func);
        }
    }
    if (!is_inside_library && !is_attr(iface->attrs, ATTR_LOCAL))
    {
        STATEMENTS_FOR_EACH_FUNC( stmt, type_iface_get_stmts(iface) )
        {
            const var_t *func = stmt->u.var;
            if (!is_attr(func->attrs, ATTR_LOCAL))
                check_remoting_args(func);
        }
    }
}

static int async_iface_attrs(attr_list_t *attrs, const attr_t *attr)
{
    switch(attr->type)
    {
    case ATTR_UUID:
        return 0;
    case ATTR_ASYNCUUID:
        append_attr(attrs, make_attrp(ATTR_UUID, attr->u.pval));
        return 0;
    default:
        return 1;
    }
}

static int arg_in_attrs(attr_list_t *attrs, const attr_t *attr)
{
    return attr->type != ATTR_OUT && attr->type != ATTR_RETVAL;
}

static int arg_out_attrs(attr_list_t *attrs, const attr_t *attr)
{
    return attr->type != ATTR_IN;
}

static void check_async_uuid(type_t *iface)
{
    statement_list_t *stmts = NULL;
    statement_t *stmt;
    type_t *async_iface;
    type_t *inherit;

    if (!is_attr(iface->attrs, ATTR_ASYNCUUID)) return;

    inherit = type_iface_get_inherit(iface);
    if (inherit && strcmp(inherit->name, "IUnknown"))
        inherit = type_iface_get_async_iface(inherit);
    if (!inherit)
        error_loc("async_uuid applied to an interface with incompatible parent\n");

    async_iface = get_type(TYPE_INTERFACE, strmake("Async%s", iface->name), iface->namespace, 0);
    async_iface->attrs = map_attrs(iface->attrs, async_iface_attrs);

    STATEMENTS_FOR_EACH_FUNC( stmt, type_iface_get_stmts(iface) )
    {
        var_t *begin_func, *finish_func, *func = stmt->u.var, *arg;
        var_list_t *begin_args = NULL, *finish_args = NULL, *args;

        args = type_function_get_args(func->declspec.type);
        if (args) LIST_FOR_EACH_ENTRY(arg, args, var_t, entry)
        {
            if (is_attr(arg->attrs, ATTR_IN) || !is_attr(arg->attrs, ATTR_OUT))
                begin_args = append_var(begin_args, copy_var(arg, strdup(arg->name), arg_in_attrs));
            if (is_attr(arg->attrs, ATTR_OUT))
                finish_args = append_var(finish_args, copy_var(arg, strdup(arg->name), arg_out_attrs));
        }

        begin_func = copy_var(func, strmake("Begin_%s", func->name), NULL);
        begin_func->declspec.type = type_new_function(begin_args);
        begin_func->declspec.type->attrs = func->attrs;
        begin_func->declspec.type->details.function->retval = func->declspec.type->details.function->retval;
        stmts = append_statement(stmts, make_statement_declaration(begin_func));

        finish_func = copy_var(func, strmake("Finish_%s", func->name), NULL);
        finish_func->declspec.type = type_new_function(finish_args);
        finish_func->declspec.type->attrs = func->attrs;
        finish_func->declspec.type->details.function->retval = func->declspec.type->details.function->retval;
        stmts = append_statement(stmts, make_statement_declaration(finish_func));
    }

    type_interface_define(async_iface, inherit, stmts);
    iface->details.iface->async_iface = async_iface->details.iface->async_iface = async_iface;
}

static void check_statements(const statement_list_t *stmts, int is_inside_library)
{
    const statement_t *stmt;

    if (stmts) LIST_FOR_EACH_ENTRY(stmt, stmts, const statement_t, entry)
    {
        switch(stmt->type) {
        case STMT_LIBRARY:
            check_statements(stmt->u.lib->stmts, TRUE);
            break;
        case STMT_TYPE:
            switch(type_get_type(stmt->u.type)) {
            case TYPE_INTERFACE:
                check_functions(stmt->u.type, is_inside_library);
                break;
            case TYPE_COCLASS:
                if(winrt_mode)
                    error_loc("coclass is not allowed in Windows Runtime mode\n");
                break;
            default:
                break;
            }
            break;
        default:
            break;
        }
    }
}

static void check_all_user_types(const statement_list_t *stmts)
{
  const statement_t *stmt;
  const var_t *v;

  if (stmts) LIST_FOR_EACH_ENTRY(stmt, stmts, const statement_t, entry)
  {
    if (stmt->type == STMT_LIBRARY)
      check_all_user_types(stmt->u.lib->stmts);
    else if (stmt->type == STMT_TYPE && type_get_type(stmt->u.type) == TYPE_INTERFACE &&
             !is_local(stmt->u.type->attrs))
    {
      const statement_t *stmt_func;
      STATEMENTS_FOR_EACH_FUNC(stmt_func, type_iface_get_stmts(stmt->u.type)) {
        const var_t *func = stmt_func->u.var;
        if (type_function_get_args(func->declspec.type))
          LIST_FOR_EACH_ENTRY( v, type_function_get_args(func->declspec.type), const var_t, entry )
            check_for_additional_prototype_types(v->declspec.type);
        check_for_additional_prototype_types(type_function_get_rettype(func->declspec.type));
      }
    }
  }
}

int is_valid_uuid(const char *s)
{
  int i;

  for (i = 0; i < 36; ++i)
    if (i == 8 || i == 13 || i == 18 || i == 23)
    {
      if (s[i] != '-')
        return FALSE;
    }
    else
      if (!isxdigit(s[i]))
        return FALSE;

  return s[i] == '\0';
}

static statement_t *make_statement(enum statement_type type)
{
    statement_t *stmt = xmalloc(sizeof(*stmt));
    stmt->type = type;
    return stmt;
}

static statement_t *make_statement_type_decl(type_t *type)
{
    statement_t *stmt = make_statement(STMT_TYPE);
    stmt->u.type = type;
    stmt->declonly = !type->defined;
    return stmt;
}

static statement_t *make_statement_reference(type_t *type)
{
    statement_t *stmt = make_statement(STMT_TYPEREF);
    stmt->u.type = type;
    return stmt;
}

static statement_t *make_statement_declaration(var_t *var)
{
    statement_t *stmt = make_statement(STMT_DECLARATION);
    stmt->u.var = var;
    if (var->declspec.stgclass == STG_EXTERN && var->eval)
        warning("'%s' initialised and declared extern\n", var->name);
    if (is_const_decl(var))
    {
        if (var->eval)
            reg_const(var);
    }
    else if (type_get_type(var->declspec.type) == TYPE_FUNCTION)
        check_function_attrs(var->name, var->attrs);
    else if (var->declspec.stgclass == STG_NONE || var->declspec.stgclass == STG_REGISTER)
        error_loc("instantiation of data is illegal\n");
    return stmt;
}

static statement_t *make_statement_library(typelib_t *typelib)
{
    statement_t *stmt = make_statement(STMT_LIBRARY);
    stmt->u.lib = typelib;
    return stmt;
}

static statement_t *make_statement_pragma(const char *str)
{
    statement_t *stmt = make_statement(STMT_PRAGMA);
    stmt->u.str = str;
    return stmt;
}

static statement_t *make_statement_cppquote(const char *str)
{
    statement_t *stmt = make_statement(STMT_CPPQUOTE);
    stmt->u.str = str;
    return stmt;
}

static statement_t *make_statement_importlib(const char *str)
{
    statement_t *stmt = make_statement(STMT_IMPORTLIB);
    stmt->u.str = str;
    return stmt;
}

static statement_t *make_statement_import(const char *str)
{
    statement_t *stmt = make_statement(STMT_IMPORT);
    stmt->u.str = str;
    return stmt;
}

static statement_t *make_statement_module(type_t *type)
{
    statement_t *stmt = make_statement(STMT_MODULE);
    stmt->u.type = type;
    return stmt;
}

static statement_t *make_statement_typedef(declarator_list_t *decls, int declonly)
{
    declarator_t *decl, *next;
    statement_t *stmt;
    type_list_t **type_list;

    if (!decls) return NULL;

    stmt = make_statement(STMT_TYPEDEF);
    stmt->u.type_list = NULL;
    type_list = &stmt->u.type_list;
    stmt->declonly = declonly;

    LIST_FOR_EACH_ENTRY_SAFE( decl, next, decls, declarator_t, entry )
    {
        var_t *var = decl->var;
        type_t *type = find_type_or_error(var->name, 0);
        *type_list = xmalloc(sizeof(type_list_t));
        (*type_list)->type = type;
        (*type_list)->next = NULL;

        type_list = &(*type_list)->next;
        free(decl);
        free(var);
    }

    return stmt;
}

static statement_list_t *append_statements(statement_list_t *l1, statement_list_t *l2)
{
    if (!l2) return l1;
    if (!l1 || l1 == l2) return l2;
    list_move_tail (l1, l2);
    return l1;
}

static attr_list_t *append_attribs(attr_list_t *l1, attr_list_t *l2)
{
    if (!l2) return l1;
    if (!l1 || l1 == l2) return l2;
    list_move_tail (l1, l2);
    return l1;
}

static statement_list_t *append_statement(statement_list_t *list, statement_t *stmt)
{
    if (!stmt) return list;
    if (!list)
    {
        list = xmalloc( sizeof(*list) );
        list_init( list );
    }
    list_add_tail( list, &stmt->entry );
    return list;
}

void init_loc_info(loc_info_t *i)
{
    i->input_name = input_name ? input_name : "stdin";
    i->line_number = line_number;
    i->near_text = parser_text;
}

static void check_def(const type_t *t)
{
    if (t->defined)
        error_loc("%s: redefinition error; original definition was at %s:%d\n",
                  t->name, t->loc_info.input_name, t->loc_info.line_number);
}
